2013-03-11  Glenn Morris  <rgm@gnu.org>

	* Merge in all changes up to version 24.3 release.

2013-03-11  Paul Eggert  <eggert@cs.ucla.edu>

	* insdel.c (adjust_after_replace): Use bool for boolean.

2013-03-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keyboard.c: Move keyboard decoding to read_key_sequence.
	(decode_keyboard_code): Remove.
	(tty_read_avail_input): Don't try to decode input.
	(read_decoded_char): New function.
	(read_key_sequence): Use it.

2013-03-10  Daniel Colascione  <dancol@dancol.org>

	* w32term.h (GUISTR, GUI_ENCODE_FILE, GUI_ENCODE_SYSTEM, GUI_FN)
	(GUI_SDATA, guichar_t): Macros to abstract out differences between
	NTGUI_UNICODE and !NTGUI_UNICODE builds, some moved out of
	w32fns.c.

	* w32term.c (construct_drag_n_drop): Use the above macros to make
	drag-and-drop work for non-ASCII filenames in cygw32 builds.

	* w32fns.c (x_set_name, x_set_title): Use the above macros to
	properly display non-ASCII frame titles in cygw32 builds.

	* w32fns.c (Fw32_shell_execute): Use the above macros to properly
	call ShellExecute in cygw32 builds.

	* w32fn.c (Fx_file_dialog): Use the above macros to simplify the
	common file dialog code.

	* w32fns.c (Ffile_system_info): Remove from cygw32 builds, which
	can just use du like other systems.

	* coding.c (from_unicode_buffer): Declare.
	* coding.c (from_unicode_buffer): Implement.

2013-03-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lread.c: Minor cleanup.
	(FROM_FILE_P): New macro.
	(skip_dyn_bytes, unreadchar, read1): Use it.
	(read_list): Consolidate duplicated code.

	* bytecode.c (struct byte_stack): Remove `constants' when unused.

2013-03-10  Eli Zaretskii  <eliz@gnu.org>

	* xdisp.c (display_tool_bar_line, redisplay_tool_bar)
	(redisplay_internal, set_cursor_from_row, try_window)
	(try_window_id, dump_glyph_row, extend_face_to_end_of_line)
	(display_line, notice_overwritten_cursor)
	(mouse_face_from_buffer_pos, note_mouse_highlight):
	Use MATRIX_ROW_DISPLAYS_TEXT_P.
	(note_mouse_highlight): Use MATRIX_ROW_GLYPH_START.
	(mouse_face_from_string_pos, fast_find_string_pos):
	Use MATRIX_ROW_VPOS.

	* xfns.c (Fx_show_tip): Use MATRIX_ROW_DISPLAYS_TEXT_P.

	* w32fns.c (Fx_show_tip): Use MATRIX_ROW_DISPLAYS_TEXT_P.

	* xdisp.c (try_cursor_movement): Use MATRIX_ROW and
	MATRIX_MODE_LINE_ROW.

	* dispnew.c (update_window): Use MATRIX_ROW and MATRIX_MODE_LINE_ROW.

2013-03-10  Kenichi Handa  <handa@gnu.org>

	* lisp.h (adjust_after_replace): Extern it.

	* coding.c (detect_coding): Cound the heading ASCII bytes in the
	case of detection for coding_category_utf_8_auto.
	(decode_coding_gap) [not CODING_DISABLE_ASCII_OPTIMIZATION]:
	Skip decoding if all bytes are ASCII.

	* insdel.c (adjust_after_replace): Make it public.  New arg
	text_at_gap_tail.
	(adjust_after_insert): Call adjust_after_replace with the new arg
	value 0.

2013-03-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keyboard.h (EVENT_START, EVENT_END, POSN_WINDOW, POSN_POSN)
	(POSN_WINDOW_POSN, POSN_TIMESTAMP): Be careful since events may come
	from Elisp via unread-command-events.

	* keyboard.c (access_keymap_keyremap): Accept nil return value from
	functions to mean "no change".

2013-03-08  Paul Eggert  <eggert@cs.ucla.edu>

	region-cache.c, scroll.c, search.c: Use bool for booleans.
	* lisp.h (compile_pattern):
	* scroll.c (do_scrolling, do_direct_scrolling):
	* search.c (struct regexp_cache, compile_pattern_1)
	(compile_pattern, string_match_1, search_command)
	(trivial_regexp_p, search_buffer, Freplace_match, match_limit)
	(search_regs_saved, Fregexp_quote):
	Use bool for boolean.
	* region-cache.c (region_cache_forward, region_cache_backward):
	Fix comments to match code: these functions return int, not boolean.

2013-03-08  Dmitry Antipov  <dmantipov@yandex.ru>

	* search.c (find_newline): Accept start and end byte positions
	as arguments and allow -1 if not known.
	(find_newline_no_quit): Likewise for start position.
	* lisp.h (find_newline, find_newline_no_quit): Adjust prototype.
	* bidi.c (bidi_find_paragraph_start): Pass byte position to
	find_newline_no_quit, thus eliminating CHAR_TO_BYTE.
	* editfns.c (Fconstrain_to_field): Break long line.
	Adjust call to find_newline.
	* indent.c (vmotion): Adjust calls to find_newline_no_quit.
	Use DEC_BOTH to start next search from the previous buffer
	position, where appropriate.
	* xdisp.c (back_to_previous_line_start, forward_to_next_line_start)
	(get_visually_first_element, move_it_vertically_backward): Likewise.
	Obtain byte position from the display iterator, where appropriate.

2013-03-08  Paul Eggert  <eggert@cs.ucla.edu>

	print.c, process.c: Use bool for booleans.
	* lisp.h (wait_reading_process_output):
	* print.c (print_output_debug_flag, PRINTDECLARE, printchar)
	(strout, debug_output_compilation_hack, float_to_string, print)
	(print_object):
	* process.c (kbd_is_on_hold, inhibit_sentinels, process_output_skip)
	(decode_status, status_message, create_process, create_pty)
	(Fmake_network_process, Fnetwork_interface_info)
	(wait_reading_process_output, read_process_output)
	(write_queue_push, write_queue_pop, process_send_signal)
	(handle_child_signal, keyboard_bit_set, kbd_on_hold_p):
	* process.h (struct Lisp_Process, inhibit_sentinels, kbd_on_hold_p):
	Use bool for booleans.
	* process.c (Fnetwork_interface_list): Remove unused local.
	(connect_counter): Now EMACS_INT, not int.

2013-03-08  Dmitry Antipov  <dmantipov@yandex.ru>

	* bidi.c (bidi_fetch_char): Swap first and second arguments
	to match other functions accepting character and byte positions.
	Adjust comment.
	(bidi_resolve_explicit_1, bidi_level_of_next_char): Adjust users.
	(bidi_paragraph_init): Likewise.  Use DEC_BOTH which is faster
	when you need just to move to the previous buffer position.
	* xdisp.c (Fcurrent_bidi_paragraph_direction): Use DEC_BOTH.

2013-03-07  Eli Zaretskii  <eliz@gnu.org>

	* .gdbinit (prowlims): Display the enabled_p flag of the row.

2013-03-07  Dmitry Antipov  <dmantipov@yandex.ru>

	Avoid character to byte conversions in motion subroutines.
	* indent.h (compute_motion, vmotion): Add byte position argument.
	* indent.c (compute_motion): Use it and avoid CHAR_TO_BYTE.
	Add eassert.
	(Fcompute_motion): Break long line.  Adjust call to compute_motion.
	Use list5 for return value.
	(vmotion): Use byte position argument and avoid call to CHAR_TO_BYTE.
	Adjust comments, style and calls to compute_motion.
	(Fvertical_motion): Adjust call to vmotion.
	* window.c (Fdelete_other_windows_internal): Record window start
	byte position and adjust call to vmotion.
	(window_scroll_line_based): Likewise with call to compute_motion.
	Use SET_PT_BOTH.
	(Frecenter): Adjust calls to vmotion.

2013-03-07  Dmitry Antipov  <dmantipov@yandex.ru>

	* lisp.h (list2i, list3i): New functions.
	(list4i): Move from window.c and make LISP_INLINE.
	* editfns.c (make_lisp_time):
	* fns.c (Flocale_info):
	* keyboard.c (parse_modifiers):
	* xterm.c (x_ewmh_activate_frame): Use list2i.
	* instel.c (signal_after_change):
	* nsfns.m (Fx_server_version, Fxw_color_values):
	* w32fns.c (Fxw_color_values, Fx_server_version):
	* xfns.c (Fxw_color_values, Fx_server_version): Use list3i.
	* fileio.c (Fvisited_file_modtime):
	* nsfns.m (Fns_display_usable_bounds):
	* w32.c (ltime): Use list4i.

2013-03-06  Eli Zaretskii  <eliz@gnu.org>

	* search.c (find_newline_no_quit): Rename from find_next_newline.
	Add commentary.

	* lisp.h (find_newline_no_quit): Rename prototype.

	* xdisp.c (back_to_previous_line_start)
	(forward_to_next_line_start, get_visually_first_element)
	(move_it_vertically_backward): Callers of find_newline_no_quit changed.
	* indent.c (vmotion): Callers of find_newline_no_quit changed.
	* bidi.c (bidi_find_paragraph_start): Callers of
	find_newline_no_quit changed.

	* msdos.c: Change encoding to cp850.  (Bug#13879)
	(fr_keyboard, it_keyboard, dk_keyboard): Update keyboard layouts.

2013-03-06  Dmitry Antipov  <dmantipov@yandex.ru>

	Coding system support cleanup and minor refactoring.
	* coding.h (enum coding_result_code): Remove
	CODING_RESULT_INCONSISTENT_EOL and CODING_RESULT_INSUFFICIENT_MEM.
	(toplevel): Remove unused CODING_MODE_INHIBIT_INCONSISTENT_EOL.
	(CODING_MODE_LAST_BLOCK, CODING_MODE_SELECTIVE_DISPLAY)
	(CODING_MODE_DIRECTION, CODING_MODE_FIXED_DESTINATION)
	(CODING_MODE_SAFE_ENCODING): Rearrange bit values.
	(decode_coding_region, encode_coding_region, decode_coding_string):
	Remove unused compatibility macros.
	* coding.c (Qinconsistent_eol, Qinsufficient_memory): Remove.
	(record_conversion_result): Adjust user.
	(syms_of_coding): Likewise.
	(ALLOC_CONVERSION_WORK_AREA): Use SAFE_ALLOCA.
	(decode_coding, encode_coding): Add USE_SAFE_ALLOCA and SAFE_FREE.
	(decode_coding_object): Simplify since xrealloc never returns NULL.
	Add eassert.

2013-03-06  Paul Eggert  <eggert@cs.ucla.edu>

	Fix a build failure on OpenBSD 4.x and MirBSD (Bug#13881).
	* sysdep.c (list_system_processes)
	[BSD_SYSTEM && !DARWIN_OS && !__FreeBSD__]:
	Make it a stub in this case; otherwise the build might fail,
	and this code hasn't been tested on such hosts anyway.
	Problem reported by Nelson H. F. Beebe in
	<http://lists.gnu.org/archive/html/emacs-devel/2013-03/msg00021.html>
	and analyzed by Jérémie Courrèges-Anglas in
	<http://lists.gnu.org/archive/html/emacs-devel/2013-03/msg00062.html>.

2013-03-06  Dmitry Antipov  <dmantipov@yandex.ru>

	* lisp.h (find_next_newline_no_quit): Rename to find_next_newline.
	* xdisp.c (back_to_previous_line_start, forward_to_next_line_start)
	(get_visually_first_element, move_it_vertically_backward): Ajust users.
	* bidi.c (bidi_find_paragraph_start): Likewise.
	* indent.c (vmotion): Likewise.

2013-03-05  Paul Eggert  <eggert@cs.ucla.edu>

	FILE's lock is now always .#FILE and may be a regular file (Bug#13807).
	* filelock.c: Include <c-ctype.h>.
	(MAX_LFINFO): New top-level constant.
	(lock_info_type): Remove members pid, boot_time.  Add members at,
	dot, colon.  Change user member to be the entire buffer, not a
	pointer.  This allows us to handle the case where a foreign
	pid or boot time exceeds the local range.  All uses changed.
	(LINKS_MIGHT_NOT_WORK): New constant.
	(FREE_LOCK_INFO): Remove, as the pieces no longer need freeing.
	(defined_WINDOWSNT): Remove.
	(MAKE_LOCK_NAME, file_in_lock_file_name):
	Always use .#FILE (not .#-FILE) for the file lock,
	even if it is a regular file.
	(rename_lock_file): New function.
	(create_lock_file): Use it.
	(create_lock_file, read_lock_data):
	Prefer a symbolic link for the lock file, falling back on a
	regular file if symlinks don't work.  Do not try to create
	symlinks on MS-Windows, due to security hassles.  Stick with
	POSIXish functions (open, read, write, close, fchmod, readlink, symlink,
	link, rename, unlink, mkstemp) when creating locks, as a GNUish
	host may be using a Windowsish file system, and cannot use
	MS-Windows-only system calls.  Fall back on mktemp if mkstemp
	doesn't work.  Don't fail merely because of a symlink-contents
	length limit in the current file system; fall back on regular
	files.  Increase the symlink contents length limit to 8 KiB, this
	should be big enough for any real use and doesn't crunch the
	stack.
	(create_lock_file, lock_file_1, read_lock_data):
	Simplify allocation of lock file buffers now that they fit in 8 KiB.
	(lock_file_1): Return error number, not bool.  All callers changed.
	(ELOOP): New macro, if not already defined.
	(read_lock_data): Return size of lock file contents, not Lisp object.
	All callers changed.  Handle a race condition if some other process
	replaces a regular-file lock with a symlink lock or vice versa,
	while we're trying to read the lock.
	(current_lock_owner): Parse contents more carefully, to help avoid
	confusing a regular-file lock with some other application's use
	of the file.  Check for lock file contents being too long, or
	not parsing correctly.
	(current_lock_owner, lock_file):
	Allow foreign pid and boot times that exceed the local range.
	(current_lock_owner, lock_if_free, lock_file):
	Simplify allocation of lock file contents.
	* w32.c (sys_rename_replace): New function, containing most of
	the contents of the old sys_rename.
	(sys_rename): Use it.
	(fchmod): New dummy function.
	* w32.h (sys_rename_replace, fchmod): New decls.

2013-03-05  Eli Zaretskii  <eliz@gnu.org>

	* bidi.c (bidi_resolve_explicit_1): Don't call CHAR_TO_BYTE or
	bidi_count_bytes, as the callers now arrange for bidi_it->charpos
	to be in sync with bidi_it->bytepos.  Suggested by Dmitry Antipov
	<dmantipov@yandex.ru>.

2013-03-05  Dmitry Antipov  <dmantipov@yandex.ru>

	* composite.c (get_composition_id, fill_gstring_header):
	Use make_uninit_vector where appropriate.
	* font.c (Ffont_get_glyphs, build_style_table): Likewise.
	* xselect.c (clean_local_selection_data): Likewise.

2013-03-04  Paul Eggert  <eggert@cs.ucla.edu>

	Fix misuse of ImageMagick that caused core dump (Bug#13846).
	* image.c (imagemagick_load_image): Calculate height and width
	after flattening the image, not before.

2013-03-04  Dmitry Antipov  <dmantipov@yandex.ru>

	* font.c (Ffont_get_glyphs): Use convenient LGLYPH_NEW.
	* ftfont.c (ftfont_shape_by_flt): Likewise.
	* w32uniscribe.c (uniscribe_shape): Likewise.

2013-03-02  Paul Eggert  <eggert@cs.ucla.edu>

	The lock for FILE is now .#FILE or .#-FILE (Bug#13807).
	The old approach, which fell back on DIR/.#FILE.0 through
	DIR/.#FILE.9, had race conditions that could not be easily fixed.
	If DIR/.#FILE is a non-symlink file, Emacs now does not create a
	lock file for DIR/FILE; that is, DIR/FILE is no longer partly
	protected by a lock if DIR/.#FILE is a non-symlink file ("partly"
	because the locking mechanism was never reliable in that case).
	This patch fixes this and other bugs discovered by a code
	inspection that was prompted by
	<http://lists.gnu.org/archive/html/emacs-devel/2013-02/msg00531.html>.
	Also, this patch switches to .#-FILE (not .#FILE) on MS-Windows,
	to avoid interoperability problems between the MS-Windows and
	non-MS-Windows implementations.  MS-Windows and non-MS-Windows
	instances of Emacs now ignore each others' locks.
	* filelock.c (defined_WINDOWSNT): New constant.
	(MAKE_LOCK_NAME, fill_in_lock_file_name):
	Don't create DIR/.#FILE.0 through DIR/.#FILE.9.  Instead, create
	DIR/.#FILE symlinks on non-MS-Windows hosts, and DIR/.#-FILE
	regular files on MS-Windows hosts.
	(MAKE_LOCK_NAME, unlock_file, Ffile_locked_p):
	Use SAFE_ALLOCA to avoid problems with long file names.
	(MAX_LFINFO): Now a local constant, not a global macro.
	(IS_LOCK_FILE): Remove.
	(lock_file_1): Don't inspect errno if symlink call succeeds;
	that's not portable.
	(lock_file): Document that this function can return if lock
	creation fails.
	(lock_file): Don't access freed storage.

2013-03-02  Andreas Schwab  <schwab@linux-m68k.org>

	* lisp.h (XPNTR) [!USE_LSB_TAG]: Remove extra paren.  (Bug#13734)

2013-03-02  Paul Eggert  <eggert@cs.ucla.edu>

	* textprop.c: Use bool for booleans.
	(validate_interval_range, Fadd_text_properties)
	(Fremove_text_properties): Prefer bool to int when either works.

2013-03-02  Eli Zaretskii  <eliz@gnu.org>

	* textprop.c (Fadd_text_properties, Fremove_text_properties):
	If the interval tree changes as a side effect of calling
	modify_region, re-do processing starting from the call to
	validate_interval_range.  (Bug#13743)

2013-02-28  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (sys_open): Don't reset the flags for FD in fd_info[].
	(Bug#13546).

2013-02-27  Eli Zaretskii  <eliz@gnu.org>

	* filelock.c (create_lock_file) [WINDOWSNT]: Use _sopen with
	_SH_DENYRW flag, instead of emacs_open, to deny any other process
	access to the lock file until it is written and closed.
	(Bug#13807)

2013-02-27  Paul Eggert  <eggert@cs.ucla.edu>

	* callint.c (Qcall_interactively):
	* macros.c (Qexecute_kbd_macro):
	Now static.

2013-02-26  Bastien Guerry  <bzg@gnu.org>

	* window.c (Frecenter): Tiny docstring enhancement.

2013-02-26  Paul Eggert  <eggert@cs.ucla.edu>

	Minor textprop integer cleanup.
	* intervals.h, textprop.c (add_text_properties_from_list):
	Return void, not int, since nobody uses the return value.
	* textprop.c (validate_plist, add_properties, remove_properties)
	(Fadd_text_properties):
	Don't assume list length fits in int.
	(interval_has_all_properties, interval_has_some_properties)
	(interval_has_some_properties_list, add_properties, remove_properties)
	(Fadd_text_properties, Fremove_text_properties)
	(Fremove_list_of_text_properties, text_property_stickiness):
	Use bool for booleans.
	(Fadd_text_properties, Fremove_text_properties):
	(Fremove_list_of_text_properties):
	Reindent do-while as per GNU style.

2013-02-25  Eli Zaretskii  <eliz@gnu.org>

	Implement CLASH_DETECTION for MS-Windows.

	* filelock.c [WINDOWSNT]: Include w32.h.
	(MAKE_LOCK_NAME): Don't use 'lock', it clashes with MS runtime
	function of that name.  Up-case the macro arguments.
	(IS_LOCK_FILE): New macro.
	(fill_in_lock_file_name): Use IS_LOCK_FILE instead of S_ISLNK.
	(create_lock_file): New function, with body extracted from
	lock_file_1.
	[WINDOWSNT]: Implement lock files by writing a regular file with
	the lock information as its contents.
	(read_lock_data): New function, on Posix platforms just calls
	emacs_readlinkat.
	[WINDOWSNT]: Read the lock info from the file.
	(current_lock_owner): Call read_lock_data instead of calling
	emacs_readlinkat directly.
	(lock_file) [WINDOWSNT]: Run the file name through
	dostounix_filename.

	* w32proc.c (sys_kill): Support the case of SIG = 0, in which case
	just check if the process by that PID exists.

	* w32.c (sys_open): Don't reset the _O_CREAT flag if _O_EXCL is
	also present, as doing so will fail to error out if the file
	already exists.

	* makefile.w32-in ($(BLD)/filelock.$(O)): Depend on src/w32.h.

	* textprop.c (Fadd_text_properties, Fremove_text_properties)
	(Fremove_list_of_text_properties): Skip all of the intervals in
	the region between START and END that already have resp. don't
	have the requested properties, not just the first one.
	Add assertions that the loop afterwards always modifies the
	properties.  (Bug#13743)

2013-02-25  Stefan Monnier  <monnier@iro.umontreal.ca>

	* callint.c (Fcall_interactively): Use the right lexical environment
	for `interactive' specs (bug#13811).
	* eval.c (Feval): Accept a lexical environment.

2013-02-25  Paul Eggert  <eggert@cs.ucla.edu>

	Simplify data_start configuration (Bug#13783).
	This is a followon simplification to the fix for Bug#13650.
	* Makefile.in (LD_FIRSTFLAG, LIB_GCC, CRT_DIR, LIB_STANDARD)
	(START_FILES): Remove.  All uses removed.
	(otherobj): Remove $(VMLIMIT_OBJ), as it's now first.
	(ALLOBJS): Move here from autodeps.mk, and with VMLIMITS_OBJ first.
	(buildobj.h): Use it.
	($(ALLOBJS)): Depend on globals.h.
	(temacs$(EXEEXT)): Use $(ALLOBJS).
	* autodeps.mk (ALLOBJS): Move to Makefile.in.
	* deps.mk (vm-limit.o):
	* makefile.w32-in ($(BLD)/vm-limit.$(O)):
	Do not depend on mem-limits.h.
	* emacs.c (__do_global_ctors, __do_global_ctors_aux)
	(__do_global_dtors, __CTOR_LIST__, __DTOR_LIST__)
	[__GNUC__ && !ORDINARY_LINK]: Remove.
	* mem-limits.h, pre-crt0.c: Remove.
	* unexaix.c, unexcoff.c: Don't include mem-limits.h.
	* unexcoff.c (etext): New decl.
	(make_hdr): Use DATA_START instead of start_of_data.
	* vm-limit.c: Move most of mem-limits.h's contents here.
	(data_start): New decl.  It's OK if this is approximate,
	so simplify-away some unnecessary exactness.
	(POINTER): Remove; all uses removed.
	(data_space_start): Now char *, to avoid casts.
	(exceeds_lisp_ptr): New function, replacing the old
	EXCEEDS_LISP_PTR macro.  All uses changed.
	(check_memory_limits): Simplify and remove casts.
	(start_of_data) [!CANNOT_DUMP || !SYSTEM_MALLOC]: Remove.
	(memory_warnings): Use data_start instead of start_of_data.

2013-02-24  Andreas Schwab  <schwab@linux-m68k.org>

	* xdisp.c (set_message): Only check for debug-on-message if STRING
	is a string.  (Bug#13797)

2013-02-24  Paul Eggert  <eggert@cs.ucla.edu>

	Fix regression introduced by July 10 filelock.c patch.
	* filelock.c (fill_in_lock_file_name): Fix crash caused by the
	2012-07-10 patch to this file.  Reported by Eli Zaretskii in
	<http://lists.gnu.org/archive/html/emacs-devel/2013-02/msg00533.html>
	and diagnosed by Andreas Schwab in
	<http://lists.gnu.org/archive/html/emacs-devel/2013-02/msg00534.html>.

2013-02-22  Paul Eggert  <eggert@cs.ucla.edu>

	Assume C89 or better.
	* ralloc.c (SIZE, POINTER, NIL):
	* vm-limit.c (POINTER):
	Remove, replacing all uses with C89 equivalents.  These old
	symbols were present only for porting to pre-C89 platforms.

2013-02-22  Claudio Bley  <claudio.bley@gmail.com>

	* w32.c (emacs_gnutls_pull): Don't call 'select', and don't loop.
	This avoids warning messages reported as part of Bug#13546.

2013-02-21  Ken Brown  <kbrown@cornell.edu>

	* sheap.c (report_sheap_usage): Fix arguments of message1_no_log.

2013-02-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* sheap.c (report_sheap_usage): Prefer message1_nolog.

	* keyboard.c (Qcommand_execute): New var.
	(command_loop_1, read_char): Use it.
	(Fcommand_execute): Remove, replace by an Elisp implementation.
	(syms_of_keyboard): Adjust accordingly.

2013-02-19  Daniel Colascione  <dancol@dancol.org>

	* sheap.c (report_sheap_usage): Use message, not message1, so
	that we don't try to create a buffer while we're in the middle
	of dumping Emacs.  Explain why.

2013-02-20  Dmitry Antipov  <dmantipov@yandex.ru>

	* search.c (find_newline): Return byte position in bytepos.
	Adjust comment.
	(find_next_newline_no_quit, find_before_next_newline):
	Add bytepos argument.
	* lisp.h (find_newline, find_next_newline_no_quit)
	(find_before_next_newline): Adjust prototypes.
	* bidi.c (bidi_find_paragraph_start):
	* editfns.c (Fconstrain_to_field, Fline_end_position):
	* indent.c (compute_motion, vmotion):
	* xdisp.c (back_to_previous_line_start, forward_to_next_line_start):
	(get_visually_first_element, move_it_vertically_backward):
	Adjust users and avoid calls to CHAR_TO_BYTE where appropriate.

2013-02-19  Eli Zaretskii  <eliz@gnu.org>

	* w32proc.c (new_child): Avoid leaking handles if the subprocess
	resources were not orderly released.

2013-02-17  Eli Zaretskii  <eliz@gnu.org>

	* xdisp.c (x_draw_vertical_border): For a window that is neither
	the leftmost nor the rightmost, redraw both the left and the right
	vertical borders.  (Bug#13723)

2013-02-17  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xml.c (init_libxml2_functions):
	* sound.c (sound_warning):
	* sheap.c (report_sheap_usage):
	* process.c (wait_reading_process_output):
	* msdos.c (XMenuActivate):
	* macros.c (Fstart_kbd_macro, Fend_kbd_macro):
	* keyboard.c (top_level_1):
	* editfns.c (Fmessage, Fmessage_box):
	* callint.c (Fcall_interactively):
	* fns.c (Fyes_or_no_p): Prefer `message1' over `message'.

2013-02-17  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.c (syms_of_xterm): Move scroll-bar-adjust-thumb-portion ...
	* frame.c (syms_of_frame): ... to here.

2013-02-16  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (sys_chown): Remove unused function.

	* w32term.c <input_signal_count>: Declare 'volatile'
	unconditionally.  (Bug#9066)

	* w32.c (set_errno): Reset h_errno and don't set it to any other
	value.  Set errno instead.
	(check_errno): Reset h_errno.
	(sys_socket, socket_to_fd, sys_bind, sys_connect)
	(sys_gethostname, sys_getservbyname, sys_getpeername)
	(sys_shutdown, sys_setsockopt, sys_listen, sys_getsockname)
	(sys_accept, sys_recvfrom, sys_sendto, fcntl, sys_read): Don't set
	h_errno.
	(sys_gethostbyname): Set h_errno only errors detected.

2013-02-15  Paul Eggert  <eggert@cs.ucla.edu>

	* process.c (h_errno) [!HAVE_H_ERRNO]: Remove unused decl.

2013-02-15  Eli Zaretskii  <eliz@gnu.org>

	* keyboard.c (read_char): Fix calculation of auto-save time out
	when auto-save-timeout is less than 4.  (Bug#13720)

	* w32proc.c (new_child): Free up to 2 slots of dead processes at a
	time.  Improve diagnostics in DebPrint.  (Bug#13546)

	* w32.c (sys_socket, sys_bind, sys_connect, sys_gethostname)
	(sys_gethostbyname, sys_getservbyname, sys_getpeername)
	(sys_shutdown, sys_setsockopt, sys_listen, sys_getsockname)
	(sys_accept, sys_recvfrom, sys_sendto, fcntl): In case of failure,
	make sure errno is set to an appropriate value.  (Bug#13546)
	(socket_to_fd): Add assertion against indexing fd_info[] with a
	value that is out of bounds.
	(sys_accept): If fd is negative, do not set up the child_process
	structure for reading.

2013-02-15  Dmitry Antipov  <dmantipov@yandex.ru>

	* composite.c (fill_gstring_header): Remove useless prototype.
	Break long line.
	* lisp.h (message_dolog, compile_pattern): Adjust prototype.
	* print.c (PRINTDECLARE, print_object):
	* search.c (compile_pattern, fast_looking_at, search_buffer):
	(simple_search, boyer_moore, Freplace_match):
	* xdisp.c (c_string_pos, number_of_chars, message_dolog):
	(get_overlay_arrow_glyph_row, display_mode_element):
	(decode_mode_spec_coding, message3):
	* xfaces.c (face_at_string_position): Use bool for booleans.
	Adjust comments.

2013-02-15  Paul Eggert  <eggert@cs.ucla.edu>

	Fix AIX port (Bug#13650).
	* lisp.h (XPNTR) [!USE_LSB_TAG && DATA_SEG_BITS]:
	Fix bug introduced in 2012-07-27 change.  DATA_SEG_BITS, if set,
	was #undeffed earlier, so it cannot be used as a macro here.
	Use the constant and not the macro.

2013-02-15  Eli Zaretskii  <eliz@gnu.org>

	* w32proc.c (new_child): If no vacant slots are found in
	child_procs[], make another pass looking for slots whose process
	has exited or died.  (Bug#13546)

	* w32.c (sys_pipe): When failing due to file descriptors above
	MAXDESC, set errno to EMFILE.
	(_sys_read_ahead): Update cp->status when failing to read serial
	communications input, so that the status doesn't stay at
	STATUS_READ_IN_PROGRESS.  (Bug#13546)

2013-02-14  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (tb_size_cb): New function.
	(xg_create_tool_bar): Connect size-allocate to tb_size_cb (Bug#13512).

2013-02-14  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keyboard.c (active_maps): Fcurrent_active_maps expects a position, not
	an event.

2013-02-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keyboard.c (syms_of_keyboard): Further tweaks of docstring.

2013-02-13  Dmitry Antipov  <dmantipov@yandex.ru>

	* font.c (font_range): Add pos_byte argument.  Adjust comment
	and break long line.
	* font.h (font_range): Adjust prototype.
	* composite.c (autocmp_chars): Pass byte position to font_range.
	Break long line.  Remove useless prototype and format comment.

2013-02-13  Glenn Morris  <rgm@gnu.org>

	* keyboard.c (input-decode-map, key-translation-map): Doc fixes.

2013-02-13  Paul Eggert  <eggert@cs.ucla.edu>

	Improve AIX port some more (Bug#13650).
	With this, it should be as good as it was in 23.3, though it's
	still pretty bad: the dumped emacs does not run.  See Mark Fleishman in
	http://lists.gnu.org/archive/html/help-gnu-emacs/2011-04/msg00287.html
	* unexaix.c (start_of_text): Remove.
	(_data, _text): Declare as char[], not int, as AIX manual suggests.
	(bias, lnnoptr, text_scnptr, data_scnptr, load_scnptr)
	(orig_load_scnptr, orig_data_scnptr):
	Now off_t, not long, since they are file offsets.
	(make_hdr): Use _data, not start_of_data ().
	This is the key part of the fix.
	(make_hdr, unrelocate_symbols): Use off_t for file offsets.
	(unrelocate_symbols): Cast pointers to intptr_t, not to ulong.

	* pre-crt0.c (data_start): Initialize to 1.
	This ports to compilers that optimize the external declaration
	'int x = 0;' as if it were 'int x;' to shrink the executable.

	Improve AIX port (Bug#13650).
	This doesn't fix the bug, but it makes progress: Emacs builds now.
	* unexaix.c: Include inttypes.h, stdarg.h.
	(report_error, report_error_1): Mark as _Noreturn.
	(report_error): Don't report the wrong errno.
	(report_error_1): Now varargs.  All callers changed.
	(make_hdr): Use uintptr_t, not unsigned, when converting pointers
	to unsigned.  Don't use ADDR_CORRECT, as it no longer exists.
	(write_ptr): Use %p to print address rather than %lx and a cast
	to unsigned long.  Grow buffer a bit, to be safer.

2013-02-13  Eli Zaretskii  <eliz@gnu.org>

	* bidi.c (bidi_resolve_neutral): After finding the next
	non-neutral character, accept NEUTRAL_ON type as well, because
	directional control characters, such as LRE and RLE, have their
	type converted to that by bidi_resolve_weak.  This avoids aborts
	when LRE/RLE follows a run of neutrals.
	(bidi_move_to_visually_next): Assert that return value of
	bidi_peek_at_next_level is non-negative.  Negative values will
	cause an infloop.

2013-02-13  Paul Eggert  <eggert@cs.ucla.edu>

	Minor getenv-related fixes.
	* callproc.c (Fcall_process_region) [!DOS_NT]:
	Avoid unnecessary duplicate call to getenv.
	* callproc.c (init_callproc):
	* dispnew.c (init_display):
	* sysdep.c (sys_subshell):
	Omit unnecessary cast of getenv or egetenv.

2013-02-13  Juanma Barranquero  <lekktu@gmail.com>

	* makefile.w32-in ($(BLD)/filelock.$(O), $(BLD)/sysdep.$(O)):
	Update dependencies.

2013-02-12  Eli Zaretskii  <eliz@gnu.org>

	* xdisp.c (redisplay_internal): Don't set w->region_showing to the
	marker's position.
	(display_line): Set w->region_showing to the value of
	it->region_beg_charpos, not to -1.  This fixes redisplay
	optimization when cursor is moved up after M->.  (Bug#13623)
	(Bug#13626)
	(try_scrolling): Scroll text up more if point is too close to ZV
	and inside the scroll margin.  This makes sure point is moved
	outside the scroll margin in these cases.

	* window.h (struct window): region_showing can no longer be
	negative.

2013-02-11  Paul Eggert  <eggert@cs.ucla.edu>

	Tune by using memchr and memrchr.
	* doc.c (Fsnarf_documentation):
	* fileio.c (Fsubstitute_in_file_name):
	* search.c (find_newline, scan_newline):
	* xdisp.c (pos_visible_p, display_count_lines):
	Use memchr and memrchr rather than scanning byte-by-byte.
	* search.c (find_newline): Rename from scan_buffer.
	Omit first arg TARGET, as it's always '\n'.  All callers changed.

	Clean up read_key_sequence a tiny bit more.
	* keyboard.c (read_char_x_menu_prompt) [HAVE_MENUS]:
	(read_key_sequence): Remove unused locals.

2013-02-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	Clean up read_key_sequence a bit; reread active keymaps after first event.
	* keyboard.c (read_char, read_char_x_menu_prompt)
	(read_char_minibuf_menu_prompt):
	Replace nmaps+maps with a single `map' arg.
	(follow_key): Operate on a single map.
	(active_maps): New function.
	(test_undefined): Also return true for nil bindings.
	(read_key_sequence): Use active_maps to replace the arrays of keymaps with
	a single (composed) keymap.  Remember `first_event' to choose the right
	set of active keymaps.  Recompute the set of keymaps after receiving
	the first event.  Remove GOBBLE_FIRST_EVENT.
	(syms_of_keyboard): Remove inhibit_local_menu_bar_menus.
	* keyboard.h (read_char): Update declaration.
	* lread.c (read_filtered_event): Adjust call to read_char.

2013-02-11  Eli Zaretskii  <eliz@gnu.org>

	* xdisp.c (move_it_vertically_backward, move_it_by_lines):
	Don't use the limitation on backwards movement when lines are truncated
	in the window.  (Bug#13675)

2013-02-11  Dmitry Antipov  <dmantipov@yandex.ru>

	* marker.c (set_marker_internal): If desired position is passed
	as a marker, avoid call to buf_charpos_to_bytepos.
	* window.c (Fset_window_point): Omit redundant type checking.
	(Fset_window_start): Likewise.  Format comment.
	(window_scroll_pixel_based): Use set_marker_restricted_both
	with character and byte positions obtained from an iterator.
	(Fset_window_configuration): Use set_marker_restricted_both.
	* xdisp.c (message_dolog): Likewise.

2013-02-10  Eli Zaretskii  <eliz@gnu.org>

	* xdisp.c (move_it_vertically_backward, move_it_by_lines):
	When text lines are longer than window's screen lines, don't move back
	too far.  This speeds up some redisplay operations.  (Bug#13675)

2013-02-10  Dmitry Antipov  <dmantipov@yandex.ru>

	* syntax.c (scan_sexps_forward): Fix byte position calculation
	Bug#13664 (a.k.a Bug#13667) introduced with 2013-02-08 change.

2013-02-10  Paul Eggert  <eggert@cs.ucla.edu>

	* fileio.c (Fexpand_file_name): Omit confusing pointer comparison
	that was not needed.

2013-02-09  Paul Eggert  <eggert@cs.ucla.edu>

	Minor hashing refactoring.
	* fns.c (SXHASH_REDUCE): Move to lisp.h.
	(sxhash_float): Return EMACS_UINT, for consistency with the other
	hash functions.
	* lisp.h (INTMASK): Now a macro, since SXHASH_REDUCE is now a
	non-static inline function and therefore can't use static vars.
	(SXHASH_REDUCE): Move here from fns.c, and make it inline.
	* profiler.c (hashfn_profiler): Use SXHASH_REDUCE, to be consistent
	with the other hash functions.

2013-02-09  Eli Zaretskii  <eliz@gnu.org>

	* callproc.c (Fcall_process_region) [WINDOWSNT]: Make sure the
	XXXXXX part of the temporary file pattern is not downcased even
	when w32-downcase-file-names is non-nil.  (Bug#13661)

	* xdisp.c (decode_mode_spec): Remove handling of %t.

	* msdos.c (careadlinkatcwd): Remove.

2013-02-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lread.c (skip_dyn_bytes): New function (bug#12598).
	(read1): Use it.  Use getc instead of READCHAR to read bytes.
	(load_each_byte): Remove.  Update users.

2013-02-08  Dmitry Antipov  <dmantipov@yandex.ru>

	* search.c (scan_buffer): Calculate end byte position just once.
	(scan_newline): Do not recalculate start_byte.
	(search_command): Use eassert.
	* syntax.c (struct lisp_parse_state): New member location_byte.
	(scan_sexps_forward): Record from_byte and avoid redundant
	character to byte position calculation ...
	(Fparse_partial_sexp): ... here.  Break too long line.

2013-02-08  Dmitry Antipov  <dmantipov@yandex.ru>

	* lisp.h (make_uninit_vector): New function.
	* alloc.c (Fvector, Fmake_byte_code):
	* ccl.c (Fregister_ccl_program):
	* charset.c (Fdefine_charset_internal, define_charset_internal):
	* coding.c (make_subsidiaries, Fdefine_coding_system_internal):
	* composite.c (syms_of_composite):
	* font.c (Fquery_font, Ffont_info, syms_of_font):
	* fontset.c (FONT_DEF_NEW, Fset_fontset_font):
	* ftfont.c (ftfont_shape_by_flt):
	* indent.c (recompute_width_table):
	* nsselect.m (clean_local_selection_data):
	* syntax.c (init_syntax_once):
	* w32unsubscribe.c (uniscribe_shape):
	* window.c (Fcurrent_window_configuration):
	* xfaces.c (Fx_family_fonts):
	* xselect.c (selection_data_to_lisp_data): Use it.

2013-02-07  Dmitry Antipov  <dmantipov@yandex.ru>

	* coding.c (Fdefine_coding_system_internal): Use AREF where
	argument is known to be a vector.
	* fns.c (Flocale_info): Likewise for ASET.
	* xselect.c (selection_data_to_lisp_data): Likewise for ASET.
	* w32fns.c (w32_parse_hot_key): Likewise for ASIZE and AREF.

2013-02-05  Jan Djärv  <jan.h.d@swipnet.se>

	* nsmenu.m (update_frame_tool_bar): Check for negative tool bar
	height.

	* nsterm.h (HAVE_NATIVE_FS): Define if OSX => 10.7.
	(EmacsView): Add fs_is_native, fsIsNative, isFullscreen and
	updateCollectionBehaviour.

	* nsterm.m (NEW_STYLE_FS): Remove.
	(ns_last_use_native_fullscreen): New variable.
	(x_make_frame_visible): Replace NEW_STYLE_FS with isFullscreen.
	(x_set_window_size): Do not take title bar and tool bar into account
	if isFullscreen returns YES.
	(ns_fullscreen_hook): Replace NEW_STYLE_FS with isFullscreen.
	(check_native_fs): New function.
	(ns_select, ns_read_socket): Call check_native_fs if HAVE_NATIVE_FS.
	(ns_term_init): Remove NEW_STYLE_FS.
	(updateFrameSize:, windowWillResize:toSize:): Only adjust for title bar
	and tool bar if isFullscreen returns NO.
	(windowDidResize:): Replace NEW_STYLE_FS with fsIsNative.
	(initFrameFromEmacs:): Initialize fs_is_native.  Replace NEW_STYLE_FS
	with HAVE_NATIVE_FS.
	(window:willUseFullScreenPresentationOptions:): New method.
	(windowDidEnterFullScreen:): Replace NEW_STYLE_FS with fsIsNative.
	Hide toolbar if not enabled (Bug#13444).
	(windowDidExitFullScreen:): Call updateCollectionBehaviour.
	Restore tool bar if enabled, hide it otherwise (Bug#13444).
	(fsIsNative, isFullscreen, updateCollectionBehaviour): New methods.
	(toggleFullScreen:): If fs_is_native, call toggleFullScreen on
	window.  Do no set FRAME_EXTERNAL_TOOL_BAR (f) to 0.
	Check FRAME_EXTERNAL_TOOL_BAR (f) before restoring
	FRAME_TOOLBAR_HEIGHT (f).  Call updateFrameSize when going non-fs.
	(syms_of_nsterm): Add ns-use-native-fullscreen.

2013-02-04  Paul Eggert  <eggert@cs.ucla.edu>

	* fileio.c (Qchoose_write_coding_system): Now static.

2013-02-04  Eli Zaretskii  <eliz@gnu.org>

	* xdisp.c (window_buffer_changed): region_showing can be negative,
	which still means region is being displayed.
	(redisplay_internal): Resurrect code that forced redisplay of the
	whole window when showing region and the mark has changed.
	Record the new mark position to allow redisplay optimizations.
	(display_line): If it->region_beg_charpos is non-zero, set the
	window's region_showing member to -1.  (Bug#13623)  (Bug#13626)

	* window.h (struct window) <region_showing>: Declare ptrdiff_t,
	not bitfield of 1 bit.

2013-02-03  Daniel Colascione  <dancol@dancol.org>

	* emacs.c: Use execvp, not execv, when DAEMON_MUST_EXEC, so that
	daemon mode works on cygw32 when Emacs is installed and not just
	during development.

2013-02-02  Paul Eggert  <eggert@cs.ucla.edu>

	Avoid file time stamp bug on MS-Windows (Bug#13149).
	* fileio.c (Fwrite_region): Don't use the heuristic on empty files,
	as FAT32 doesn't update time stamps when truncating them.
	Also, check that a file time stamp is not a multiple of 100 ns;
	this should catch all instances of the problem on MS-Windows,
	as its native file system resolution is 100 ns or worse, and
	checking for a non-multiple of 100 ns should impose only a small
	overhead on systems with ns resolution.

2013-02-02  Eli Zaretskii  <eliz@gnu.org>

	Avoid encoding file names on MS-Windows when they need to be run
	through dostounix_filename.
	* w32.c (normalize_filename): Accept an additional argument
	MULTIBYTE; if non-zero, traverse the file name by bytes and don't
	downcase it even if w32-downcase-file-names is non-nil.
	(dostounix_filename): Accept an additional argument MULTIBYTE and
	pass it to normalize_filename.
	(emacs_root_dir): Adjust.

	* msdos.h (dostounix_filename): Adjust prototype.

	* w32.h (dostounix_filename): Adjust prototype.

	* msdos.c (dostounix_filename): Accept an additional argument and
	ignore it.
	(init_environment): Adjust callers of dostounix_filename.

	* fileio.c (Ffile_name_directory, file_name_as_directory)
	(directory_file_name, Fexpand_file_name)
	(Fsubstitute_in_file_name): [DOS_NT] Adjust call to
	dostounix_filename.
	[WINDOWSNT]: Downcase file names if w32-downcase-file-names is
	non-nil.
	(Fsubstitute_in_file_name): [DOS_NT] Don't downcase environment
	variables, as egetenv is case-insensitive for DOS_NT.

	* dired.c (file_name_completion): Don't call Fdirectory_file_name
	with an encoded file name.

	* w32proc.c (Fw32_short_file_name, Fw32_long_file_name):
	Adjust calls to dostounix_filename.

	* w32fns.c (Fx_file_dialog): Adjust call to dostounix_filename.

	* unexw32.c (unexec): Adjust call to dostounix_filename.

	* termcap.c (tgetent) [MSDOS]: Adjust call to dostounix_filename.

	* emacs.c (decode_env_path) [DOS_NT]: Adjust call to
	dostounix_filename.

	* callproc.c (Fcall_process) [MSDOS]: Adjust call to
	dostounix_filename.

	* callproc.c (Fcall_process): Make sure program name in PATH and
	new_argv[0] is encoded, if needed.  Otherwise, un-encoded string
	is passed to exec/spawnve, which fails unless the file-name
	encoding is UTF-8.

	* w32proc.c (sys_spawnve): Make sure escape_char is initialized,
	even if w32-quote-process-args is nil.

2013-02-01  Paul Eggert  <eggert@cs.ucla.edu>

	Fix timestamp bug when write-region appends nothing (Bug#13149).
	* fileio.c (Fwrite_region): When neither O_EXCL nor O_TRUNC is used,
	the file's time stamp doesn't change if Emacs happens to write nothing
	to the file, and on a buggy file system this could cause Emacs to
	incorrectly infer that the file system doesn't have the bug.
	Avoid this problem by inhibiting the inference in this case.

2013-02-01  Dmitry Antipov  <dmantipov@yandex.ru>

	* window.h (struct window): Convert base_line_number, base_line_pos
	and column_number_displayed members from Lisp_Object to ptrdiff_t.
	Convert region_showing member from Lisp_Object to bitfield.
	Remove sequence_number member.  Adjust comments.
	* window.c (sequence_number): Remove.
	(make_window): Initialize column_number_displayed.
	* print.c (print_object): Follow the printed representation of
	frames and print window pointer to distinguish between windows.
	(adjust_window_count): Invalidate base_line_pos.  Adjust comment.
	* xdisp.c (wset_base_line_number, wset_base_line_pos)
	(wset_column_number_displayed, wset_region_showing): Remove.
	(window_buffer_changed, mode_line_update_needed, redisplay_internal)
	(try_scrolling, try_cursor_movement, redisplay_window)
	(try_window_reusing_current_matrix, try_window_id, display_line)
	(display_mode_lines, decode_mode_spec): Adjust users.
	* .gdbinit (pwinx): Do not print sequence_number.

2013-02-01  Paul Eggert  <eggert@cs.ucla.edu>

	Use fdopendir, fstatat and readlinkat, for efficiency (Bug#13539).
	* conf_post.h (GNULIB_SUPPORT_ONLY_AT_FDCWD): Remove.
	* dired.c: Include <fcntl.h>.
	(open_directory): New function, which uses open and fdopendir
	rather than opendir.  DOS_NT platforms still use opendir, though.
	(directory_files_internal, file_name_completion): Use it.
	(file_attributes): New function, with most of the old Ffile_attributes.
	(directory_files_internal, Ffile_attributes): Use it.
	(file_attributes, file_name_completion_stat): First arg is now fd,
	not dir name.  All uses changed.  Use fstatat rather than lstat +
	stat.
	(file_attributes): Use emacs_readlinkat rather than Ffile_symlink_p.
	* fileio.c: Include <allocator.h>, <careadlinkat.h>.
	(emacs_readlinkat): New function, with much of the old
	Ffile_symlink_p, but with an fd argument for speed.
	It uses readlinkat rather than careadlinkatcwd, so that it
	need not assume the working directory.
	(Ffile_symlink_p): Use it.
	* filelock.c (current_lock_owner): Use emacs_readlinkat
	rather than emacs_readlink.
	* lisp.h (emacs_readlinkat): New decl.
	(READLINK_BUFSIZE, emacs_readlink): Remove.
	* sysdep.c: Do not include <allocator.h>, <careadlinkat.h>.
	(emacs_norealloc_allocator, emacs_readlink): Remove.
	This stuff is moved to fileio.c.
	* w32.c (fstatat, readlinkat): New functions.
	(careadlinkat): Don't check that fd == AT_FDCWD.
	(careadlinkatcwd): Remove; no longer needed.

2013-01-31  Glenn Morris  <rgm@gnu.org>

	* fileio.c (choose_write_coding_system): Make it callable from Lisp.
	(Fwrite_region): Update for new choose_write_coding_system args.
	Move the last piece of choose_write_coding_system here.  (Bug#13522)
	(syms_of_fileio): Add choose-write-coding-system.

2013-01-30  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (sys_open): Zero out the flags for the new file descriptor.
	(sys_close): Zero out the flags for the file descriptor before
	closing it.  (Bug#13546)

	* w32.c (parse_root, get_volume_info, readdir, read_unc_volume)
	(logon_network_drive, stat_worker, symlink, chase_symlinks):
	Use CharNextExA and CharPrevExA to iterate over file names encoded in
	DBCS.  (Bug#13553)

	* w32.c (w32_get_long_filename, init_environment, readlink):
	Support file names encoded in DBCS codepages.
	(readlink): Use the current file-name-coding-system, not the ANSI
	codepage, to decode and handle targets of symlinks.

2013-01-28  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (opendir): Now accepts a 'const char *'.

2013-01-28  Dmitry Antipov  <dmantipov@yandex.ru>

	Remove obsolete redisplay code.  See the discussion at
	http://lists.gnu.org/archive/html/emacs-devel/2013-01/msg00576.html.
	* dispnew.c (preemption_period, preemption_next_check): Remove.
	(Vredisplay_preemption_period): Likewise.
	(update_frame, update_single_window, update_window, update_frame_1):
	Adjust users.  Always assume that PERIODIC_PREEMPTION_CHECKING is not
	used, following the 2012-06-22 change.

2013-01-25  Eli Zaretskii  <eliz@gnu.org>

	* w32notify.c (Fw32notify_add_watch): Doc fix.  (Bug#13540)

2013-01-25  Dmitry Antipov  <dmantipov@yandex.ru>

	* font.c (num_fonts): Remove the leftover from old
	debugging code.  Adjust comment style here and there.
	* insdel.c (insert_1): Remove.
	* lisp.h (insert_1): Remove prototype.
	* xdisp.c (message_dolog): Adjust users to call insert_1_both.

2013-01-25  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (max_filename_mbslen): New function.
	(normalize_filename, readdir): Use it to detect locales where ANSI
	encoding of file names uses a double-byte character set (DBCS).
	If a DBCS encoding is used, advance by characters using
	CharNextExA, instead of incrementing a 'char *' pointer.
	Use _mbslwr instead of _strlwr.  (Bug#13515)

	* w32heap.c (allocate_heap) [!_WIN64]: Decrease the initial
	request of memory reservation to 1.7GB.  (Bug#13065)

2013-01-25  Andreas Schwab  <schwab@linux-m68k.org>

	* coding.c (detect_coding_iso_2022): Move back mis-reordered code
	at check_extra_latin label.  (Bug#13505)

2013-01-24  Dmitry Antipov  <dmantipov@yandex.ru>

	* nsfont.m (ns_escape_name, ns_unescape_name, ns_registry_to_script):
	Avoid redundant calls to strlen.

2013-01-24  Dmitry Antipov  <dmantipov@yandex.ru>

	Drop async_visible and async_iconified fields of struct frame.
	This is possible because async input is gone; for details, see
	http://lists.gnu.org/archive/html/emacs-devel/2012-12/msg00734.html.
	* frame.h (struct frame): Remove async_visible and async_iconified
	members, convert garbaged to unsigned bitfield.  Adjust comments.
	(FRAME_SAMPLE_VISIBILITY): Remove.  Adjust all users.
	(SET_FRAME_VISIBLE, SET_FRAME_ICONIFIED): New macros.
	* frame.c, gtkutil.c, term.c, w32fns.c, window.c, xdisp.c:
	Consistently use SET_FRAME_VISIBLE, SET_FRAME_ICONIFIED,
	FRAME_VISIBLE_P and FRAME_ICONIFIED_P macros where appropriate.
	* w32term.c: Ditto.
	(w32_read_socket): Save iconified state to generate DEICONIFY_EVENT
	properly.  Likewise for obscured.
	* xterm.c: Ditto.
	(handle_one_xevent): Save visible state to generate ICONIFY_EVENT
	properly.
	* nsterm.m: Ditto.
	(windowDidDeminiaturize): Generate DEICONIFY_EVENT.

2013-01-24  Dmitry Antipov  <dmantipov@yandex.ru>

	* insdel.c (prepare_to_modify_buffer): Revert last change as suggested
	in http://lists.gnu.org/archive/html/emacs-devel/2013-01/msg00555.html.

2013-01-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (message2, message2_nolog): Remove functions.
	(message3, message3_nolog): Extract nbytes and multibyteness directly
	from the string.  Change all callers.
	(message3_nolog): Don't set message_enable_multibyte since set_message
	will reset it anyway.
	(message1, message1_nolog): Use message3.
	(vmessage): Use a stack allocated buffer rather than f->message_buf.
	(with_echo_area_buffer): Remove last two arguments.  Update all callers.
	(set_message): Drop all but the second arg, which has to be a string.
	(set_message_1): Simplify now that we know that a1 is NULL and the
	second arg is a string.
	* frame.h (struct frame): Remove `message_buf' field.
	Use glyphs_initialized_p instead.
	(FRAME_MESSAGE_BUF): Remove macro.
	* w16select.c (Fw16_set_clipboard_data): Prefer message3 to message2.
	* lisp.h (message2, message2_nolog): Remove declarations.
	(message3, message3_nolog): Update declarations.
	* keyboard.c (read_char_minibuf_menu_text)
	(read_char_minibuf_menu_width): Remove vars.
	(read_char_minibuf_menu_prompt): Rewrite the menu's construction so as
	to correctly handle multibyte strings.
	* frame.c (delete_frame): Don't free message_buf any more.
	* editfns.c (message_text, message_length): Remove vars.
	(Fmessage_box): Don't copy the Lisp string's bytes any longer.
	* fileio.c (auto_save_error): Use message3 instead of message2.
	* dispnew.c (adjust_frame_message_buffer): Remove function.

2013-01-23  Eli Zaretskii  <eliz@gnu.org>

	* w32term.c (w32fullscreen_hook): Account correctly for the screen
	real estate used for the tool bar and the menu bar.

2013-01-23  Dmitry Antipov  <dmantipov@yandex.ru>

	* insdel.c (prepare_to_modify_buffer): Force redisplay if
	hidden buffer is prepared to modification (Bug#13164).

2013-01-22  Dmitry Antipov  <dmantipov@yandex.ru>

	* window.h (struct window): Change window_end_valid member from
	Lisp_Object to a bitfield.  Adjust comments.
	(wset_window_end_valid): Remove.
	* window.c (adjust_window_count): Clear window_end_valid.
	(Fwindow_end): Adjust user.  Remove ancient #if 0 code.
	(Fwindow_line_height, set_window_buffer, Frecenter)
	(Fsplit_window_internal, Fdelete_other_windows_internal)
	(Fset_window_fringes, Fset_window_scroll_bars): Adjust users.
	* dispnew.c (adjust_glyph_matrix, clear_window_matrices): Likewise.
	* xdisp.c (check_window_end, reconsider_clip_changes)
	(redisplay_internal, mark_window_display_accurate_1, redisplay_window)
	(try_window, try_window_reusing_current_matrix, note_mouse_highlight)
	(find_first_unchanged_at_end_row, try_window_id): Likewise.

2013-01-22  Dmitry Antipov  <dmantipov@yandex.ru>

	* xdisp.c (mark_window_display_accurate): Simplify the loop
	assuming that the only one of vchild, hchild or buffer window
	slots is non-nil.  Call mark_window_display_accurate_1 for
	the leaf windows only.
	(mark_window_display_accurate_1): Always assume leaf window.
	Adjust comment.

2013-01-22  Paul Eggert  <eggert@cs.ucla.edu>

	* emacs.c (Qkill_emacs_hook): Now static.

	* fileio.c (Finsert_file_contents): Simplify.
	Remove unnecessary assignments and tests.

2013-01-21  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (acl_set_file): Don't test for errors unless
	set_file_security returns FALSE.  Avoids spurious errors when
	saving files.

2013-01-21  Dmitry Antipov  <dmantipov@yandex.ru>

	* fileio.c (Finsert_file_contents): Revert code introduced at
	2013-01-18 in favor of the simpler and generally better fix.
	Save stack space by removing 'buffer' and reusing 'read_buf'
	where appropriate.

2013-01-19  Paul Eggert  <eggert@cs.ucla.edu>

	* lisp.h (eabs): Define unconditionally (Bug#13419).
	The old "#if !defined (eabs)" was an unnecessary revenant of back
	when this macro was called "abs".  Document 'eabs' better.

2013-01-19  Glenn Morris  <rgm@gnu.org>

	* fns.c (Frandom): Doc fix.

2013-01-19  Eli Zaretskii  <eliz@gnu.org>

	* editfns.c (get_pos_property): Use SAFE_ALLOCA_LISP, to avoid
	segfault when there are lots of overlays.

	* buffer.c (sort_overlays): Use SAFE_NALLOCA, to avoid segfault
	when there are lots of overlays.
	See http://lists.gnu.org/archive/html/emacs-devel/2013-01/msg00421.html
	for the details and a way to reproduce.

2013-01-19  Paul Eggert  <eggert@cs.ucla.edu>

	* fileio.c: Use O_APPEND to append.
	This corresponds better to the natural interpretation of "append",
	and avoids the need to open the output file twice, or to invoke
	lseek when APPEND is neither nil nor a number.
	This relies on POSIX 1003.1-1988 or later, which is OK nowadays.
	(Fwrite_region): Simplify.  Use O_APPEND instead of opening the
	file possibly twice, and lseeking to its end; this avoids the
	need to lseek on non-regular files.  Do not use O_EXCL and O_TRUNC
	at the same time: the combination is never needed and apparently
	it doesn't work with DOS_NT.

	Fix size bug on DOS_NT introduced by CIFS workaround (Bug#13149).
	* fileio.c (Fwrite_region): Use O_BINARY in checking code, too.

	Allow floating-point file offsets.
	Problem reported by Vitalie Spinu in
	<http://lists.gnu.org/archive/html/emacs-devel/2013-01/msg00411.html>.
	* fileio.c (emacs_lseek): Remove.
	(file_offset): New function.
	(Finsert_file_contents, Fwrite_region): Use it.

2013-01-19  Chong Yidong  <cyd@gnu.org>

	* emacs.c (Fkill_emacs): Set waiting_for_input to 0 to avoid
	aborting on Fsignal (Bug#13289).

2013-01-19  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (acl_set_file): Treat ERROR_ACCESS_DENIED from
	set_file_security as failure due to insufficient privileges.
	Reported by Fabrice Popineau <fabrice.popineau@supelec.fr>.
	(fstat): Return owner and group like 'stat' and 'lstat' do.

2013-01-19  Paul Eggert  <eggert@cs.ucla.edu>

	Work around bug in CIFS and vboxsf file systems (Bug#13149).
	The bug was observed on Ubuntu operating inside a virtual machine,
	editing files mounted via CIFS or vboxsf from the MS Windows 7 host.
	The workaround introduces a race condition on non-buggy hosts,
	but it's an unlikely race and anyway there's a nearly identical
	nearby race that can't be fixed.
	* fileio.c (valid_timestamp_file_system, timestamp_file_system):
	New static vars.
	(Fwrite_region): Test for file system time stamp bug.
	(init_fileio): New function.
	* lisp.h (init_fileio): Declare it.
	* emacs.c (main): Call it.

	* fileio.c (Finsert_file_contents): Simplify new diagnostic
	and make it more consistent with other stat-failure diagnostics.

2013-01-18  Dmitry Antipov  <dmantipov@yandex.ru>

	Fix crash when inserting data from non-regular files.
	See http://lists.gnu.org/archive/html/emacs-devel/2013-01/msg00406.html
	for the error description produced by valgrind.
	* fileio.c (read_non_regular): Rename to read_contents.
	Free Lisp_Save_Value object used to pass parameters.
	(read_non_regular_quit): Rename to read_contents_quit.
	(Finsert_file_contents): Redesign internal file reading loop to adjust
	gap and end positions after each read and so help make_gap to work
	properly.  Do not signal an I/O error too early and so do not leave
	not yet decoded characters in a buffer, which was the reason of
	redisplay crash.  Use list2 to build return value.  Adjust comments.

2013-01-17  Paul Eggert  <eggert@cs.ucla.edu>

	Close a race when statting and reading files (Bug#13149).
	* fileio.c (Finsert_file_contents): Use open+fstat, not stat+open.
	This avoids a race if the file is renamed between stat and open.
	This race is not the problem originally noted in Bug#13149;
	see <http://bugs.gnu.org/13149#73> and later messages in the thread.

2013-01-17  Dmitry Antipov  <dmantipov@yandex.ru>

	* lisp.h (toplevel): Add comment about using Lisp_Save_Value
	objects, related functions and macros.
	(make_save_value): Adjust prototype.
	(make_save_pointer): New prototype.
	(SAFE_NALLOCA): Fix indentation.  Use make_save_pointer.
	(SAFE_ALLOCA_LISP): Adjust make_save_value usage.
	* alloc.c (format_save_value): Rename to make_save_value.
	(make_save_pointer): New function.
	(record_xmalloc): Use make_save_pointer.
	* dired.c, editfns.c, fileio.c, font.c, gtkutil.c, lread.c:
	* nsmenu.m, nsterm.m, xfns.c, xmenu.c, xselect.c, keymap.c:
	Change users of make_save_value to make_save_pointer.
	Likewise for format_save_value and make_save_value.

2013-01-17  Dmitry Antipov  <dmantipov@yandex.ru>

	* buffer.h (NARROWED, BUF_NARROWED): Drop unused macros.
	(DECODE_POSITION, BUFFER_CHECK_INDIRECTION): Fix indentation.
	* buffer.c (toplevel, syms_of_buffer): Drop old commented-out
	debugging stubs.

2013-01-15  Paul Eggert  <eggert@cs.ucla.edu>

	* alloc.c (free_save_value): Now static.

2013-01-15  Dmitry Antipov  <dmantipov@yandex.ru>

	* keymap.c (map_keymap_internal): Use format_save_value.
	(map_keymap_char_table_item): Adjust accordingly.
	* fileio.c (non_regular_fd, non_regular_inserted)
	(non_regular_nbytes): Remove.
	(Finsert_file_contents): Convert trytry to ptrdiff_t.
	Use format_save_value to pass parameters to read_non_regular.
	(read_non_regular): Use XSAVE_ macros to extract parameters.
	Adjust comment.
	* xmenu.c (xmenu_show) [!USE_X_TOOLKIT && !USE_GTK]: Use
	format_save_value.
	(pop_down_menu) [!USE_X_TOOLKIT && !USE_GTK]: Adjust user.

2013-01-15  Dmitry Antipov  <dmantipov@yandex.ru>

	* lisp.h (XSAVE_POINTER, XSAVE_INTEGER): Change to allow
	extraction from any Lisp_Save_Value slot.  Add type checking.
	* alloc.c, dired.c, editfns.c, fileio.c, ftfont.c, gtkutil.c:
	* keymap.c, lread.c, nsterm.h, nsmenu.c, xfns.c, xmenu.c:
	* xselect.c: All users changed.

2013-01-15  Dmitry Antipov  <dmantipov@yandex.ru>

	Some convenient bits to deal with Lisp_Save_Values.
	* lisp.h (XSAVE_OBJECT): New macro to extract saved objects.
	(allocate_misc): Remove prototype.
	(format_save_value): New prototype.
	* alloc.c (allocate_misc): Revert back to static.
	(format_save_value): New function to build Lisp_Save_Value
	object with the specified internal structure.
	(make_save_value): Reimplement using format_save_value.
	* editfns.c (save_excursion_save): Use format_save_value.
	(save_excursion_restore): Use XSAVE_OBJECT.

2013-01-14  Paul Eggert  <eggert@cs.ucla.edu>

	Avoid needless casts with XSAVE_POINTER.
	* alloc.c (mark_object) [GC_MARK_STACK]:
	* dired.c (directory_files_internal_unwind):
	* fileio.c (do_auto_save_unwind):
	* gtkutil.c (pop_down_dialog):
	* keymap.c (map_keymap_char_table_item):
	* lread.c (load_unwind):
	* nsmenu.m (pop_down_menu):
	* print.c (print_object) [GC_MARK_STACK]:
	* xfns.c (clean_up_file_dialog):
	* xmenu.c (cleanup_widget_value_tree):
	Omit casts between XSAVE_POINTER and a pointer type.

2013-01-14  Dmitry Antipov  <dmantipov@yandex.ru>

	Fix compilation with GC_MARK_STACK == GC_USE_GCPROS_AS_BEFORE.
	* eval.c (eval_sub): Protect `form' from being GCed before its
	car and cdr becomes protected with the backtrace entry.

2013-01-14  Dmitry Antipov  <dmantipov@yandex.ru>

	Make Lisp_Save_Value more versatile storage for up to four objects.
	* lisp.h (toplevel): Enumeration to describe types of saved objects.
	(struct Lisp_Save_Value): New layout.  Adjust comments.
	(XSAVE_POINTER): New macro.
	(XSAVE_INTEGER): Likewise.
	(allocate_misc): Add prototype.
	(free_misc): Likewise.
	* alloc.c (allocate_misc): Now global.
	(free_misc): Likewise.  Adjust comment.
	(make_save_value): Use new Lisp_Save_Value layout.  Adjust comment.
	(free_save_value): Likewise.
	(mark_object): Likewise.
	* editfns.c (save_excursion_save): Pack everything within
	Lisp_Save_Value and so avoid xmalloc.
	(save_excursion_restore): Adjust to match new layout.  Use free_misc
	because we do not allocate extra memory any more.  Add eassert.
	* print.c (print_object): New code to print Lisp_Save_Value.  Do not
	rely on valid_lisp_object_p if !GC_MARK_STACK.  Adjust comments.
	* dired.c, fileio.c, font.c, ftfont.c, gtkutil.c, keymap.c,
	* lread.c, nsmenu.m, nsterm.h, xfns.c, xmenu.c, xselect.c:
	Use XSAVE_POINTER and XSAVE_INTEGER where appropriate.

2013-01-13  Jan Djärv  <jan.h.d@swipnet.se>

	* nsfont.m (LCD_SMOOTHING_MARGIN): New define.
	(nsfont_draw): Remove disabling of LCD smoothing.
	(ns_glyph_metrics): Add LCD_SMOOTHING_MARGIN to bearings to fix
	Bug#11484 with LCD smoothing on.

2013-01-13  Paul Eggert  <eggert@cs.ucla.edu>

	Fix SIGDANGER handlers, for AIX (Bug#13408).
	* sysdep.c.c (handle_danger_signal, deliver_danger_signal) [SIGDANGER]:
	Move handlers here from emacs.c; they were out of place.

2013-01-11  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.c (syms_of_xterm): Adjust documentation for
	scroll-bar-adjust-thumb-portion.

2012-12-31  Adam Sjøgren  <asjo@koldfront.dk>  (tiny change)

	* xterm.c (scroll-bar-adjust-thumb-portion): New variable to
	determine whether scroll bar thumb size should be adjusted or not.
	Use variable for MOTIF.

	* gtkutil.c (scroll-bar-adjust-thumb-portion): Use variable for GTK.

2013-01-13  Jan Djärv  <jan.h.d@swipnet.se>

	* nsterm.m (keyDown:): Set processingCompose to NO if an emacs key
	event is generated.
	(doCommandBySelector:): Set processingCompose to NO.

	* nsfont.m (ns_findfonts): Add block/unblock_input calls.
	Remove check for fkeys count > zero, block/unblock fixes the real bug.
	(nsfont_list_family): Add block/unblock_input calls.
	(nsfont_open): Move block_input earlier.  Add unblock_input before early
	return.
	(nsfont_draw): Add block/unblock_input calls.

2013-01-12  Dmitry Antipov  <dmantipov@yandex.ru>

	* indent.c (Fvertical_motion): Remove now-incorrect GCPROs
	for old_charpos and old_bytepos.

2013-01-12  Paul Eggert  <eggert@cs.ucla.edu>

	Fix bug with set-time-zone-rule and LOCALTIME_CACHE (Bug#13415).
	* editfns.c (set_time_zone_rule) [LOCALTIME_CACHE]:
	Clear tzvalbuf_in_environ if this workaround is in effect.
	Problem and fix reported by Kazuhiro Ito.

2013-01-11  Aaron S. Hawley  <Aaron.Hawley@vtinfo.com>

	* insdel.c (Fcombine_after_change_execute, syms_of_insdel):
	Fix ambiguous doc string cross-reference(s).

	* keyboard.c (Fcommand_execute, syms_of_keyboard): Fix ambiguous
	 doc string cross-reference(s).

	* window.c (Fwindow_point, syms_of_window): Fix ambiguous doc
	 string cross-reference(s).

2013-01-11  Dmitry Antipov  <dmantipov@yandex.ru>

	Avoid unnecessary byte position calculation for the gap movement.
	Since all users of move_gap do CHAR_TO_BYTE for other purposes
	anyway, all of them should use move_gap_both instead.
	* lisp.h (move_gap): Remove prototype.
	* insdel.c (move_gap): Remove.
	(move_gap_both): Add eassert.
	* editfns.c (Ftranspose_regions): Tweak to use move_gap_both.
	* xml.c (parse_region): Likewise.

2013-01-11  Paul Eggert  <eggert@cs.ucla.edu>

	emacsclient -t should not suspend Emacs server (Bug#13387)
	* lisp.h, sysdep.c (block_tty_out_signal, unblock_tty_out_signal):
	New functions.
	* term.c (init_tty): Use them instead of rolling our own code.
	* sysdep.c (tcsetpgrp_without_stopping): Likewise.  Here, this
	switches from 'signal' to 'pthread_sigmask', which is safer in
	multithreaded applications.
	* term.c (Fresume_tty): Don't bother dissociating if O_IGNORE_CTTY,
	which has already arranged for that.
	(dissociate_if_controlling_tty): If setsid fails, fall back on TIOCNOTTY.
	This is the main part of the bug fix.

2013-01-10  Rainer Orth  <ro@CeBiTec.Uni-Bielefeld.DE>  (tiny change)

	* gtkutil.c (xg_initialize): Add ifdef HAVE_FREETYPE around
	x_last_font_name (Bug#13403).

2013-01-10  Dmitry Antipov  <dmantipov@yandex.ru>

	Omit buffer_slot_type_mismatch and use generic predicates to enforce
	the type of per-buffer values where appropriate.
	* lisp.h (struct Lisp_Buffer_Objfwd): Rename slottype member to
	predicate, which is how it's really used now.  Adjust comment.
	* buffer.h (buffer_slot_type_mismatch): Remove prototype.
	* buffer.c (buffer_slot_type_mismatch): Remove.
	(DEFVAR_PER_BUFFER, defvar_per_buffer): Rename type argument to
	predicate.  Adjust comment.
	(syms_of_buffer): Use Qsymbolp for major-mode.  Use Qintegerp for
	fill-column, left-margin, tab-width, buffer-saved-size,
	left-margin-width, right-margin-width, left-fringe-width,
	right-fringe-width, scroll-bar-width and buffer-display-count.
	Use Qstringp for default-directory, buffer-file-name,
	buffer-file-truename and buffer-auto-save-file-name.  Use Qfloatp for
	scroll-up-aggressively and scroll-down-aggressively.  Use Qnumberp for
	line-spacing.
	* data.c (store_symval_forwarding): Adjust to call the predicate.

2013-01-09  Juanma Barranquero  <lekktu@gmail.com>

	* w32.c (get_name_and_id, acl_set_file):
	* w32term.c (w32fullscreen_hook): Remove unused local variables.

2013-01-09  Dmitry Antipov  <dmantipov@yandex.ru>

	* lisp.h (make_gap_1): New prototype.
	* buffer.h (GAP_BYTES_DFL, GAP_BYTES_MIN): New macros for the special
	gap size values.
	* editfns.c (Fbuffer_size): Rename from Fbufsize to fit the common
	naming convention.
	(syms_of_editfns): Adjust defsubr.  Drop commented-out obsolete code.
	* insdel.c (make_gap_larger): Use GAP_BYTES_DFL.  Adjust comment.
	(make_gap_smaller): Use GAP_BYTES_MIN.  Adjust comment.
	(make_gap_1): New function to adjust the gap of any buffer.
	* coding.c (coding_alloc_by_making_gap): Use it.
	* buffer.c (compact_buffer): Likewise.  Use BUF_Z_BYTE, BUF_GAP_SIZE,
	GAP_BYTES_DFL and GAP_BYTES_MIN.  Adjust comment.

2013-01-08  Juri Linkov  <juri@jurta.org>

	* xfaces.c (tty_supports_face_attributes_p): Return 0 for the case
	of (supports :underline (:style wave)).  (Bug#13000)

2013-01-08  Aaron S. Hawley  <aaron.s.hawley@gmail.com>

	* undo.c (Fprimitive_undo): Move to simple.el.
	(syms_of_undo): Remove declarations for Sprimitive_undo.

2013-01-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keyboard.c (echo_add_key): Rename from echo_add_char.

2013-01-06  Chong Yidong  <cyd@gnu.org>

	* keyboard.c (echo_add_char): New function, factored out from
	echo_char.  Don't add a space if the previous echo string was
	empty (Bug#13255).
	(echo_char): Use it.
	(read_key_sequence): When echoing mock input, ensure that the
	trailing dash is properly added.

2013-01-05  Eli Zaretskii  <eliz@gnu.org>

	* xdisp.c (dump_glyph): Align glyph data better.  Use "pD" instead
	of a non-portable "t" to print ptrdiff_t values.  Allow up to 9
	digits for buffer positions, before misalignment starts.
	Display "0" for integer "object" field.
	(dump_glyph_row): Adapt the header line to changes in dump_glyph.
	Display the newline glyph more unambiguously.

2013-01-04  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* nsterm.m (ns_draw_underwave):
	* w32term.c (w32_draw_underwave):
	* xterm.c (x_draw_underwave): Make underwave look more triangular
	and also degrade gracefully for small fonts.  (Bug#13000)

	* nsterm.m (ns_draw_text_decoration):
	* w32term.c (x_draw_glyph_string):
	* xterm.c (x_draw_glyph_string): Don't use previous underline
	thickness and position if previous underline type is underwave.

2013-01-04  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Ffile_acl): Undocument return format.

2013-01-02  Glenn Morris  <rgm@gnu.org>

	* keymap.c (Fkey_description): Doc fix.  (Bug#13323)

2013-01-02  Paul Eggert  <eggert@cs.ucla.edu>

	Simplify via eabs.
	* dired.c (file_name_completion):
	* doc.c (get_doc_string):
	* floatfns.c (round2):
	* font.c (font_score, font_delete_unmatched):
	* fringe.c (compute_fringe_widths):
	* lread.c (read_list):
	* minibuf.c (Ftry_completion):
	* term.c (tty_ins_del_lines):
	* xterm.c (x_draw_image_foreground, x_draw_image_foreground_1):
	Use eabs (x) rather than open-coding it as (x < 0 ? -x : x).

2012-12-31  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (unsetenv): Set up the string passed to _putenv
	correctly.
	See http://lists.gnu.org/archive/html/emacs-devel/2012-12/msg00863.html
	for the bug this caused.

2012-12-30  Paul Eggert  <eggert@cs.ucla.edu>

	* coding.c (Qmac): Now static.

2012-12-30  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (TOOLBAR_TOP_WIDGET): New macro.
	(xg_pack_tool_bar): Use TOOLBAR_TOP_WIDGET, condition out use of
	handlebox_widget.  Set toolbar_in_hbox to false/true, set
	toolbar_is_packed to true.
	(xg_update_tool_bar_sizes): Use widget returned by TOOLBAR_TOP_WIDGET.
	(update_frame_tool_bar): Check toolbar_is_packed for packing.
	Show all on TOOLBAR_TOP_WIDGET.
	(free_frame_tool_bar): Check toolbar_is_packed.  Use widget returned
	by TOOLBAR_TOP_WIDGET.
	(xg_change_toolbar_position): Use widget returned by TOOLBAR_TOP_WIDGET.
	Check toolbar_is_packed.
	(xg_have_tear_offs, tearoff_remove, tearoff_activate): Condition on
	HAVE_GTK_TEAROFF_MENU_ITEM_NEW.
	(xg_have_tear_offs): When ! HAVE_GTK_TEAROFF_MENU_ITEM_NEW, return
	false.
	(create_menus): Create tearoff only if HAVE_GTK_TEAROFF_MENU_ITEM_NEW.
	(xg_update_menubar): Update title only if
	HAVE_GTK_TEAROFF_MENU_ITEM_NEW.
	(xg_update_submenu): Skip tearoff only if
	HAVE_GTK_TEAROFF_MENU_ITEM_NEW.
	(xg_initialize): Initialize xg_detached_menus only if
	HAVE_GTK_TEAROFF_MENU_ITEM_NEW.

	* xterm.h (struct x_output): Surround handlebox_widget with
	#ifdef HAVE_GTK_HANDLE_BOX_NEW.  toolbar_is_packed is new,
	toolbar_in_hbox is bool.

2012-12-30  Andreas Schwab  <schwab@linux-m68k.org>

	* Makefile.in (TEMACS_LDFLAGS2): Remove.
	(LIBS_GNUSTEP): Define.
	(LIBES): Add $(LIBS_GNUSTEP).
	(temacs$(EXEEXT)): Use $(LDFLAGS) instead of $(TEMACS_LDFLAGS2).

2012-12-30  Eli Zaretskii  <eliz@gnu.org>

	* xdisp.c (set_cursor_from_row): Don't confuse a truncation or
	continuation glyph on a TTY with an indication of an empty line.
	(Bug#13277)

2012-12-29  Eli Zaretskii  <eliz@gnu.org>

	* fileio.c (Fset_file_selinux_context, Fset_file_acl): Return t if
	file's SELinux context or ACLs successfully set, nil otherwise.
	(Bug#13298)
	(Fcopy_file) [WINDOWSNT]: Improve diagnostics when CopyFile fails.

	* w32proc.c (reader_thread): Avoid passing NULL handles to
	SetEvent and WaitForSingleObject.

2012-12-28  Paul Eggert  <eggert@cs.ucla.edu>

	Port EXTERNALLY_VISIBLE to Clang 3.2.
	* conf_post.h (__has_attribute): New macro.
	(EXTERNALLY_VISIBLE): Use it.  This ports to Clang 3.2.

2012-12-27  Glenn Morris  <rgm@gnu.org>

	* cygw32.c (Fcygwin_convert_file_name_to_windows)
	(Fcygwin_convert_file_name_from_windows): Doc fixes.

2012-12-27  Eli Zaretskii  <eliz@gnu.org>

	* fileio.c (file_name_as_directory, directory_file_name):
	Accept an additional argument MULTIBYTE to indicate whether the input C
	came from a multibyte or a unibyte Lisp string; all callers
	adjusted.  Don't assume the input string is always multibyte.
	(Bug#13262)
	(Ffile_name_directory) [DOS_NT]: Handle unibyte strings correctly:
	don't ENCODE_FILE them, and return a unibyte string if the input
	was unibyte.
	(Fexpand_file_name): Don't mix unibyte with multibyte strings, and
	don't assume the input strings will always be multibyte.  If the
	input strings are multibyte, decode strings obtained from C
	library functions.

2012-12-26  Dmitry Antipov  <dmantipov@yandex.ru>

	* lisp.h (toplevel): Add two notices to the comment about
	defining a new Lisp data type.
	* print.c (print_object): If Lisp_Save_Value object's pointer
	is the address of a memory area containing Lisp_Objects, try
	to print them.
	* alloc.c (valid_lisp_object_p): Adjust comment.

2012-12-26  Dmitry Antipov  <dmantipov@yandex.ru>

	* keyboard.c (record_asynch_buffer_change): Initialize an event
	only if it's really needed.
	* frame.h (enum output_method): Remove output_mac member since
	it's a leftover from the deleted code.
	* frame.c (Fframep): Adjust user here ...
	* terminal.c (Fterminal_live_p): ... and here.
	* coding.c (Qmac): Now here because it's only used to denote
	end-of-line encoding type.
	(syms_of_coding): DEFSYM it.
	* frame.h (Qmac): Remove duplicated declaration.

2012-12-26  Paul Eggert  <eggert@cs.ucla.edu>

	* window.c (select_window_1): Now static, since it's used only here.

2012-12-25  Eli Zaretskii  <eliz@gnu.org>

	* window.c (window_body_cols): Subtract display margins from the
	window body width on TTYs as well.  See
	http://lists.gnu.org/archive/html/help-gnu-emacs/2012-12/msg00317.html
	for the original report.

2012-12-25  Dmitry Antipov  <dmantipov@yandex.ru>

	* xdisp.c (redisplay_window): Remove inner local variable
	because the outer shadowed one has the same meaning.
	* xterm.h (struct x_output): Remove toolbar_detached member since it's
	set but never used.
	* gtkutil.c (xg_tool_bar_detach_callback, xg_tool_bar_attach_callback)
	(xg_create_tool_bar): Adjust users.

2012-12-24  Dmitry Antipov  <dmantipov@yandex.ru>

	* buffer.h (BUF_COMPACT): New macro to follow the common style.
	* buffer.c (Fget_buffer_create): Use it to set compact field of
	struct buffer_text to avoid accessing an uninitialized value
	when compact_buffer is called for the first time.
	(compact_buffer): Use convenient BUF_COMPACT and BUF_MODIFF.
	(Fset_buffer_modified_p): Use buffer_window_count to check
	whether the buffer is displayed in some window.
	* xdisp.c (message_dolog): Likewise.

2012-12-23  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (acl_set_file): If setting the file security descriptor
	fails, and the new DACL is identical to the existing one, silently
	return success.  This fixes problems for users backing up their
	own files without having the necessary privileges for setting
	security descriptors.

	* w32proc.c (reader_thread): Do not index fd_info[] with negative
	values.
	(reader_thread): Exit when cp->status becomes STATUS_READ_ERROR
	after WaitForSingleObject returns normally.  This expedites reader
	thread shutdown when delete_child triggers it.
	(reap_subprocess): More accurate commentary for why we call
	delete_child only when cp->fd is negative.

	* w32.c (sys_close): Do not call delete_child on a subprocess
	whose handle is not yet closed.  Instead, set its file descriptor
	to a negative value, so that reap_subprocess will call
	delete_child on that subprocess when its SIGCHLD arrives.
	This avoids closing handles used for communications between sys_select
	and reader_thread, which doesn't give sys_select a chance to
	notice that the process exited and invoke the SIGCHLD handler for
	it.

2012-12-23  Jan Djärv  <jan.h.d@swipnet.se>

	* nsfns.m (Fns_do_applescript): Run event loop until script has
	been executed (Bug#12969).
	(ns_run_ascript): Chech as_script for nil, set to nil after
	executing script.

2012-12-22  Martin Rudalics  <rudalics@gmx.at>

	* window.c (Fselect_window): Reword doc-string (Bug#13248).

2012-12-22  Eli Zaretskii  <eliz@gnu.org>

	* w32term.c (w32fullscreen_hook): New function.
	(w32_create_terminal): Plug it into the terminal's fullscreen_hook.

2012-12-21  Eli Zaretskii  <eliz@gnu.org>

	* fileio.c (Finsert_file_contents): Doc fix.

	* w32proc.c (new_child, delete_child, find_child_pid): For a
	subprocess, consider its slot being in use as long as its process
	handle (procinfo.hProcess) is not NULL.  This avoids reusing the
	slot when a new process is started immediately after killing
	another one, without waiting enough time for the first process to
	be reaped and resources allocated for it be orderly freed.
	(Bug#13086)
	Suggested by Fabrice Popineau <fabrice.popineau@supelec.fr>.

2012-12-21  Chong Yidong  <cyd@gnu.org>

	* buffer.c (Fset_buffer_major_mode): Doc fix (Bug#13231).

	* fns.c (Fcompare_strings): Doc fix (Bug#13081).

2012-12-21  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (get_name_and_id): Always pass NULL as the first argument
	of lookup_account_sid.  Avoids crashes with UNC file names that
	refer to DFS domains, not to specific machine names.  (Bug#12621)
	Remove now unused argument FNAME; all callers changed.
	(get_file_owner_and_group): Remove now unused argument FNAME; all
	callers changed.

2012-12-21  Chong Yidong  <cyd@gnu.org>

	* editfns.c (Finsert_char): Since read-char-by-name now signals an
	error for invalid chars, don't check for a nil return value.

2012-12-20  Dmitry Antipov  <dmantipov@yandex.ru>

	Avoid calls to CHAR_TO_BYTE if byte position is known.
	* editfns.c (make_buffer_string_both): Use move_gap_both.
	(Fbuffer_string): Use make_buffer_string_both.
	* marker.c (buf_charpos_to_bytepos): Convert to eassert.
	Adjust comment.
	(buf_bytepos_to_charpos): Likewise.
	(charpos_to_bytepos): Remove.
	* fileio.c (Finsert_file_contents): Use move_gap_both.
	* search.c (Freplace_match): Likewise.
	* process.c (process_send_region): Likewise.  Use convenient
	names for byte positions.
	* lisp.h (charpos_to_bytepos): Remove prototype.
	* indent.c (scan_for_column): Use CHAR_TO_BYTE.
	* insdel.c (move_gap): Likewise.

2012-12-20  Paul Eggert  <eggert@cs.ucla.edu>

	* xdisp.c (redisplay_internal): Remove now-unused local.

2012-12-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (select_frame_for_redisplay, ensure_selected_frame): Remove.
	(redisplay_internal): Don't bother selecting the frame to get the
	proper value of frame-local variables (bug#13225).

2012-12-20  Dmitry Antipov  <dmantipov@yandex.ru>

	* textprop.c (set_text_properties_1): Do not allow NULL interval.
	Rename 4th argument since it may be buffer or string.  Adjust comment.
	* intervals.c (graft_intervals_info_buffer): Find an interval here.

2012-12-19  Dmitry Antipov  <dmantipov@yandex.ru>

	* coding.c (Fdetect_coding_region): Do not check start and end with
	CHECK_NUMBER_COERCE_MARKER since validate_region does that itself.
	(code_convert_region): Likewise.

2012-12-18  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (acl_get_file, acl_set_file): Run the file name through
	map_w32_filename, and resolve any symlinks in the file name, like
	Posix platforms do.
	(acl_set_file): Call revert_to_self, if any privileges were
	enabled.

2012-12-17  Juanma Barranquero  <lekktu@gmail.com>

	* makefile.w32-in ($(BLD)/editfns.$(O), $(BLD)/fileio.$(O))
	($(BLD)/w32.$(O)): Update dependencies.

2012-12-17  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (select_frame_for_redisplay): Use select_window_1 to
	propagate redisplay's scrolling (if any) to the right window.
	(redisplay_internal): Use ensure_selected_frame.
	(display_mode_lines): Complete last fix.
	* window.c (select_window_1): New func, extracted from select_window.
	(select_window): Use it.
	* window.h (select_window_1): Declare.

2012-12-17  Eli Zaretskii  <eliz@gnu.org>

	Emulate Posix ACL APIs on MS-Windows.
	* w32.c: Include sddl.h and sys/acl.h.
	(SDDL_REVISION_1): Define if not already defined.
	(g_b_init_get_security_descriptor_dacl)
	(g_b_init_convert_sd_to_sddl, g_b_init_convert_sddl_to_sd)
	(g_b_init_is_valid_security_descriptor)
	(g_b_init_set_file_security): New static flags.
	(globals_of_w32): Initialize them to zero.
	(SetFileSecurity_Name): New string constant.
	(SetFileSecurity_Proc, GetSecurityDescriptorDacl_Proc)
	(ConvertStringSecurityDescriptorToSecurityDescriptor_Proc)
	(ConvertSecurityDescriptorToStringSecurityDescriptor_Proc)
	(IsValidSecurityDescriptor_Proc): New typedefs.
	(get_file_security, get_security_descriptor_owner)
	(get_security_descriptor_group): Set errno to ENOTSUP.
	(set_file_security, get_security_descriptor_dacl)
	(is_valid_security_descriptor, convert_sd_to_sddl)
	(convert_sddl_to_sd, acl_valid, acl_to_text, acl_from_text)
	(acl_free, acl_get_file, acl_set_file): New functions.

	* fileio.c (Fcopy_file) [WINDOWSNT]: Support copying ACLs.

2012-12-17  Paul Eggert  <eggert@cs.ucla.edu>

	Don't reraise SIGCHLD, as that can now lose (Bug#13192).
	With the 2012-12-03 fix for Bug#12980 in place, an old workaround
	for some of that bug's symptoms can now cause Emacs to abort.
	Remove the workaround.
	* process.c (wait_reading_process_output): Don't reraise SIGCHLD.
	The bug that caused SIGCHLD to get lost has been fixed, and the
	workaround for it can now cause Emacs to abort.

2012-12-16  Paul Eggert  <eggert@cs.ucla.edu>

	* sysdep.c (emacs_abort): Bump backtrace size to 40.
	Companion to the 2012-09-30 patch.  Suggested by Eli Zaretskii in
	<http://lists.gnu.org/archive/html/emacs-devel/2012-09/msg00796.html>.

2012-12-16  Romain Francoise  <romain@orebokech.com>

	* fileio.c (Ffile_acl, Fset_file_acl): New functions.
	(Fcopy_file): Change last arg to `preserve_extended_attributes'
	and copy ACL entries of file in addition to SELinux context if set.
	(syms_of_fileio): Add `file-acl' and `set-file-acl'.

	* Makefile.in (LIBACL_LIBS): New macro.
	(LIBES): Use it.

2012-12-15  Paul Eggert  <eggert@cs.ucla.edu>

	* fileio.c (internal_delete_file): Use bool for boolean.

2012-12-15  Eli Zaretskii  <eliz@gnu.org>

	Fix bug #13079 on MS-Windows with temp files not being deleted.
	* w32.h (_child_process): New members input_file and
	pending_deletion.
	(register_child): First argument is now pid_t.
	(record_infile, record_pending_deletion): New prototypes.

	* w32proc.c (new_child): Initialize input_file and
	pending_deletion members of the child.
	(delete_child): Delete the child's temporary input file, if any,
	that is pending deletion.
	(register_child): First argument is now pid_t.
	(record_infile, record_pending_deletion): New functions.
	(reap_subprocess): Fix a typo in DebPrint string.
	(sys_spawnve, sys_kill): Use pid_t for PID arguments.

	* fileio.c (internal_delete_file): Return an int again: non-zero
	if delete-file succeeds, zero otherwise.

	* lisp.h (internal_delete_file): Adjust prototype.

	* callproc.c (Fcall_process): Don't overwrite infile with result
	of DECODE_FILE.
	[WINDOWSNT] If BUFFER is an integer, i.e. we are launching an
	asynchronous subprocess, record the name of the input file name,
	if any.
	(delete_temp_file) [WINDOWSNT]: If internal_delete_file fails to
	delete the file, record it as pending deletion when the subprocess
	exits.

2012-12-14  Eli Zaretskii  <eliz@gnu.org>

	* editfns.c [HAVE_PWD_H]: Include grp.h.

	* makefile.w32-in ($(BLD)/editfns.$(O)): Add $(NT_INC)/grp.h.

2012-12-14  Paul Eggert  <eggert@cs.ucla.edu>

	Fix permissions bugs with setgid directories etc.  (Bug#13125)
	* dired.c (Ffile_attributes): Return t as the 9th attribute,
	to mark it as a placeholder.  The old value was often wrong.
	The only user of this attribute has been changed to use
	file-ownership-preserved-p instead, with its new group arg.
	* editfns.c (Fgroup_gid, Fgroup_real_gid): New functions.

2012-12-14  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (select_frame_for_redisplay, display_mode_lines):
	Keep selected_window and selected_frame in sync.

2012-12-14  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (stat_worker): If w32_stat_get_owner_group is zero, do not
	try to get accurate owner and group information from NT file
	security APIs.  This is to make most callers of 'stat' and
	'lstat', which don't need that information, much faster.

	* dired.c (Ffile_attributes) [WINDOWSNT]:
	Set w32_stat_get_owner_group to a non-zero value, to request accurate
	owner and group information from 'lstat'.

2012-12-13  Paul Eggert  <eggert@cs.ucla.edu>

	* fileio.c (Finsert_file_contents): Don't put tail into head area,
	as that confuses set-auto-coding, so insist on the head-read
	returning the full 1024 bytes.  Let lseek compute the tail offset;
	less work for us.  Do not ignore I/O errors when reading the tail.

	* xdisp.c: Minor style fixes.
	(init_iterator): Hoist assignment out of if-expression.
	(markpos_of_region): Callers now test for sign, not for -1.

2012-12-13  Dmitry Antipov  <dmantipov@yandex.ru>

	Minor redisplay optimization when the region length is zero.
	* xdisp.c (markpos_of_region): New function.
	(init_iterator): Do not highlight the region of zero length.
	(redisplay_window): Check whether the region is of non-zero length.
	(try_cursor_movement): Allow if the region length is zero.
	(try_window_reusing_current_matrix, try_window_id): Likewise.

2012-12-13  Eli Zaretskii  <eliz@gnu.org>

	* search.c (search_buffer): Check the inverse translations of each
	character in pattern when the buffer being searched is unibyte.
	(Bug#13084)

2012-12-13  Paul Eggert  <eggert@cs.ucla.edu>

	* fileio.c (Fvisited_file_modtime): Return (-1 ...) for nonexistent
	files, fixing a regression from 24.2.
	(Fverify_visited_file_modtime): Don't read uninitialized st.st_size.

2012-12-13  Paul Eggert  <eggert@cs.ucla.edu>

	* fileio.c (Fcopy_file): Make fstat failure as serious as open failure.
	fstat shouldn't fail, and if it does fail copy-file should not proceed.
	Remove unnecessary S_ISLNK test, as (contra the comments) this
	function can't copy symlinks.  Improve quality of error message
	when attempting to copy files that are neither regular files nor
	directories.

2012-12-12  Dmitry Antipov  <dmantipov@yandex.ru>

	* dispnew.c (set_window_cursor_after_update): Use clip_to_bounds.
	* gtkutil.c (xg_set_toolkit_scroll_bar_thumb):
	* window.c (Frecenter):
	* xdisp.c (resize_mini_window, hscroll_window_tree, draw_glyphs):
	* xterm.c (x_set_toolkit_scroll_bar_thumb): Likewise.

2012-12-12  Daniel Colascione  <dancol@dancol.org>

	* unexcw.c (fixup_executable): Use posix_fallocate to ensure that
	the dumped Emacs is not a sparse file, greatly improving Cygwin
	"make bootstrap" performance.

2012-12-11  Michael Albinus  <michael.albinus@gmx.de>

	* inotify.c (inotify_callback): Generate an Emacs event for every
	incoming inotify event.

2012-12-11  Eli Zaretskii  <eliz@gnu.org>

	* xdisp.c (handle_face_prop): Fix logic of computing
	it->start_of_box_run_p.
	(append_space_for_newline): If the glyph row is R2L, reset the
	iterator's end_of_box_run_p flag before prepending the space glyph.
	(extend_face_to_end_of_line): If the glyph row is R2L, reset the
	iterator's start_of_box_run_p flag before prepending the stretch.
	(append_glyph, produce_image_glyph, append_composite_glyph)
	(append_stretch_glyph, append_glyphless_glyph): Reverse the
	left_box_line_p and right_box_line_p flags of the glyph for R2L
	glyph rows.  (Bug#13011)

2012-12-11  Dmitry Antipov  <dmantipov@yandex.ru>

	* buffer.c (Fset_buffer_multibyte): Do not force redisplay
	if changed buffer is not shown in a window.
	* insdel.c (prepare_to_modify_buffer): Likewise.
	* window.c (replace_buffer_in_windows_safely): Do nothing
	if buffer is not shown in a window.
	(Fforce_window_update): Likewise if string or buffer argument
	is passed.

2012-12-11  Eli Zaretskii  <eliz@gnu.org>

	* inotify.c (Finotify_add_watch): Rename decoded_file_name to
	encoded_file_name, which is what it is.

2012-12-11  Dmitry Antipov  <dmantipov@yandex.ru>

	Consistently use marker_position and marker_byte_position.
	* fringe.c (Ffringe_bitmaps_at_pos):
	* indent.c (Fvertical_motion):
	* insdel.c (prepare_to_modify_buffer):
	* keyboard.c (make_lispy_position):
	* window.c (Fwindow_end, Fpos_visible_in_window_p, unshow_buffer)
	(window_scroll_pixel_based, displayed_window_lines)
	(Fset_window_configuration):
	* xdisp.c (message_dolog, with_echo_area_buffer_unwind_data)
	(mark_window_display_accurate_1, redisplay_window, decode_mode_spec):
	Replace direct access to marker fields with calls
	to marker_position and/or marker_byte_position.

2012-12-11  Juanma Barranquero  <lekktu@gmail.com>

	* makefile.w32-in (SIG2STR_H): New macro.
	(SYSWAIT_H, $(BLD)/emacs.$(O), $(BLD)/process.$(O))
	($(BLD)/w32notify.$(O)): Update dependencies.

2012-12-10  Daniel Colascione  <dancol@dancol.org>

	* w32term.c, keyboard.c: Fix build break in cygw32 by omitting
	Windows file notification functionality unless WINDOWSNT.

	* w32gui.h (hprevinst, lpCmdLine, nCmdShow): Remove unused
	declarations.

	* w32fns.c (cache_system_info): Initialize the global hinst
	variable here so various initialization calls DTRT.

	* unexw32.c (hprevinst, lpCmdLine, nCmdShow): Remove unused variables.
	(hinst): Remove unneeded extern declaration.
	(_start): Remove initialization of above variables; remove
	initialization of hinst, as cache_system_info now does that.

	* emacs.c (main): Call cache_system_info early in startup; we
	previously weren't calling it in Cygwin builds.

	* Makefile.in (ntsource, WINDRES, W32_RES, W#@_RES_LINK):
	Teach the autoconf build system how to compile a Windows resource file
	and link it to Emacs.

2012-12-10  Dmitry Antipov  <dmantipov@yandex.ru>

	Per-buffer window counters.
	* buffer.h (struct buffer): New member window_count.
	(buffer_window_count): New function.
	* buffer.c (Fget_buffer_create, Fmake_indirect_buffer):
	Initialize window_count.
	(Fkill_buffer): Verify window_count for the buffer being killed.
	(modify_overlay): Do not force redisplay if buffer is not shown
	in any window.
	(init_buffer_once): Initialize window_count for buffer_defaults
	and buffer_local_symbols.
	* window.h (buffer_shared): Remove declaration.
	(wset_buffer): Convert from inline ...
	* window.c (wset_buffer): ... to an ordinary function.
	(adjust_window_count): New function.
	(make_parent_window): Use it.
	* xdisp.c (buffer_shared): Remove.
	(redisplay_internal, redisplay_window): Adjust users.
	(buffer_shared_and_changed): Use per-buffer window counter.

2012-12-10  Eli Zaretskii  <eliz@gnu.org>

	Support for filesystem notifications on MS-Windows.
	* w32proc.c (sys_select): If drain_message_queue returns non-zero,
	and this is a TTY frame, signal the caller that keyboard input is
	available.

	* w32xfns.c (drain_message_queue): Now returns an int: an
	indication whether any WM_EMACS_FILENOTIFY messages were found in
	the queue.

	* w32inevt.c (handle_file_notifications): New function.
	(w32_console_read_socket): Call it to process file notifications.

	* w32console.c (initialize_w32_display): Record the main thread ID
	in dwMainThreadId.

	* deps.mk (inotify.o): New dependency list.

	* Makefile.in (SOME_MACHINE_OBJECTS): Add w32notify.o.

	* w32term.h (WM_EMACS_FILENOTIFY): New custom message.
	(WM_EMACS_END): Bump value by 1.
	(notification_buffer_in_use, file_notifications)
	(notifications_size, notifications_desc): Declare.
	(w32_get_watch_object, lispy_file_action, globals_of_w32notify):
	Add prototypes.

	* w32term.c (lispy_file_action, queue_notifications): New functions.
	(syms_of_w32term) <Qadded, Qremoved, Qmodified, Qrenamed_from>
	<Qrenamed_to>: New symbols.
	(w32_read_socket): Handle the WM_EMACS_FILENOTIFY message.

	* w32notify.c: New file, implements file event notifications for
	MS-Windows.

	* w32fns.c (w32_wnd_proc): Handle the WM_EMACS_FILENOTIFY message
	by posting it to the w32_read_socket queue.

	* termhooks.h (enum event_kind) [HAVE_NTGUI]: Support FILE_NOTIFY_EVENT.

	* makefile.w32-in (OBJ2): Add $(BLD)/w32notify.$(O).
	(GLOBAL_SOURCES): Add w32notify.c
	($(BLD)/w32notify.$(O)): New set of dependencies.

	* lisp.h (syms_of_w32notify) [WINDOWSNT]: Add prototype.

	* keyboard.c (kbd_buffer_get_event) [WINDOWSNT]:
	Handle FILE_NOTIFY_EVENT.
	(syms_of_keyboard) [HAVE_NTGUI] <Qfile_notify>: New symbol.
	(keys_of_keyboard) [WINDOWSNT]: Bind file-notify to
	w32notify-handle-event by default.

	* emacs.c (main) [WINDOWSNT]: Call globals_of_w32notify and
	syms_of_w32notify.

2012-12-10  Rüdiger Sonderfeld  <ruediger@c-plusplus.de>

	Support for filesystem notifications on GNU/Linux via inotify.
	* termhooks.h (enum event_kind) [HAVE_INOTIFY]: Add FILE_NOTIFY_EVENT.

	* lisp.h (syms_of_inotify) [HAVE_INOTIFY]: Add prototype.

	* keyboard.c (Qfile_inotify) [HAVE_INOTIFY]: New variable.
	(syms_of_keyboard): DEFSYM it.
	(kbd_buffer_get_event) [HAVE_INOTIFY]: Generate FILE_NOTIFY_EVENT.
	(make_lispy_event): Support FILE_NOTIFY_EVENT by generating
	Qfile_inotify events.
	(keys_of_keyboard) [HAVE_INOTIFY]: Bind file-inotify events in
	special-event-map to inotify-handle-event.

	* emacs.c (main) [HAVE_INOTIFY]: Call syms_of_inotify.

	* Makefile.in (base_obj): Add inotify.o.

	* inotify.c: New file.

2012-12-10  Jan Djärv  <jan.h.d@swipnet.se>

	* nsterm.m (fd_handler:): FD_ZERO fds (Bug#13103).

2012-12-10  Fabrice Popineau  <fabrice.popineau@gmail.com>

	* w32fns.c (cache_system_info): Cast sysinfo_cache.dwPageSize to
	DWORD_PTR, for compatibility with 64-bit builds.

	* w32.c (_PROCESS_MEMORY_COUNTERS_EX):
	(GetProcessWorkingSetSize_Proc, get_process_working_set_size)
	(system_process_attributes): Use SIZE_T rather than DWORD, for
	compatibility with 64-bit builds.

2012-12-10  Christopher Schmidt  <christopher@ch.ristopher.com>

	* lread.c (Vload_source_file_function): Doc fix (Bug#11647).

2012-12-10  Eli Zaretskii  <eliz@gnu.org>

	* indent.c (Fvertical_motion): If a display string will be
	displayed on the left or the right margin, don't consider it as a
	factor in cursor positioning.  (Bug#13108)

2012-12-10  Martin Rudalics  <rudalics@gmx.at>

	* editfns.c (Fcompare_buffer_substrings): Reword doc-string.

2012-12-10  Paul Eggert  <eggert@cs.ucla.edu>

	* fileio.c (Fsubstitute_in_file_name): Use ptrdiff_t, not int,
	for string length.

2012-12-08  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (unsetenv): Return 0 if the input string is too long.

2012-12-08  Paul Eggert  <eggert@cs.ucla.edu>

	Use putenv+unsetenv instead of modifying environ directly (Bug#13070).
	* alloc.c (xputenv): New function.
	* dbusbind.c (Fdbus_init_bus):
	* emacs.c (main):
	* xterm.c (x_term_init):
	Use xputenv instead of setenv or putenv, to detect memory exhaustion.
	* editfns.c (initial_tz): Move static var decl up.
	(tzvalbuf_in_environ): New static var.
	(init_editfns): Initialize these two static vars.
	(Fencode_time): Don't assume arbitrary limit on EMACS_INT width.
	Save old TZ value on stack, if it's small.
	(Fencode_time, set_time_zone_rule): Don't modify 'environ' directly;
	instead, use xputenv+unsetenv to set and restore TZ.
	(environbuf): Remove static var.  All uses removed.
	(Fset_time_zone_rule): Do not save TZ and environ;
	no longer needed here.
	(set_time_zone_rule_tz1, set_time_zone_rule_tz2) [LOCALTIME_CACHE]:
	Move to inside set_time_zone_rule; they don't need file scope any more.
	(set_time_zone_rule): Maintain the TZ=value string separately.
	(syms_of_editfns): Don't initialize initial_tz;
	init_editfns now does it.
	* emacs.c (dump_tz) [HAVE_TZSET]: Now const.
	* lisp.h (xputenv): New decl.

2012-12-08  Fabrice Popineau  <fabrice.popineau@gmail.com>

	* w32fns.c (emacs_abort): Don't do arithmetic on void pointers.

2012-12-08  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (unsetenv, sys_putenv): New functions.

2012-12-08  Chong Yidong  <cyd@gnu.org>

	* editfns.c (Finsert_char): Make the error message more
	informative (Bug#12992).

2012-12-08  Paul Eggert  <eggert@cs.ucla.edu>

	Simplify get_lim_data.
	* vm-limit.c (get_lim_data): Combine RLIMIT_AS and RLIMIT_DATA methods.
	Remove USG and vlimit methods; no longer used these days.
	Add #error catchall just in case.

	Assume POSIX 1003.1-1988 or later for signal.h (Bug#13026).
	Exceptions: do not assume SIGCONT, SIGSTOP, SIGTSTP, SIGTTIN,
	SIGTTOU, SIGUSR1, SIGUSR2, as Microsoft platforms lack these.
	* process.c [subprocesses]: Include <c-ctype.h>, <sig2str.h>.
	(deleted_pid_list, Fdelete_process, create_process)
	(record_child_status_change, handle_child_signal, deliver_child_signal)
	(init_process_emacs, syms_of_process):
	Assume SIGCHLD is defined.
	(parse_signal): Remove.  All uses removed.
	(abbr_to_signal): New static function.
	(Fsignal_process): Use it to convert signal names to ints.
	* sysdep.c (sys_suspend) [!DOS_NT]: Use kill (0, ...) rather than
	kill (getpgrp (), ...).
	(emacs_sigaction_init): Assume SIGCHLD is defined.
	(init_signals): Assume SIGALRM, SIGCHLD, SIGHUP, SIGKILL,
	SIGPIPE, and SIGQUIT are defined.  Do not worry about SIGCLD any more.
	* syssignal.h (EMACS_KILLPG): Remove.
	All uses replaced by 'kill' with a negative pid.
	(SIGCHLD): Remove definition, as we now assume SIGCHLD.
	* w32proc.c (sys_kill): Support negative pids compatibly with POSIX.

2012-12-07  Paul Eggert  <eggert@cs.ucla.edu>

	* sysdep.c (get_child_status): Abort on internal error (Bug#13086).
	This will cause a production Emacs to dump core instead of
	infinite-looping.

2012-12-07  Dmitry Antipov  <dmantipov@yandex.ru>

	* frame.c (make_frame): Do not set window's buffer to t.
	* window.c (Fsplit_window_internal): Likewise.  Previously it was
	used to indicate that the window is being set up.  Now we use
	set_window_buffer for all new windows, so the condition in ...
	(Fset_window_buffer): ... is always true and can be removed.

2012-12-07  Dmitry Antipov  <dmantipov@yandex.ru>

	Convenient macro to check whether the buffer is hidden.
	* buffer.h (BUFFER_HIDDEN_P): New macro.
	* frame.c (make_frame): Use it.  Adjust comment.
	* buffer.c (candidate_buffer): New function.
	(Fother_buffer, other_buffer_safely): Use it.

2012-12-06  Eli Zaretskii  <eliz@gnu.org>

	* w32proc.c (waitpid): Avoid busy-waiting when called with WNOHANG
	if the child process is still running.  Instead, exit the wait
	loop and return zero.  (Bug#13086)

2012-12-06  Dmitry Antipov  <dmantipov@yandex.ru>

	* frame.h (x_char_width, x_char_height): Remove prototypes.
	* w32term.h (x_char_width, x_char_height): Likewise.
	* xfns.c (x_char_width, x_char_height): Remove.
	* w32fns.c (x_char_width, x_char_height): Likewise.
	* nsfns.m (x_char_width, x_char_height): Likewise.
	* frame.c (Fframe_char_width): Use FRAME_COLUMN_WIDTH for
	all window frames.
	(Fframe_char_height): Likewise with FRAME_LINE_HEIGHT.
	* keyboard.c (command_loop_1): Remove prototype.
	(command_loop_2, top_level_1): Add static to match prototype.

2012-12-06  Paul Eggert  <eggert@cs.ucla.edu>

	Fix a recently-introduced delete-process race condition.
	* callproc.c, process.h (record_kill_process):
	New function, containing part of the old call_process_kill.
	(call_process_kill): Use it.
	This does not change call_process_kill's behavior.
	* process.c (Fdelete_process): Use record_kill_process to fix a
	race condition that could cause Emacs to lose track of a child.

2012-12-06  Dmitry Antipov  <dmantipov@yandex.ru>

	Avoid code duplication between prev_frame and next_frame.
	* frame.c (candidate_frame): New function.  Add comment.
	(prev_frame, next_frame): Use it.  Adjust comment.

2012-12-06  Eli Zaretskii  <eliz@gnu.org>

	* callproc.c (Fcall_process_region) [!HAVE_MKSTEMP]: If mktemp
	fails, signal an error instead of continuing with an empty
	string.  (Bug#13079)
	Encode expanded temp file pattern before passing it to mkstemp or
	mktemp.

	* fileio.c (file_name_as_directory, directory_file_name) [DOS_NT]:
	Encode the file name before passing it to dostounix_filename, in
	case it will downcase it (under w32-downcase-file-names).
	(Bug#12933)

2012-12-05  Paul Eggert  <eggert@cs.ucla.edu>

	Minor call-process cleanups.
	* callproc.c (Fcall_process): Do record-unwind-protect on MSDOS
	at the same time as other platforms, to simplify analysis.
	No need for fd0_volatile since we have synch_process_fd.
	Avoid needless emacs_close; arg is always negative.

2012-12-04  Andreas Schwab  <schwab@linux-m68k.org>

	* callproc.c (Fcall_process): Fix specpdl nesting for asynchronous
	processes.

2012-12-04  Dmitry Antipov  <dmantipov@yandex.ru>

	* lisp.h (Mouse_HLInfo): Remove set-but-unused mouse_face_image_state
	member.  Adjust users.  Convert mouse_face_past_end, mouse_face_defer
	and mouse_face_hidden members to a bitfields.
	* frame.h (struct frame): Remove set-but-not-used space_width member.
	(FRAME_SPACE_WIDTH): Remove.
	* nsterm.m, w32term.c, xterm.c: Adjust users.
	* termchar.h (struct tty_display_info): Remove set-but-unused se_is_so
	member.  Adjust users.  Convert term_initted, delete_in_insert_mode,
	costs_set, insert_mode, standout_mode, cursor_hidden and flow_control
	members to a bitfields.

2012-12-03  Paul Eggert  <eggert@cs.ucla.edu>

	Don't let call-process be a zombie factory (Bug#12980).
	Fixing this bug required some cleanup of the signal-handling code.
	As a side effect, this change also fixes a longstanding rare race
	condition whereby Emacs could mistakenly kill unrelated processes,
	and it fixes a bug where a second C-g does not kill a recalcitrant
	synchronous process in GNU/Linux and similar platforms.
	The patch should also fix the last vestiges of Bug#9488,
	a bug which has mostly been fixed on the trunk by other changes.
	* callproc.c, process.h (synch_process_alive, synch_process_death)
	(synch_process_termsig, sync_process_retcode):
	Remove.  All uses removed, to simplify analysis and so that
	less consing is done inside critical sections.
	* callproc.c (call_process_exited): Remove.  All uses replaced
	with !synch_process_pid.
	* callproc.c (synch_process_pid, synch_process_fd): New static vars.
	These take the role of what used to be in unwind-protect arg.
	All uses changed.
	(block_child_signal, unblock_child_signal):
	New functions, to avoid races that could kill innocent-victim processes.
	(call_process_kill, call_process_cleanup, Fcall_process): Use them.
	(call_process_kill): Record killed processes as deleted, so that
	zombies do not clutter up the system.  Do this inside a critical
	section, to avoid a race that would allow the clutter.
	(call_process_cleanup): Fix code so that the second C-g works again
	on common platforms such as GNU/Linux.
	(Fcall_process): Create the child process in a critical section,
	to fix a race condition.  If creating an asynchronous process,
	record it as deleted so that zombies do not clutter up the system.
	Do unwind-protect for WINDOWSNT too, as that's simpler in the
	light of these changes.  Omit unnecessary call to emacs_close
	before failure, as the unwind-protect code does that.
	* callproc.c (call_process_cleanup):
	* w32proc.c (waitpid): Simplify now that synch_process_alive is gone.
	* process.c (record_deleted_pid): New function, containing
	code refactored out of Fdelete_process.
	(Fdelete_process): Use it.
	(process_status_retrieved): Remove.  All callers changed to use
	child_status_change.
	(record_child_status_change): Remove, folding its contents into ...
	(handle_child_signal): ... this signal handler.  Now, this
	function is purely a handler for SIGCHLD, and is not called after
	a synchronous waitpid returns; the synchronous code is moved to
	wait_for_termination.  There is no need to worry about reaping
	more than one child now.
	* sysdep.c (get_child_status, child_status_changed): New functions.
	(wait_for_termination): Now takes int * status and bool
	interruptible arguments, too.  Do not record child status change;
	that's now the caller's responsibility.  All callers changed.
	Reimplement in terms of get_child_status.
	(wait_for_termination_1, interruptible_wait_for_termination):
	Remove.  All callers changed to use wait_for_termination.
	* syswait.h: Include <stdbool.h>, for bool.
	(record_child_status_change, interruptible_wait_for_termination):
	Remove decls.
	(record_deleted_pid, child_status_changed): New decls.
	(wait_for_termination): Adjust to API changes noted above.

	* bytecode.c, lisp.h (Qbytecode): Remove.
	No longer needed after 2012-11-20 interactive-p changes.

2012-12-03  Eli Zaretskii  <eliz@gnu.org>

	* xdisp.c (redisplay_window): If the cursor is visible, but inside
	the scroll margin, move point outside the margin.  (Bug#13055)

2012-12-03  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (my_log_handler): New function.
	(xg_set_geometry): Set log handler to my_log_handler (Bug#11177).

2012-12-03  Dmitry Antipov  <dmantipov@yandex.ru>

	* lisp.h (modify_region): Rename to...
	(modify_region_1): ...new prototype.
	* textprop.c (modify_region): Now static.  Adjust users.
	* insdel.c (modify_region): Rename to...
	(modify_region_1): ...new function to work with current buffer.
	Adjust comment and users.  Use true and false for booleans.

2012-12-03  Dmitry Antipov  <dmantipov@yandex.ru>

	* alloc.c (free_save_value): New function.
	(safe_alloca_unwind): Use it.
	* lisp.h (free_save_value): New prototype.
	* editfns.c (save_excursion_save): Use Lisp_Misc_Save_Value.
	Add comment.
	(save_excursion_restore): Adjust to match saved data structure.
	Use free_save_value to offload some work from GC.  Drop obsolete
	#if 0 code.

2012-12-03  Chong Yidong  <cyd@gnu.org>

	* fileio.c (Vauto_save_list_file_name): Doc fix.

2012-12-03  Fabrice Popineau  <fabrice.popineau@gmail.com>

	* w32fns.c: Remove prototype of atof.
	(syspage_mask): Make it DWORD_PTR, for compatibility with 64-bit
	builds.
	(file_dialog_callback): Make it UINT_PTR.

	* w32common.h (syspage_mask): Declare DWORD_PTR, for compatibility
	with 64-bit builds.

	* w32.c (FILE_DEVICE_FILE_SYSTEM, METHOD_BUFFERED)
	(FILE_ANY_ACCESS, CTL_CODE) [_MSC_VER]: Define only if not already
	defined.

2012-12-03  Glenn Morris  <rgm@gnu.org>

	* data.c (Fboundp, Fsymbol_value): Doc fix re lexical-binding.

2012-12-02  Paul Eggert  <eggert@cs.ucla.edu>

	Fix xpalloc confusion after memory is exhausted.
	* alloc.c (xpalloc): Comment fix.
	* charset.c (Fdefine_charset_internal): If xpalloc exhausts memory
	and signals an error, do not clear charset_table_size, as
	charset_table is still valid.
	* doprnt.c (evxprintf): Clear *BUF after freeing it.

	Use execve to avoid need to munge environ (Bug#13054).
	* callproc.c (Fcall_process):
	* process.c (create_process):
	Don't save and restore environ; no longer needed.
	* callproc.c (child_setup):
	Use execve, not execvp, to preserve environ.

2012-12-01  Paul Eggert  <eggert@cs.ucla.edu>

	* xterm.c (x_draw_image_relief): Remove unused locals (Bug#10500).

2012-12-01  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* xterm.c (x_draw_relief_rect, x_draw_image_relief): Fix relief
	display for sliced images (Bug#10500).

	* w32term.c (w32_draw_relief_rect, x_draw_image_relief): Likewise.

2012-11-30  Juanma Barranquero  <lekktu@gmail.com>

	* doc.c (Fdocumentation): Re-add handling of function-documentation,
	accidentally removed in 2012-11-09T04:10:16Z!monnier@iro.umontreal.ca (bug#13034).

2012-11-29  Dmitry Antipov  <dmantipov@yandex.ru>

	* xdisp.c (window_outdated): Remove eassert since it hits
	some suspicious corner cases (see Bug#13007 and Bug#13012).
	(mode_line_update_needed): New function.
	(redisplay_internal, redisplay_window): Use it.
	(ensure_selected_frame): New function.
	(redisplay_internal, unwind_redisplay): Use it.
	(redisplay_internal): Move comment about buffer_shared...
	(buffer_shared_and_changed): ...near to its real use.

2012-11-29  Paul Eggert  <eggert@cs.ucla.edu>

	* callproc.c (Fcall_process): Don't misreport vfork failure.

2012-11-28  Paul Eggert  <eggert@cs.ucla.edu>

	* callproc.c (Fcall_process): Fix vfork portability problems.
	Do not assume that fd[0], count, filefd, and save_environ survive
	vfork.  Fix bug whereby wrong errno value could be reported for
	pipe failure.  Some minor cleanups, too, as follows.  Move buf and
	bufsize to the context where they're needed.  Change new_argv to
	be of type char **, as this is more convenient and avoids casts.
	(CALLPROC_BUFFER_SIZE_MIN, CALLPROC_BUFFER_SIZE_MAX):
	Now local constants, not macros.

2012-11-18  Kenichi Handa  <handa@gnu.org>

	* font.c (font_unparse_xlfd): Fix previous change.  Keep "const"
	for the variable "f".

2012-11-13  Kenichi Handa  <handa@gnu.org>

	* font.c (font_unparse_xlfd): Exclude special characters from the
	generating XLFD name.

2012-11-27  Paul Eggert  <eggert@cs.ucla.edu>

	Assume POSIX 1003.1-1988 or later for grp.h, pwd.h.
	* dired.c (stat_uname, stat_gname):
	* fileio.c (Fexpand_file_name): Remove no-longer-needed casts.

	Assume POSIX 1003.1-1988 or later for errno.h (Bug#12968).
	* dired.c (directory_files_internal, file_name_completion):
	Assume EAGAIN and EINTR are defined.

	* fileio.c (Fcopy_file): Assume EISDIR is defined.
	* gmalloc.c (ENOMEM, EINVAL): Assume they're defined.
	* gnutls.c (emacs_gnutls_write): Assume EAGAIN is defined.
	* lread.c (readbyte_from_file): Assume EINTR is defined.
	* process.c (wait_reading_process_output, send_process) [subprocesses]:
	Assume EIO and EAGAIN are defined.
	* unexcoff.c (write_segment): Assume EFAULT is defined.

2012-11-27  Eli Zaretskii  <eliz@gnu.org>

	* fontset.c (Finternal_char_font): Return nil on non-GUI frames.
	(Bug#11964)

	* xdisp.c (draw_glyphs): Don't draw in mouse face if mouse
	highlighting on the frame was cleared.  Prevents assertion
	violations when repeatedly clicking on the "Top" link of the
	"bread-crumbs" in Info buffers.

2012-11-25  Paul Eggert  <eggert@cs.ucla.edu>

	* sysdep.c (sys_subshell): Don't assume pid_t fits in int.

2012-11-24  Ken Brown  <kbrown@cornell.edu>

	* keyboard.c (HAVE_MOUSE):
	* frame.c (HAVE_MOUSE): Remove, and rewrite code as if HAVE_MOUSE
	were always defined.

2012-11-24  Eli Zaretskii  <eliz@gnu.org>

	* xdisp.c (set_cursor_from_row): Skip step 2 only if point is not
	between bpos_covered and bpos_max.  This fixes cursor display when
	several display strings follow each other.

	* .gdbinit (pgx): If the glyph's object is a string, display the
	pointer to string data, rather than the value of the string object
	itself (which barfs under CHECK_LISP_OBJECT_TYPE).

	* indent.c (Fvertical_motion): If the starting position is covered
	by a display string, return to one position before that, to avoid
	overshooting it inside move_it_to.  (Bug#12930)

2012-11-23  Dmitry Antipov  <dmantipov@yandex.ru>

	* frame.h (struct frame): Remove display_preempted member
	since all users are dead long ago.
	* nsterm.h (struct x_output): Use the only dummy member.
	* w32menu.c (pending_menu_activation): Remove since not
	really used.
	(set_frame_menubar): Adjust user.
	* w32term.h (struct x_output): Drop outdated #if 0 code.
	(struct w32_output): Use bitfields for explicit_parent,
	asked_for_visible and menubar_active members.
	Drop unused pending_menu_activation member.
	* xterm.h (struct x_output): Drop outdated #if 0 code.
	Use bitfields for explicit_parent, asked_for_visible,
	has_been_visible and net_wm_state_hidden_seen members.

2012-11-23  Eli Zaretskii  <eliz@gnu.org>

	* makefile.w32-in (globals.h, gl-stamp): Use $(SWITCHCHAR) instead
	of a literal "/".  (Bug#12955)
	(gl-stamp): Invoke fc.exe directly, not through cmd.

2012-11-23  Paul Eggert  <eggert@cs.ucla.edu>

	Assume POSIX 1003.1-1988 or later for dirent.h (Bug#12958).
	* dired.c: Assume HAVE_DIRENT_H.
	(NAMLEN): Remove, replacing with ...
	(dirent_namelen): New function.  All uses changed.  Use the GNU macro
	_D_EXACT_NAMELEN if available, as it's faster than strlen.
	(DIRENTRY): Remove, replacing all uses with 'struct dirent'.
	(DIRENTRY_NONEMPTY): Remove.  All callers now assume it's nonzero.
	* makefile.w32-in (DIR_H): Remove.  All uses replaced with
	$(NT_INC)/dirent.h.
	($(BLD)/w32.$(O)): Do not depend on $(SRC)/ndir.h.
	* ndir.h: Rename to ../nt/inc/dirent.h.
	* sysdep.h (closedir) [!HAVE_CLOSEDIR]: Remove.
	Do not include <dirent.h>; no longer needed.
	* w32.c: Include <dirent.h> rather than "ndir.h".

2012-11-23  Chong Yidong  <cyd@gnu.org>

	* xftfont.c (xftfont_open): Remove duplicate assignment.

2012-11-22  Dmitry Antipov  <dmantipov@yandex.ru>

	* alloc.c (Fgarbage_collect): Unblock input after clearing
	gc_in_progress to avoid note_mouse_highlight glitch with GC.
	* frame.h (FRAME_MOUSE_UPDATE): New macro.
	* msdos.c (IT_frame_up_to_date): Use it here...
	* w32term.c (w32_frame_up_to_date): ...here...
	* xterm.c (XTframe_up_to_date): ...and here...
	* nsterm.m (ns_frame_up_to_date): ...but not here.
	* lisp.h (Mouse_HLInfo): Remove mouse_face_deferred_gc member.
	Adjust users.
	* xdisp.c (message2_nolog, message3_nolog, note_mouse_highlight):
	Do not check whether GC is in progress.

2012-11-22  Dmitry Antipov  <dmantipov@yandex.ru>

	* xdisp.c (window_buffer_changed): New function.
	(update_menu_bar, update_tool_bar): Use it to
	simplify large 'if' statements.
	(redisplay_internal): Generalize commonly used
	'tail' and 'frame' local variables.

2012-11-22  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (getcwd): Fix the 2nd argument type, to prevent conflicts
	with Windows system header.

2012-11-21  Paul Eggert  <eggert@cs.ucla.edu>

	Assume POSIX 1003.1-1988 or later for unistd.h (Bug#12945).
	* alloc.c: Assume unistd.h exists.
	* fileio.c (Fexpand_file_name) [DOS_NT]: Use getcwd, not getwd.
	* sysdep.c (get_current_dir_name): Assume getcwd exists.
	(getwd) [USG]: Remove; no longer needed.
	(sys_subshell) [DOS_NT]: Use getcwd, not getwd.
	* w32.c (getcwd): Rename from getwd, and switch to getcwd's API.
	* w32.h (getcwd): Remove decl.

2012-11-21  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (fast_set_selected_frame): Rename from update_tool_bar_unwind.
	Make it set selected_window as well.
	(update_tool_bar): Use it.

2012-11-21  Ken Brown  <kbrown@cornell.edu>

	* emacs.c (main): Set the G_SLICE environment variable for all
	Cygwin builds, not just GTK builds.  See
	https://lists.gnu.org/archive/html/emacs-devel/2012-11/msg00368.html.

2012-11-21  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (FILE_DEVICE_FILE_SYSTEM, METHOD_BUFFERED)
	(FILE_ANY_ACCESS, CTL_CODE, FSCTL_GET_REPARSE_POINT) [_MSC_VER]:
	Define for the MSVC compiler.

	* w32term.h (EnumSystemLocalesW) [_MSC_VER]: Add a missing semi-colon.

	* fileio.c (Fsubstitute_in_file_name, Ffile_name_directory)
	(Fexpand_file_name) [DOS_NT]: Pass encoded file name to
	dostounix_filename.  Prevents crashes down the road, because
	dostounix_filename assumes it gets a unibyte string.
	Reported by Michel de Ruiter <michel@sentient.nl>, see
	http://lists.gnu.org/archive/html/help-emacs-windows/2012-11/msg00017.html

2012-11-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	Conflate Qnil and Qunbound for `symbol-function'.
	* alloc.c (Fmake_symbol): Initialize `function' to Qnil.
	* lread.c (init_obarray): Set `function' fields to Qnil.
	* eval.c (Fcommandp): Ignore Qunbound.
	(Fautoload, eval_sub, Fapply, Ffuncall, Fmacroexpand):
	* data.c (Ffset, Ffboundp, indirect_function, Findirect_function):
	Test NILP rather than Qunbound.
	(Ffmakunbound): Set to Qnil.
	(Fsymbol_function): Never signal an error.
	(Finteractive_form): Ignore Qunbound.

2012-11-20  Paul Eggert  <eggert@cs.ucla.edu>

	* eval.c (interactive_p): Remove no-longer-used decl.

2012-11-20  Dmitry Antipov  <dmantipov@yandex.ru>

	* xdisp.c (buffer_shared): Adjust comment.
	(buffer_shared_and_changed): New function.
	(prepare_menu_bars, redisplay_internal): Use it to
	decide whether all windows or frames should be updated.
	(window_outdated): New function.
	(text_outside_line_unchanged_p, redisplay_window): Use it.
	(redisplay_internal): Likewise.  Fix indentation.

2012-11-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* eval.c (Finteractive_p, Fcalled_interactively_p, interactive_p): Remove.
	(syms_of_eval): Remove corresponding defsubr.
	* bytecode.c (exec_byte_code): `interactive-p' is now a Lisp function.

2012-11-19  Daniel Colascione  <dancol@dancol.org>

	* w32fns.c (Fx_file_dialog):
	(Fx_file_dialog): Accommodate rename of cygwin_convert_path* to
	cygwin_convert_file_name*.

	* cygw32.c (Fcygwin_convert_path_to_windows, syms_of_cygw32):
	Rename cygwin_convert_path* to cygwin_convert_file_name*.

2012-11-18  Paul Eggert  <eggert@cs.ucla.edu>

	* nsterm.m (ns_select): Send SIGIO only to self, not to process group.

2012-11-18  Eli Zaretskii  <eliz@gnu.org>

	* w32select.c: Include w32common.h before w32term.h, so that
	windows.h gets included before w32term.h uses some of its
	features, see below.

	* w32term.h (LOCALE_ENUMPROCA, LOCALE_ENUMPROCW) [_MSC_VER]:
	New typedefs.
	(EnumSystemLocalesA, EnumSystemLocalesW) [_MSC_VER]:
	New prototypes.
	(EnumSystemLocales) [_MSC_VER]: Define if undefined.  (Bug#12878)

2012-11-18  Jan Djärv  <jan.h.d@swipnet.se>

	* nsterm.m (hold_event): Set send_appdefined to YES (Bug#12834).
	(ns_select): Return at once if events are held (Bug#12834).

2012-11-18  enami tsugutomo  <tsugutomo.enami@jp.sony.com>

	* unexelf.c (ELFSIZE) [__NetBSD__ && _LP64]: Set to 64.
	Needed following 2012-10-20 change.  (Bug#12902)

2012-11-18  Juanma Barranquero  <lekktu@gmail.com>

	* w32proc.c (waitpid): Remove unused label get_result.

2012-11-17  Juanma Barranquero  <lekktu@gmail.com>

	* makefile.w32-in (SYSWAIT_H): New macro.
	($(BLD)/callproc.$(O), $(BLD)/w32proc.$(O), $(BLD)/process.$(O))
	($(BLD)/sysdep.$(O)): Update dependencies.

2012-11-17  Paul Eggert  <eggert@cs.ucla.edu>

	Assume POSIX 1003.1-1988 or later for fcntl.h (Bug#12881).
	* callproc.c (relocate_fd): Assume F_DUPFD.
	* emacs.c, term.c (O_RDWR): Remove.
	* keyboard.c (tty_read_avail_input): Use O_NONBLOCK rather than
	O_NDELAY, since O_NONBLOCK is the standard name for this flag.
	* nsterm.m: Assume <fcntl.h> exists.
	* process.c (NON_BLOCKING_CONNECT, allocate_pty, create_process)
	(create_pty, Fmake_network_process, server_accept_connection)
	(wait_reading_process_output, init_process_emacs):
	Assume O_NONBLOCK.
	(wait_reading_process_output): Put in a special case for WINDOWSNT
	to mimick the older behavior where it had O_NDELAY but not O_NONBLOCK.
	It's not clear this is needed, but it's a more-conservative change.
	(create_process): Assume FD_CLOEXEC.
	(create_process, create_pty): Assume O_NOCTTY.
	* sysdep.c (init_sys_modes, reset_sys_modes): Assume F_SETFL.
	(reset_sys_modes): Use O_NONBLOCK rather than O_NDELAY.
	Omit if not DOS_NT, since F_GETFL is not defined there.
	(serial_open): Assume O_NONBLOCK and O_NOCTTY.
	* term.c: Include <fcntl.h>, for flags like O_NOCTTY.
	(O_NOCTTY): Remove.
	(init_tty): Assume O_IGNORE_CTTY is defined to 0 on platforms that
	lack it, since gnulib guarantees this.
	* w32.c (fcntl): Test for O_NONBLOCK rather than O_NDELAY.

2012-11-17  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (faccessat): Pretend that directories have the execute bit
	set.  Emacs expects that, e.g., in files.el:cd-absolute.

	* w32proc.c (create_child): Don't clip the PID of the child
	process to fit into an Emacs integer, as this is no longer a
	restriction.
	(waitpid): Rename from sys_wait.  Emulate a Posix 'waitpid' by
	reaping only the process specified by PID argument, if that is
	positive.  Use PID instead of dead_child to know which process to
	reap.  Wait for the child to die only if WNOHANG is not in
	OPTIONS.
	(sys_select): Don't set dead_child.

	* sysdep.c (wait_for_termination_1): Remove the WINDOWSNT portion,
	as it is no longer needed.

	* process.c (waitpid, WUNTRACED) [!WNOHANG]: Remove definitions,
	no longer needed.
	(record_child_status_change): Remove the setting of
	record_at_most_one_child for the !WNOHANG case.

2012-11-17  Paul Eggert  <eggert@cs.ucla.edu>

	Fix problems in ns port found by static checking.
	* nsterm.m: Include <pthread.h>, for pthread_mutex_lock etc.
	(hold_event, setPosition:portion:whole:): Send SIGIO only to self,
	not to process group.
	(ns_select): Use emacs_write, not write, as that's more robust
	in the presence of signals.
	(fd_handler:): Check for read errors.

2012-11-16  Glenn Morris  <rgm@gnu.org>

	* editfns.c (Fmessage): Mention message-log-max.  (Bug#12849)

2012-11-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* eval.c (Finteractive_p): Revert lexbind-merge mishap.

2012-11-16  Eli Zaretskii  <eliz@gnu.org>

	* w32proc.c (timer_loop): Make sure SuspendThread and ResumeThread
	use the same value of thread handle.
	(start_timer_thread): If the timer thread exited (due to error),
	clean up by closing the two handles it used.  Duplicate the caller
	thread's handle here, so it gets duplicated only once, when
	launching the timer thread.  Set priority of the timer thread, not
	the caller thread.
	(getitimer): Don't duplicate the caller thread's handle here.
	(Bug#12832)

2012-11-16  Jan Djärv  <jan.h.d@swipnet.se>

	* nsterm.m (hold_event): Send SIGIO to make sure ns_read_socket is
	called (Bug#12834).

2012-11-16  Paul Eggert  <eggert@cs.ucla.edu>

	Remove no-longer-used pty_max_bytes variable.
	* process.c (pty_max_bytes): Remove; unused.
	(send_process): Do not set it.

2012-11-15  Juanma Barranquero  <lekktu@gmail.com>

	* makefile.w32-in ($(BLD)/dispnew.$(O), $(BLD)/emacs.$(O)):
	Update dependencies.

2012-11-15  Paul Eggert  <eggert@cs.ucla.edu>

	* eval.c (mark_backtrace) [BYTE_MARK_STACK]: Remove stray '*'.
	This follows up on the 2012-09-29 patch that removed indirection
	for the 'function' field.  Reported by Sergey Vinokurov in
	<http://lists.gnu.org/archive/html/emacs-devel/2012-11/msg00263.html>.

2012-11-14  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (faccessat): Rename from sys_faccessat.  (No need to use a
	different name, as the MS runtime does not have such a function,
	and probably never will.)  All callers changed.  Ignore DIRFD
	value if PATH is an absolute file name, to match Posix spec
	better.  If AT_SYMLINK_NOFOLLOW is set in FLAGS, don't resolve
	symlinks.

2012-11-14  Dmitry Antipov  <dmantipov@yandex.ru>

	* xdisp.c (echo_area_display, redisplay_internal):
	Omit redundant check whether frame_garbaged is set.

2012-11-14  Paul Eggert  <eggert@cs.ucla.edu>

	Use faccessat, not access, when checking file permissions (Bug#12632).
	This fixes a bug that has been present in Emacs since its creation.
	It was reported by Chris Torek in 1983 even before GNU Emacs existed,
	which must set some sort of record.  (Torek's bug report was against
	a predecessor of GNU Emacs, but GNU Emacs happened to have the
	same common flaw.)  See Torek's Usenet posting
	"setuid/setgid programs & Emacs" Article-I.D.: sri-arpa.858
	Posted: Fri Apr  8 14:18:56 1983.
	* Makefile.in (LIB_EACCESS): New macro.
	(LIBES): Use it.
	* callproc.c (init_callproc):
	* charset.c (init_charset):
	* fileio.c (check_existing, check_executable, check_writable)
	(Ffile_readable_p):
	* lread.c (openp, load_path_check):
	* process.c (allocate_pty):
	* xrdb.c (file_p):
	Use effective UID when checking permissions, not real UID.
	* callproc.c (init_callproc):
	* charset.c (init_charset):
	* lread.c (load_path_check, init_lread):
	Test whether directories are accessible, not merely whether they exist.
	* conf_post.h (GNULIB_SUPPORT_ONLY_AT_FDCWD): New macro.
	* fileio.c (check_existing, check_executable, check_writable)
	(Ffile_readable_p):
	Use symbolic names instead of integers for the flags, as they're
	portable now.
	(check_writable): New arg AMODE.  All uses changed.
	Set errno on failure.
	(Ffile_readable_p): Use faccessat, not stat + open + close.
	(Ffile_writable_p): No need to call check_existing + check_writable.
	Just call check_writable and then look at errno.  This saves a syscall.
	dir should never be nil; replace an unnecessary runtime check
	with an eassert.  When checking the parent directory of a nonexistent
	file, check that the directory is searchable as well as writable, as
	we can't create files in unsearchable directories.
	(file_directory_p): New function, which uses 'stat' on most platforms
	but faccessat with D_OK (for efficiency) if WINDOWSNT.
	(Ffile_directory_p, Fset_file_times): Use it.
	(file_accessible_directory_p): New function, which uses a single
	syscall for efficiency.
	(Ffile_accessible_directory_p): Use it.
	* xrdb.c (file_p): Use file_directory_p.
	* lisp.h (file_directory_p, file_accessible_directory_p): New decls.
	* lread.c (openp): When opening a file, use fstat rather than
	stat, as that avoids a permissions race.  When not opening a file,
	use file_directory_p rather than stat.
	(dir_warning): First arg is now a usage string, not a format.
	Use errno.  All uses changed.
	* nsterm.m (ns_term_init): Remove unnecessary call to file-readable
	that merely introduced a race.
	* process.c, sysdep.c, term.c: All uses of '#ifdef O_NONBLOCK'
	changed to '#if O_NONBLOCK', to accommodate gnulib O_* style,
	and similarly for the other O_* flags.
	* w32.c (sys_faccessat): Rename from sys_access and switch to
	faccessat's API.  All uses changed.
	* xrdb.c: Do not include <sys/stat.h>; no longer needed.
	(magic_db): Rename from magic_file_p.
	(magic_db, search_magic_path): Return an XrmDatabase rather than a
	char *, so that we don't have to test for file existence
	separately from opening the file for reading.  This removes a race
	fixes a permission-checking problem, and simplifies the code.
	All uses changed.
	(file_p): Remove; no longer needed.

2012-11-13  Dmitry Antipov  <dmantipov@yandex.ru>

	Omit glyphs initialization at startup.
	* dispnew.c (glyphs_initialized_initially_p): Remove.
	(adjust_frame_glyphs_initially): Likewise.  Adjust users.
	(Fredraw_frame): Move actual code from here...
	(redraw_frame): ...to here.  Add eassert.  Adjust comment.
	(Fredraw_display): Use redraw_frame.
	* xdisp.c (clear_garbaged_frames): Likewise.

2012-11-13  Eli Zaretskii  <eliz@gnu.org>

	* xdisp.c (decode_mode_spec): Limit the value of WIDTH argument
	passed to pint2str and pint2hrstr to be at most the size of the
	frame's decode_mode_spec_buffer.  This avoids crashes with very
	large values of FIELD_WIDTH argument to decode_mode_spec.
	(Bug#12867)

2012-11-13  Paul Eggert  <eggert@cs.ucla.edu>

	Fix a race with verify-visited-file-modtime (Bug#12863).
	Since at least 1991 Emacs has ignored an mtime difference of no
	more than one second, but my guess is that this was to work around
	file system bugs that were fixed long ago.  Since the race is
	causing problems now, let's remove that code.
	* fileio.c (Fverify_visited_file_modtime): Do not accept a file
	whose time stamp is off by no more than a second.  Insist that the
	file time stamps match exactly.

2012-11-12  Dmitry Antipov  <dmantipov@yandex.ru>

	* frame.h (struct frame): Convert external_tool_bar member to
	1-bit unsigned bitfield.
	* termhooks.h (struct terminal): Remove mouse_moved member since
	all users are long dead.  Adjust comment on mouse_position_hook.

2012-11-12  Dmitry Antipov  <dmantipov@yandex.ru>

	Simplify by using FOR_EACH_FRAME here and there.
	* frame.c (next_frame, prev_frame, other_visible_frames)
	(delete_frame, visible-frame-list): Use FOR_EACH_FRAME.
	* w32term.c (x_window_to_scroll_bar): Likewise.
	* window.c (window_list): Likewise.
	* xdisp.c (x_consider_frame_title): Likewise.
	* xfaces.c (Fdisplay_supports_face_attributes_p): Likewise.
	* xfns.c (x_window_to_frame, x_any_window_to_frame)
	(x_menubar_window_to_frame, x_top_window_to_frame): Likewise.
	* xmenu.c (menubar_id_to_frame): Likewise.
	* xselect.c (frame_for_x_selection): Likewise.
	* xterm.c (x_frame_of_widget, x_window_to_scroll_bar)
	(x_window_to_menu_bar): Likewise.
	* w32fns.c (x_window_to_frame): Likewise.  Adjust comment.

2012-11-12  Paul Eggert  <eggert@cs.ucla.edu>

	* data.c (Qdefalias_fset_function): Now static.

	Another tweak to vectorlike_header change.
	* alloc.c (struct Lisp_Vectorlike_Free, NEXT_IN_FREE_LIST):
	Remove, and replace all uses with ...
	(next_in_free_list, set_next_in_free_list):
	New functions, which respect C's aliasing rules better.

2012-11-11  Paul Eggert  <eggert@cs.ucla.edu>

	* window.c (list4i): Rename from 'quad'.  All uses changed.
	Needed because <sys/types.h> defines 'quad' on Solaris 10.

2012-11-11  Juanma Barranquero  <lekktu@gmail.com>

	* xdisp.c (start_hourglass) [HAVE_NTGUI]: Add block to silence
	warning about mixing declarations and code in ISO C90.

2012-11-10  Martin Rudalics  <rudalics@gmx.at>

	* window.c (Fsplit_window_internal): Set combination limit of
	new parent window to t iff Vwindow_combination_limit is t;
	fixing a regression introduced with the change from 2012-09-22.
	(Fset_window_combination_limit): Fix doc-string.

2012-11-10  Eli Zaretskii  <eliz@gnu.org>

	* xdisp.c (try_scrolling): Fix correction of aggressive-scroll
	amount when the scroll margins are too large.  When scrolling
	backwards in the buffer, give up if cannot reach point or the
	scroll margin within a reasonable number of screen lines.
	Fixes point position in window under scroll-up/down-aggressively when
	point is positioned many lines beyond the window top/bottom.
	(Bug#12811)

	* ralloc.c (relinquish): If real_morecore fails to return memory
	to the system, don't crash; instead, leave the last heap
	unchanged and return.  (Bug#12774)

2012-11-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp.h (AUTOLOADP): New macro.
	* eval.c (Fautoload): Don't attach to loadhist, call Fdefalias instead.
	* data.c (Ffset): Remove special ad-advice-info handling.
	(Fdefalias): Handle autoload definitions and new Qdefalias_fset_function.
	(Fsubr_arity): CSE.
	(Finteractive_form): Simplify.
	(Fquo): Don't insist on having at least 2 arguments.
	(Qdefalias_fset_function): New var.

2012-11-09  Jan Djärv  <jan.h.d@swipnet.se>

	* image.c (xpm_make_color_table_h): Change to hashtest_equal.

	* nsfont.m (Qcondensed, Qexpanded): New variables.
	(ns_descriptor_to_entity): Restore Qcondensed, Qexpanded setting.
	(syms_of_nsfont): Defsym Qcondensed, Qexpanded.

2012-11-09  Dmitry Antipov  <dmantipov@yandex.ru>

	Fix recently introduced crash on MS-Windows (Bug#12839).
	* w32term.h (struct scroll_bar): Use convenient header.
	(SCROLL_BAR_VEC_SIZE): Remove.
	* w32term.c (x_scroll_bar_create): Use VECSIZE.

2012-11-09  Dmitry Antipov  <dmantipov@yandex.ru>

	Tweak last vectorlike_header change.
	* alloc.c (struct Lisp_Vectorlike_Free): Special type to represent
	vectorlike object on the free list.  This is introduced to avoid
	some (but not all) pointer casting and aliasing problems, see
	http://lists.gnu.org/archive/html/emacs-devel/2012-11/msg00105.html.
	* .gdbinit (pvectype, pvecsize): New commands to examine vectorlike
	objects.
	(xvectype, xvecsize): Use them to examine Lisp_Object values.

2012-11-09  Jan Djärv  <jan.h.d@swipnet.se>

	* nsfont.m (ns_descriptor_to_entity): Qcondensed and Qexpanded has
	been removed, so remove them here also.

2012-11-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	* doc.c (Fdocumentation): Handle new property
	dynamic-docstring-function to replace the old ad-advice-info.

2012-11-09  Paul Eggert  <eggert@cs.ucla.edu>

	* fns.c (Qeql, hashtest_eq): Now static.

2012-11-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp.h (XHASH): Redefine to be imperfect and fit in a Lisp int.
	* fns.c (hashfn_eq, hashfn_eql, sxhash):
	* profiler.c (hashfn_profiler): Don't use XUINT on non-integers.
	* buffer.c (compare_overlays): Use XLI rather than XHASH.

2012-11-08  Paul Eggert  <eggert@cs.ucla.edu>

	Use same hash function for hashfn_profiler as for hash_string etc.
	* fns.c (SXHASH_COMBINE): Remove.  All uses replaced by sxhash_combine.
	* lisp.h (sxhash_combine): New inline function, with the contents
	of the old SXHASH_COMBINE.
	* profiler.c (hashfn_profiler): Use it, instead of having a
	special hash function containing a comparison that always yields 1.

2012-11-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xfaces.c (Qultra_light, Qreverse_oblique, Qreverse_italic)
	(Qultra_condensed, Qextra_condensed, Qcondensed, Qsemi_condensed)
	(Qsemi_expanded, Qextra_expanded, Qexpanded, Qultra_expanded):
	Remove unused vars.

2012-11-08  Jan Djärv  <jan.h.d@swipnet.se>

	* image.c (xpm_make_color_table_h): Fix compiler error because
	make_hash_table changed.

2012-11-08  Thomas Kappler  <tkappler@gmail.com>  (tiny change)

	* nsfont.m (ns_findfonts): Handle empty matchingDescs (Bug#11541).

2012-11-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	Use ad-hoc comparison function for the profiler's hash-tables.
	* profiler.c (Qprofiler_backtrace_equal, hashtest_profiler): New vars.
	(make_log): Use them.
	(handle_profiler_signal): Don't inhibit quit any longer since we don't
	call Fequal any more.
	(Ffunction_equal): New function.
	(cmpfn_profiler, hashfn_profiler): New functions.
	(syms_of_profiler): Initialize them.
	* lisp.h (struct hash_table_test): New struct.
	(struct Lisp_Hash_Table): Use it.
	* alloc.c (mark_object): Mark hash_table_test fields of hash tables.
	* fns.c (make_hash_table): Take a struct to describe the test.
	(cmpfn_eql, cmpfn_equal, cmpfn_user_defined, hashfn_eq, hashfn_eql)
	(hashfn_equal, hashfn_user_defined): Adjust to new calling convention.
	(hash_lookup, hash_remove_from_table): Move assertion checking of
	hashfn result here.  Check hash-equality before calling cmpfn.
	(Fmake_hash_table): Adjust call to make_hash_table.
	(hashtest_eq, hashtest_eql, hashtest_equal): New structs.
	(syms_of_fns): Initialize them.
	* emacs.c (main): Move syms_of_fns earlier.
	* xterm.c (syms_of_xterm):
	* category.c (hash_get_category_set): Adjust call to make_hash_table.
	* print.c (print_object): Adjust to new hash-table struct.
	* composite.c (composition_gstring_put_cache): Adjust to new hashfn.

2012-11-08  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (modifier_set): Fix handling of Scroll Lock when the
	value of w32-scroll-lock-modifier is neither nil nor one of the
	known key modifiers.  (Bug#12806)

2012-11-08  Dmitry Antipov  <dmantipov@yandex.ru>

	Shrink struct vectorlike_header to the only size field.
	* lisp.h (enum pvec_type): Avoid explicit enum member values.
	Adjust comment.
	(enum More_Lisp_Bits): Change PSEUDOVECTOR_SIZE_BITS and
	PVEC_TYPE_MASK to arrange new bitfield in the vector header.
	(PSEUDOVECTOR_REST_BITS, PSEUDOVECTOR_REST_MASK): New members.
	(PSEUDOVECTOR_AREA_BITS): New member used to extract subtype
	information from the vector header.  Adjust comment.
	(XSETPVECTYPE, XSETPVECTYPESIZE, XSETTYPED_PSEUDOVECTOR)
	(PSEUDOVECTOR_TYPEP, DEFUN): Adjust to match new vector header
	layout.
	(XSETSUBR, SUBRP): Adjust to match new Lisp_Subr layout.
	(struct vectorlike_header): Remove next member.  Adjust comment.
	(struct Lisp_Subr): Add convenient header.  Adjust comment.
	(allocate_pseudovector): Adjust prototype.
	* alloc.c (mark_glyph_matrix, mark_face_cache, allocate_string)
	(sweep_string, lisp_malloc): Remove useless prototypes.
	(enum mem_type): Adjust comment.
	(NEXT_IN_FREE_LIST): New macro.
	(SETUP_ON_FREE_LIST): Adjust XSETPVECTYPESIZE usage.
	(Fmake_bool_vector): Likewise.
	(struct large_vector): New type to represent allocation unit for
	the vectors with the memory footprint more than VBLOOCK_BYTES_MAX.
	(large_vectors): Change type to struct large_vector.
	(allocate_vector_from_block): Simplify.
	(PSEUDOVECTOR_NBYTES): Replace with...
	(vector_nbytes): ...new function.  Adjust users.
	(sweep_vectors): Adjust processing of large vectors.
	(allocate_vectorlike): Likewise.
	(allocate_pseudovector): Change type of 3rd arg to enum pvec_type.
	Add easserts.  Adjust XSETPVECTYPESIZE usage.
	(allocate_buffer): Use BUFFER_PVEC_INIT.
	(live_vector_p): Adjust to match large vector.
	* buffer.c (init_buffer_once): Use BUFFER_PVEC_INIT.
	* buffer.h (struct buffer): Add next member.
	(BUFFER_LISP_SIZE, BUFFER_REST_SIZE, BUFFER_PVEC_INIT):
	New macros.
	(FOR_EACH_BUFFER): Adjust to match struct buffer change.
	* fns.c (internal_equal): Adjust to match enum pvec_type change.
	(copy_hash_table): Adjust to match vector header change.
	* lread.c (defsubr): Use XSETPVECTYPE.
	* .gdbinit (xpr, xbacktrace): Adjust to match vector header change.
	(xvectype): Likewise.  Print PVEC_NORMAL_VECTOR for regular vectors.
	(xvecsize): New command.

2012-11-08  Dmitry Antipov  <dmantipov@yandex.ru>

	* keyboard.c (event_to_kboard): Do not dereference
	frame_or_window field of SELECTION_REQUEST_EVENT
	and SELECTION_CLEAR_EVENT events (Bug#12814).
	* xterm.h (struct selection_input_event): Adjust comment.

2012-11-07  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (modifier_set): Don't report modifiers from toggle key,
	such as Scroll Lock, if the respective keys are treated as
	function keys, not as modifiers.  This avoids destroying non-ASCII
	keyboard input when Scroll Lock is toggled ON.  (Bug#12806)

2012-11-07  Dmitry Antipov  <dmantipov@yandex.ru>

	* xfns.c (Fx_wm_set_size_hint): Use check_x_frame.  Adjust docstring.

2012-11-06  Paul Eggert  <eggert@cs.ucla.edu>

	Restore some duplicate definitions (Bug#12814).
	This undoes part of the 2012-11-03 changes.  Some people build
	with plain -g rather than with -g3, and they need the duplicate
	definitions for .gdbinit to work; see <http://bugs.gnu.org/12814#26>.
	* lisp.h (GCTYPEBITS, ARRAY_MARK_FLAG, PSEUDOVECTOR_FLAG, VALMASK):
	Define as macros, as well as as enums or as constants.

2012-11-06  Jan Djärv  <jan.h.d@swipnet.se>

	* nsterm.m (convert_ns_to_X_keysym, keyDown:): Add NSNumericPadKeyMask
	to keypad keys (Bug#12816).

2012-11-06  Paul Eggert  <eggert@cs.ucla.edu>

	Minor adjustments of recently-changed frame functions.
	* buffer.c (Fbuffer_list): Omit CHECK_FRAME, since arg is already
	known to be a frame (we're in the FRAMEP branch).
	* lisp.h (Qframep): Remove decl.  frame.h declares this.
	* window.c (quad): Args are of type EMACS_INT, not ptrdiff_t,
	since they're meant for Lisp fixnum values.

2012-11-06  Dmitry Antipov  <dmantipov@yandex.ru>

	* window.c (Fwindow_combination_limit): Revert to the only
	required argument and adjust docstring as suggested in
	http://lists.gnu.org/archive/html/emacs-diffs/2012-11/msg01082.html
	by Martin Rudalics <rudalics@gmx.at>.

2012-11-06  Dmitry Antipov  <dmantipov@yandex.ru>

	Widely used frame validity and checking functions.
	* frame.h (decode_live_frame, decode_any_frame): Add prototypes.
	* frame.c (decode_live_frame, decode_any_frame): New functions.
	(delete_frame, Fredirect_frame_focus, Fframe_parameters)
	(Fframe_parameter, Fframe_char_height, Fframe_char_width)
	(Fframe_pixel_height, Fframe_pixel_width, Ftool_bar_pixel_width)
	(Fframe_pointer_visible_p): Use decode_any_frame.
	(Fmake_frame_visible, Fmake_frame_invisible, Ficonify_frame)
	(Fraise_frame, Flower_frame, Fmodify_frame_parameters)
	(Fset_frame_height, Fset_frame_width): Use decode_live_frame.
	(Fframe_focus): Likewise.  Allow zero number of arguments.
	Adjust docstring.
	(frame_buffer_list, frame_buffer_predicate): Remove.
	* lisp.h (frame_buffer_predicate): Remove prototype.
	* buffer.c (Fother_buffer): Use decode_any_frame.
	* xdisp.c (Ftool_bar_lines_needed): Likewise.
	* xfaces.c (Fcolor_gray_p, Fcolor_supported_p): Likewise.
	* font.c (Ffont_face_attributes, Ffont_family_list, Fopen_font)
	(Fclose_font, Ffont_info): Use decode_live_frame.
	* fontset.c (check_fontset_name): Likewise.
	* terminal.c (Fframe_terminal): Likewise.
	* w32fns.c (check_x_frame): Likewise.
	* window.c (Fminibuffer_window, Fwindow_at)
	(Fcurrent_window_configuration): Likewise.
	(Frun_window_configuration_change_hook, Fwindow_resize_apply):
	Likewise.  Allow zero number of arguments.  Adjust docstring.
	* dispnew.c (Fredraw_frame): Likewise.
	* xfaces.c (frame_or_selected_frame): Remove.
	(Fx_list_fonts, Finternal_get_lisp_face_attribute, Fface_font)
	(Finternal_lisp_face_equal_p, Finternal_lisp_face_empty_p)
	(Fframe_face_alist): Use decode_live_frame.
	* xfns.c (check_x_frame): Likewise.

2012-11-06  Dmitry Antipov  <dmantipov@yandex.ru>

	* window.c (quad): New function.
	(Fwindow_edges, Fwindow_pixel_edges, Fwindow_inside_edges)
	(Fwindow_absolute_pixel_edges, Fwindow_inside_absolute_pixel_edges)
	(Fwindow_inside_pixel_edges, Fpos_visible_in_window_p)
	(Fwindow_line_height): Use it.
	(Fwindow_fringes): Use list3.
	(Fwindow_scroll_bars): Use list4.
	(Fwindow_frame, Fwindow_top_child, Fwindow_left_child)
	(Fwindow_combination_limit): Allow zero number of arguments.

2012-11-05  Eli Zaretskii  <eliz@gnu.org>

	* makefile.w32-in ($(BLD)/w32fns.$(O)): Depend on $(NT_INC)/unistd.h.

	* w32fns.c: Include unistd.h, to avoid compiler warnings on Cygwin.
	(emacs_abort) [CYGWIN]: Don't call _open_osfhandle; instead, use
	file descriptor 2 for standard error.  (Bug#12805)

2012-11-05  Chong Yidong  <cyd@gnu.org>

	* process.c (wait_reading_process_output): Revert previous change.

2012-11-05  Paul Eggert  <eggert@cs.ucla.edu>

	Assume at least POSIX.1-1988 for getpgrp, setpgid, setsid (Bug#12800).
	This removes code that has been obsolete since around 1990.
	* callproc.c (Fcall_process):
	* emacs.c (main):
	* process.c (create_process):
	* term.c (dissociate_if_controlling_tty):
	Assume setsid exists.
	* callproc.c (child_setup): Assume setpgid exists and behaves as
	per POSIX.1-1988 or later.
	* conf_post.h (setpgid) [!HAVE_SETPGID]: Remove.
	* emacs.c (shut_down_emacs):
	* sysdep.c (sys_suspend, init_foreground_group):
	Assume getpgrp behaves as per POSIX.1-1998 or later.
	* msdos.c (setpgrp): Remove.
	(tcgetpgrp, setpgid, setsid): New functions.
	* systty.h (EMACS_GETPGRP): Remove.  All callers now use getpgrp.
	* term.c (no_controlling_tty): Remove; unused.
	* w32proc.c (setpgrp): Remove.
	(setsid, tcgetpgrp): New functions.

	Simplify by assuming __fpending.
	* dispnew.c: Include <fpending.h>, not <stdio_ext.h>.
	(update_frame_1): Use __fpending, not PENDING_OUTPUT_COUNT.
	Do not assume that __fpending's result fits in int.

2012-11-04  Paul Eggert  <eggert@cs.ucla.edu>

	Remove EMACS_OUTQSIZE+sleep hack.
	* dispnew.c (update_frame_1): Remove hack for terminals slower
	than 2400 bps, which throttled Emacs by having it sleep.
	This code hasn't worked since at least 2007, when the multi-tty stuff
	was added, and anyway those old terminals are long dead.
	* systty.h (EMACS_OUTQSIZE): Remove; unused.  The macro isn't used even
	without the dispnew.c change, as dispnew.c doesn't include systty.h.

	Fix data-loss with --version (Bug#9574).
	* emacs.c (close_output_streams): Use strerror, not emacs_strerror,
	as we can't assume that emacs_strerror is initialized, and strerror
	is good enough here.
	(main): Invoke atexit earlier, to catch earlier instances of
	sending data to stdout and exiting, e.g., "emacs --version >/dev/full".

2012-11-04  Michael Marchionna  <tralfaz@pacbell.net>

	* nsterm.m: Add NSClearLineFunctionKey and keypad keys (Bug#8680).
	(keyDown): Remap keypad keys to X11 virtual key codes.

2012-11-03  Paul Eggert  <eggert@cs.ucla.edu>

	Fix data-loss with --batch (Bug#9574).
	* emacs.c: Include <close-stream.h>.
	(close_output_streams): New function.
	(main): Pass it to atexit, so that Emacs closes stdout and stderr
	and handles errors appropriately.
	(Fkill_emacs): Don't worry about flushing, as close_output_stream
	does that now.

	Fix a race condition that causes Emacs to mess up glib (Bug#8855).
	The symptom is a diagnostic "GLib-WARNING **: In call to
	g_spawn_sync(), exit status of a child process was requested but
	SIGCHLD action was set to SIG_IGN and ECHILD was received by
	waitpid(), so exit status can't be returned."  The diagnostic
	is partly wrong, as the SIGCHLD action is not set to SIG_IGN.
	The real bug is a race condition between Emacs and glib: Emacs
	does a waitpid (-1, ...) and reaps glib's subprocess by mistake,
	so that glib can't find it.  Work around the bug by invoking
	waitpid only on subprocesses that Emacs itself creates.
	* process.c (create_process, record_child_status_change):
	Don't use special value -1 in pid field, as the caller now must
	know the pid rather than having the callee infer it.
	The inference was sometimes incorrect anyway, due to another race.
	(create_process): Set new 'alive' member if child is created.
	(process_status_retrieved): New function.
	(record_child_status_change): Use it.
	Accept negative 1st argument, which means to wait for the
	processes that Emacs already knows about.  Move special-case code
	for DOS_NT (which lacks WNOHANG) here, from caller.  Keep track of
	processes that have already been waited for, by testing and
	clearing new 'alive' member.
	(CAN_HANDLE_MULTIPLE_CHILDREN): Remove, as record_child_status_change
	now does this internally.
	(handle_child_signal): Let record_child_status_change do all
	the work, since we do not want to reap all exited child processes,
	only the child processes that Emacs itself created.
	* process.h (Lisp_Process): New boolean member 'alive'.

	Omit duplicate definitions no longer needed with gcc -g3.
	* lisp.h (GCTYPEBITS, GCALIGNMENT, ARRAY_MARK_FLAG, PSEUDOVECTOR_FLAG)
	(VALMASK, MOST_POSITIVE_FIXNUM, MOST_NEGATIVE_FIXNUM):
	Define only as macros.  There's no longer any need to also define
	these symbols as enums or as constants, since we now assume
	gcc -g3 when debugging.

2012-11-03  Eli Zaretskii  <eliz@gnu.org>

	* lisp.mk: Adjust comments to the fact that term/internal is now
	loaded from loadup.el.

	* msdos.c (msdos_abort): Rename from emacs_abort, and make static.
	(msdos_fatal_signal): New function.
	(XMenuActivate): Adjust the call to kbd_buffer_events_waiting to
	its argument list.

	* conf_post.h (_GL_EXECINFO_INLINE) [MSDOS]: Define to "inline"
	for GCC versions before 4.
	(emacs_raise): Define to call msdos_fatal_signal.

	* xdisp.c (init_from_display_pos): Fix initialization of the bidi
	iterator when starting in the middle of a display or overlay
	string.  (Bug#12745)

2012-11-03  Chong Yidong  <cyd@gnu.org>

	* process.c (wait_reading_process_output): Clean up the last
	change.

2012-11-03  Jim Paris  <jim@jtan.com>  (tiny change)

	* process.c (wait_reading_process_output): Avoid a race condition
	with SIGIO delivery (Bug#11536).

2012-11-03  Chong Yidong  <cyd@gnu.org>

	* buffer.c (cursor_type): Untabify docstring.

2012-11-03  Dmitry Antipov  <dmantipov@yandex.ru>

	* frame.h (struct frame): Drop can_have_scroll_bars member
	which is meaningless for a long time.  Adjust comments.
	(FRAME_CAN_HAVE_SCROLL_BARS): Remove.
	* frame.c, nsfns.m, term.c, w32fns.c, xfns.c: Adjust users.

2012-11-03  Dmitry Antipov  <dmantipov@yandex.ru>

	* window.c (decode_next_window_args): Update window arg after
	calling decode_live_window and so fix crash reported at
	http://lists.gnu.org/archive/html/emacs-devel/2012-11/msg00035.html
	by Juanma Barranquero <lekktu@gmail.com>.
	(Fwindow_body_width, Fwindow_body_height): Simplify a bit.
	* font.c (Ffont_at): Likewise.

2012-11-01  Jan Djärv  <jan.h.d@swipnet.se>

	* widget.c (resize_cb): New function.
	(EmacsFrameRealize): Add resize_cb as event handler (Bug#12733).
	(EmacsFrameResize): Check if all is up to date before changing frame
	size.

2012-11-02  Eli Zaretskii  <eliz@gnu.org>

	Implement backtrace output for fatal errors on MS-Windows.
	* w32fns.c (CaptureStackBackTrace_proc): New typedef.
	(BACKTRACE_LIMIT_MAX): New macro.
	(w32_backtrace): New function.
	(emacs_abort): Use w32_backtrace when the user chooses not to
	attach a debugger.  Update the text of the abort dialog.

2012-11-02  Dmitry Antipov  <dmantipov@yandex.ru>

	Window-related stuff cleanup here and there.
	* dispnew.c (Finternal_show_cursor, Finternal_show_cursor_p):
	Use decode_any_window.
	* fringe.c (Ffringe_bitmaps_at_pos): Likewise.
	* xdisp.c (Fformat_mode_line): Likewise.
	* font.c (Ffont_at): Use decode_live_window.
	* indent.c (Fcompute_motion, Fvertical_motion): Likewise.
	* window.c (decode_next_window_args): Likewise.
	(decode_any_window): Remove static.
	* window.h (decode_any_window): Add prototype.
	* lisp.h (CHECK_VALID_WINDOW, CHECK_LIVE_WINDOW): Move from here...
	* window.h: ...to here, redefine via WINDOW_VALID_P and WINDOW_LIVE_P,
	respectively.

2012-11-02  Dmitry Antipov  <dmantipov@yandex.ru>

	Remove pad from struct input_event.
	* termhooks.h (struct input_event): Remove padding field.
	Adjust comment.
	* keyboard.c (event_to_kboard): Simplify because frame_or_window
	member is never cons for a long time.  Adjust comment.
	(mark_kboards): Adjust because SELECTION_REQUEST_EVENT and
	SELECTION_CLEAR_EVENT has no Lisp_Objects to mark.  Add comment.
	* xterm.c (handle_one_xevent): Do not initialize frame_or_window
	field of SELECTION_REQUEST_EVENT and SELECTION_CLEAR_EVENT.

2012-11-01  Eli Zaretskii  <eliz@gnu.org>

	* w32proc.c (getpgrp, setpgid): New functions.  (Bug#12776)

2012-10-31  Paul Eggert  <eggert@cs.ucla.edu>

	Fix crash when using Emacs as commit editor for git (Bug#12697).
	* callproc.c (setpgrp): Remove macro, as we now use setpgid
	and it is configured in conf_post.h.
	(Fcall_process): Don't invoke both setsid and setpgid; the former
	is enough, if it exists.
	* callproc.c (Fcall_process, child_setup):
	* process.c (create_process): Use setpgid.
	* conf_post.h (setpgid) [!HAVE_SETPGID]: New macro, which substitutes
	for the real thing.
	* dispnew.c (init_display): Initialize the foreground group
	if we are running a tty display.
	* emacs.c (main): Do not worry about setpgrp; init_display does it now.
	* lisp.h (init_foreground_group): New decl.
	* sysdep.c (inherited_pgroup): New static var.
	(init_foreground_group, tcsetpgrp_without_stopping)
	(narrow_foreground_group, widen_foreground_group): New functions.
	(init_sys_modes): Narrow foreground group.
	(reset_sys_modes): Widen foreground group.

2012-10-31  Michael Albinus  <michael.albinus@gmx.de>

	* dbusbind.c: Fix cut'n'waste error.  Use HAVE_DBUS_VALIDATE_INTERFACE.

2012-10-31  Martin Rudalics  <rudalics@gmx.at>

	* minibuf.c (read_minibuf): Restore current buffer since
	choose_minibuf_frame calling Fset_frame_selected_window may
	change it (Bug#12766).

2012-10-30  Jan Djärv  <jan.h.d@swipnet.se>

	* frame.c (Fframe_pixel_height): Fix documentation (Bug#12733).

2012-10-30  Kenichi Handa  <handa@gnu.org>

	* font.c (Ffont_at): If WINDOW is specified and it is not
	displaying the current buffer, signal an error.

2012-10-29  Daniel Colascione  <dancol@dancol.org>

	* cygw32.h, cygw32.c (Qutf_16le, from_unicode, to_unicode):
	In preparation for fixing bug#12739, move these functions from
	here...

	* coding.h, coding.c: ... to here, and compile them only when
	WINDOWSNT or CYGWIN.  Moving these functions out of cygw32 proper
	lets us write cygw32-agnostic code for the HAVE_NTGUI case.

2012-10-28  Eli Zaretskii  <eliz@gnu.org>

	* w32proc.c (TIMER_TICKS_PER_SEC): New macro.
	(timer_loop, getitimer, setitimer): Use it instead of
	CLOCKS_PER_SEC, which is no longer pertinent, since we don't use
	'clock'.
	(w32_get_timer_time): Use 10*TIMER_TICKS_PER_SEC instead of a
	literal 10000.

2012-10-28  Jan Djärv  <jan.h.d@swipnet.se>

	* nsterm.m (NO_APPDEFINED_DATA): New define.
	(last_appdefined_event_data): New variable
	(last_appdefined_event): Remove.
	(ns_select): Initialize t from last_appdefined_event_data instead
	of [last_appdefined_event data1].
	(sendEvent:): Save [theEvent data1] to last_appdefined_event_data,
	remove last_appdefined_event (Bug#12698).

2012-10-28  Stefan Monnier  <monnier@iro.umontreal.ca>

	* frame.c (x_set_font): Catch internal error.

2012-10-27  Eli Zaretskii  <eliz@gnu.org>

	Avoid overflow in w32 implementation of interval timers.
	When possible, for ITIMER_PROF count only times the main thread
	actually executes.
	* w32proc.c <struct itimer_data>: 'expire' and 'reload' are now
	'volatile ULONGLONG' types.  All the other data which was
	previously clock_t is now ULONGLONG.  'terminate' is 'volatile int'.
	(GetThreadTimes_Proc): New typedef.
	(w32_get_timer_time): New function, returns a suitable time value
	for the timer.
	(timer_loop): Enter critical section when accessing ULONGLONG
	values of the itimer_data struct, as these accesses are no longer
	atomic.  Call 'w32_get_timer_time' instead of 'clock'.
	Remove unused variable.
	(init_timers): Initialize s_pfn_Get_Thread_Times.
	(start_timer_thread): Don't assign itimer->caller_thread here.
	(getitimer): Assign itimer->caller_thread here.
	(setitimer): Always call getitimer to get the value of ticks_now.
	(sys_spawnve): Avoid compiler warning about format mismatch.

2012-10-26  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (w32_wnd_proc) <WM_MOUSEMOVE>: Don't enable tracking of
	mouse movement events if the menu bar is active.  This avoids
	producing a busy "hour-glass" cursor by Windows if the mouse
	pointer is positioned over a tooltip shown for some menu item.

2012-10-25  Paul Eggert  <eggert@cs.ucla.edu>

	Don't assume process IDs fit in int.
	* emacs.c (shut_down_emacs) [!DOS_NT]:
	* sysdep.c (sys_suspend) [SIGTSTP && !MSDOS]:
	* term.c (dissociate_if_controlling_tty) [!DOS_NT]:
	Use pid_t, not int, to store process IDs, as 'int'
	is not wide enough on a few platforms (e.g., AIX and IRIX).

2012-10-23  Kenichi Handa  <handa@gnu.org>

	The following change is to make face-font-rescale-alist work
	correctly for non-ASCII fonts.

	* font.c (font_open_entity): Don't handle Vface_font_rescale_alist.
	(font_open_for_lface): Handle Vface_font_rescale_alist.

2012-10-23  Chong Yidong  <cyd@gnu.org>

	* xfaces.c (Vfont_list_limit): Move unused variable to faces.el.

2012-10-21  Jan Djärv  <jan.h.d@swipnet.se>

	* nsfont.m (nsfont_open, ns_glyph_metrics): Force integer advancement
	for screen font.
	(nsfont_draw): Turn off LCD-smoothing (Bug#11484).

	* xterm.c (x_focus_changed): Check if daemonp when sending focus in
	event (Bug#12681).

2012-10-21  Glenn Morris  <rgm@gnu.org>

	* lisp.mk (lisp): Add cp51932.el and eucjp-ms.el.

2012-10-20  Paul Eggert  <eggert@cs.ucla.edu>

	Port to OpenBSD 5.1.
	* frame.c (Fmouse_position, Fmouse_pixel_position):
	* xdisp.c (produce_stretch_glyph):
	Declare local vars only when they're needed.
	This is clearer and avoids a warning on OpenBSD about unused vars.
	* frame.h (FRAME_WINDOW_P): Always evaluate its argument.
	This is safer, and avoids OpenBSD warnings about unused vars.
	* keyboard.c (record_menu_key): Remove unnecessary decl.
	(poll_timer): Define only if POLL_FOR_INPUT is defined.
	* unexelf.c (ELFSIZE) [!ElfW]: Do not define if already defined,
	as our definition clashes with OpenBSD's.
	* xfaces.c (load_face_colors, check_lface_attrs)
	(get_lface_attributes_no_remap, get_lface_attributes)
	(lface_fully_specified_p, x_supports_face_attributes_p)
	(tty_supports_face_attributes_p, face_fontset, realize_face)
	(realize_x_face, realize_tty_face):
	Declare parameters to be Lisp_Object[LFACE_VECTOR_SIZE], not
	merely Lisp_Object *.  This is more informative and avoids
	a warning on OpenBSD about accessing beyond an object's size.

2012-10-20  Chong Yidong  <cyd@gnu.org>

	* lread.c (Fload): Doc fix (Bug#12592).

2012-10-19  Kazuhiro Ito  <kzhr@d1.dion.ne.jp>  (tiny change)

	* font.c (Ffont_at): Fix previous change.

2012-10-19  Eli Zaretskii  <eliz@gnu.org>

	* puresize.h (BASE_PURESIZE): Bump the base value to 1700000.
	See http://lists.gnu.org/archive/html/emacs-devel/2012-10/msg00593.html
	for the reasons.

	* alloc.c (NSTATICS): Decrease to 0x800.

2012-10-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fns.c (Fnreverse): Include the problem element when signaling an
	error (bug#12677).

2012-10-18  Jan Djärv  <jan.h.d@swipnet.se>

	* nsterm.m (ns_select): Check writefds before call to
	FD_ISSET (Bug#12668).

2012-10-18  Daniel Colascione  <dancol@dancol.org>

	* alloc.c (NSTATICS): Increase from 0x650 to 0x1000
	(staticpro): If we run out of staticpro slots, die with an
	informative error instead of just calling emacs_abort.

2012-10-18  Martin Rudalics  <rudalics@gmx.at>

	Fix two flaws reported by Dmitry Antipov.
	* window.c (Ftemp_output_buffer_show): Remove.
	(Fwindow_vscroll, Fset_window_vscroll): Use decode_live_window.
	(syms_of_window): Remove defsubr for Stemp_output_buffer_show.

2012-10-17  Eli Zaretskii  <eliz@gnu.org>

	* makefile.w32-in ($(BLD)/w32.$(O)):
	($(BLD)/vm-limit.$(O)):
	($(BLD)/term.$(O)):
	($(BLD)/unexw32.$(O)):
	($(BLD)/fileio.$(O)):
	($(BLD)/dispnew.$(O)): Update dependencies.

	* w32term.h (w32_initialize_display_info, initialize_w32_display):
	Add prototypes.

	* w32proc.c: Include ctype.h.

	* w32.h (init_environment, check_windows_init_file)
	(syms_of_ntproc, syms_of_ntterm, dostounix_filename)
	(unixtodos_filename, init_winsock, srandom, random, sys_pipe)
	(set_process_dir, sys_spawnve, register_child, sys_sleep, getwd)
	(sys_link): Add prototypes.

	* w32.c: Include w32select.h.
	(sys_access, e_malloc, sys_select): Add prototypes.
	(emacs_gnutls_pull): 'timeout' is now EMACS_TIME, not struct timeval.

	* vm-limit.c [WINDOWSNT]: Include w32heap.h.

	* unexw32.c: Include lisp.h and w32.h.

	* term.c [WINDOWSNT]: Include w32term.h.

	* process.c [WINDOWSNT]: Add prototype of sys_select.

	* fileio.c [WINDOWSNT]: Include w32.h.

	* dispnew.c [WINDOWSNT]: Include w32.h.

	* cygw32.c (Fcygwin_convert_path_to_windows)
	(Fcygwin_convert_path_from_windows): Use EQ to compare 2
	Lisp_Object values.  (Bug#12661)

	* w32fns.c (w32_msg_pump): Use XIL instead of casting an integer
	to Lisp_Object.  (Bug#12661)

2012-10-17  Kenichi Handa  <handa@gnu.org>

	* xdisp.c (reseat_1): Make the information stored in it->cmp_it
	invalidate.

2012-10-17  Dmitry Antipov  <dmantipov@yandex.ru>

	* buffer.c (Fkill_buffer): When unchaining the marker,
	reset its buffer pointer to NULL (Bug#12652).

2012-10-17  Dmitry Antipov  <dmantipov@yandex.ru>

	Do not verify indirection counters of killed buffers (Bug#12579).
	* buffer.h (BUFFER_CHECK_INDIRECTION): New macro.
	* buffer.c (compact_buffer, set_buffer_internal_1): Use it.

2012-10-16  Dmitry Antipov  <dmantipov@yandex.ru>

	* alloc.c (Fmake_byte_code): Fix typo in comment.
	* print.c (print_interval): Define as static to match prototype.
	* indent.c (disptab_matches_widthtab, recompute_width_table):
	Convert to eassert.

2012-10-16  Dmitry Antipov  <dmantipov@yandex.ru>

	* editfns.c (get_system_name): Remove.
	* lisp.h (get_system_name): Remove prototype.
	* xrdb.c (getenv, getpwuid, getpwnam): Remove prototypes.
	(get_environ_db): Use Vsystem_name.  Avoid call to strlen.

2012-10-15  Daniel Colascione  <dancol@dancol.org>

	* dbusbind.c: Add comment explaining reason for previous change.

2012-10-15  Martin Rudalics  <rudalics@gmx.at>

	* window.c (Fwindow_end): Rewrite check whether cached position
	can be used (Bug#12600).
	(resize_frame_windows, grow_mini_window, shrink_mini_window):
	Set windows_or_buffers_changed.

2012-10-15  Daniel Colascione  <dancol@dancol.org>

	* dbusbind.c: Fix cygw32 build break when compiling with dbus
	enabled by undefining the symbol "interface", which the platform
	headers define to something incompatible.

2012-10-14  Daniel Colascione  <dancol@dancol.org>

	* image.c (init_tiff_functions, init_imagemagick_functions)
	(init_svg_functions): Fix cygw32 build break by using these
	functions only when WINDOWSNT _and_ HAVE_NTGUI.

2012-10-14  Jan Djärv  <jan.h.d@swipnet.se>

	* nsterm.m (ns_select): Count fd:s in writefs also (Bug#12422).

2012-10-13  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_set_widget_bg): Divide by 65535 (Bug#12612).

2012-10-13  HANATAKA, Shinya  <bogytech@gmail.com>  (tiny change)

	* coding.c (detect_coding): Set coding->id before calling
	this->detector.

2012-10-13  Andreas Schwab  <schwab@linux-m68k.org>

	* fileio.c: Formatting fixes.

2012-10-13  Paul Eggert  <eggert@cs.ucla.edu>

	Fix some stat-related races.
	* fileio.c (Fwrite_region): Avoid race condition if a file is
	removed or renamed by some other process immediately after Emacs
	writes it but before Emacs stats it.  Do not assume that stat (or
	fstat) succeeds.
	* image.c (slurp_file): Resolve the file name with fopen + fstat
	rather than stat + fopen.
	(pbm_read_file) [0]: Remove unused code with stat race.
	* process.c (allocate_pty) [HAVE_PTYS && !PTY_ITERATION && !PTY_OPEN]:
	Remove ineffective code with stat race.

2012-10-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* doc.c (get_doc_string): Don't signal an error if the file is missing.

2012-10-12  Jan Djärv  <jan.h.d@swipnet.se>

	* nsterm.m (hold_event_q): New static variable.
	(EV_TRAILER, sendScrollEventAtLoc:fromEvent:): Call hold_event if
	! q_event_ptr.
	(hold_event): New function.
	(ns_read_socket): If hold_event_q have events, store them and
	return (Bug#12384).
	(setPosition:portion:whole:): Send SIGIO to ourselves if apploopnr
	is zero (Bug#12384).

2012-10-12  Juanma Barranquero  <lekktu@gmail.com>

	* makefile.w32-in ($(BLD)/w32select.$(O)): Update dependencies.

2012-10-12  Eli Zaretskii  <eliz@gnu.org>

	* makefile.w32-in ($(BLD)/fileio.$(O)): Add sys/file.h.

	* fileio.c (check_existing): New function.
	(make_temp_name, Ffile_exists_p, Ffile_writable_p): Call it
	instead of calling 'stat', when what's needed is to check whether
	a file exists.  This avoids expensive system calls on MS-Windows.
	(Bug#12587)

	* w32.c (init_environment): Call 'check_existing' instead of 'stat'.

	* lread.c (openp) [WINDOWSNT]: Call 'access' instead of 'stat' to
	determine whether a file exists and is not a directory.

	* lisp.h (check_existing): Add prototype.

2012-10-12  Jan Djärv  <jan.h.d@swipnet.se>

	* nsfont.m (nsfont_open): Remove font cache, it is not GC correct.

2012-10-12  Glenn Morris  <rgm@gnu.org>

	* buffer.c (Fset_buffer): Doc fix.  (Bug#12624)

2012-10-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* buffer.c (Fkill_buffer): Null out the overlay list(s) as well.

	* eval.c (Fautoload): Remember previous autoload status in load-history.

2012-10-11  Paul Eggert  <eggert@cs.ucla.edu>

	lread.c, macros.c, marker.c, menu.c, minibuf.c: Use bool for booleans.
	* lread.c (load_each_byte, new_backquote_flag, readchar)
	(read_filtered_event, lisp_file_lexically_bound_p)
	(safe_to_load_version, Fload, complete_filename_p, openp)
	(build_load_history, readevalloop, read_escape, read1)
	(string_to_number, read_vector, read_list):
	* macros.c (Fstart_kbd_macro):
	* marker.c (CONSIDER):
	* menu.c (parse_single_submenu, digest_single_submenu)
	(find_and_return_menu_selection, Fx_popup_menu):
	* minibuf.c (read_minibuf_noninteractive, read_minibuf)
	(Ftry_completion):
	* nsmenu.m (ns_update_menubar, runMenuAt:forFrame:keymaps:):
	(ns_menu_show):
	* xmenu.c (set_frame_menubar, create_and_show_popup_menu)
	(xmenu_show, xdialog_show):
	Use bool for booleans.
	* lread.c (safe_to_load_version): Rename from safe_to_load_p,
	as it's not a predicate.  All uses changed.  Omit unnecessary
	buffer termination.

2012-10-11  Dmitry Antipov  <dmantipov@yandex.ru>

	* editfns.c (save_excursion_save): Use nil if mark points to nowhere.
	(save_excursion_restore): Do not restore mark if it was not saved.

2012-10-11  Paul Eggert  <eggert@cs.ucla.edu>

	* marker.c (cached_modiff): EMACS_INT, not int.

	* w32select.c (waiting_for_input): Declare by including "keyboard.h"
	instead of having a wrong decl.
	* nsmenu.m (waiting_for_input): Remove wrong decl.

2012-10-10  Paul Eggert  <eggert@cs.ucla.edu>

	keyboard.c, keymap.c: Use bool for booleans.
	* dispnew.c (sit_for): Distinguish between 3-way display_option
	and boolean do_display.
	* keyboard.c (single_kboard, this_command_key_count_reset)
	(waiting_for_input, echoing, immediate_quit, input_pending)
	(interrupt_input, interrupts_deferred, pop_kboard)
	(temporarily_switch_to_single_kboard, ignore_mouse_drag_p)
	(command_loop_1, adjust_point_for_property)
	(safe_run_hooks_error, input_polling_used, read_char):
	(help_char_p, readable_events, kbd_buffer_events_waiting)
	(kbd_buffer_get_event, timer_check_2, make_lispy_event)
	(lucid_event_type_list_p, get_input_pending):
	(gobble_input, menu_separator_name_p, menu_bar_item)
	(parse_menu_item, parse_tool_bar_item, read_char_x_menu_prompt)
	(read_char_minibuf_menu_prompt, access_keymap_keyremap)
	(keyremap_step, test_undefined, read_key_sequence)
	(detect_input_pending, detect_input_pending_ignore_squeezables)
	(detect_input_pending_run_timers, requeued_events_pending_p)
	(quit_throw_to_read_char, Fset_input_interrupt_mode):
	* keymap.c (get_keymap, keymap_parent, keymap_memberp)
	(access_keymap_1, access_keymap, map_keymap, get_keyelt)
	(Fdefine_key, Flookup_key, struct accessible_keymaps_data)
	(accessible_keymaps_1, Fkey_description, push_key_description):
	(shadow_lookup, struct where_is_internal_data)
	(where_is_internal, Fwhere_is_internal, where_is_internal_1)
	(Fdescribe_buffer_bindings, describe_map_tree, struct describe_map_elt)
	(describe_map, describe_vector):
	* menu.c (single_menu_item):
	* nsmenu.m (ns_update_menubar):
	* process.c (wait_reading_process_output):
	* search.c (scan_buffer, scan_newline):
	Use bool for boolean.
	* keyboard.c (timers_run, swallow_events)
	(detect_input_pending_run_timers):
	* process.c (wait_reading_process_output):
	Use unsigned for counter where wraparound-on-overflow is desired,
	since unsigned is guaranteed to have that behavior and signed is not.
	(read_char): Use ptrdiff_t for string length.
	(get_input_pending): Remove first argument, since it was always
	the same pointer-to-int (now pointer-to-boolean) &input_pending,
	and behave as if it had that value.  Return new value of
	input_pending.  All callers changed.
	* keyboard.h (struct kboard): Use unsigned : 1 for boolean member
	immediate_echo.  Use ptrdiff_t for echo_after_prompt, since it's
	a string length.
	* keymap.c (push_key_description): Omit last arg, which was always 1.
	All callers changed.

	* regex.c (immediate_quit) [emacs]: Remove duplicate decl.

2012-10-10  Juanma Barranquero  <lekktu@gmail.com>

	* makefile.w32-in ($(BLD)/dispnew.$(O), $(BLD)/indent.$(O))
	($(BLD)/term.$(O)): Update dependencies.

2012-10-10  Dmitry Antipov  <dmantipov@yandex.ru>

	* alloc.c (mark_object): Use meaningful PVEC_NORMAL_VECTOR.
	* lisp.h (enum pvec_type): Adjust comments and omit explicit
	initializer for PVEC_NORMAL_VECTOR.

2012-10-10  Paul Eggert  <eggert@cs.ucla.edu>

	Clean out old termopts cruft.
	* termopts.h (flow_control, meta_key): Remove unused decls.
	* dispnew.c, indent.c, nsterm.m, term.c, xsettings.c, xsmfns.c:
	Don't include termopts.h.

2012-10-10  Dmitry Antipov  <dmantipov@yandex.ru>

	* alloc.c (gc_sweep): Use pointer-to-a-pointer loop for buffers.

2012-10-10  Paul Eggert  <eggert@cs.ucla.edu>

	* commands.h (immediate_quit): Remove duplicate decl.

2012-10-09  Jan Djärv  <jan.h.d@swipnet.se>

	* nsfont.m (Vfonts_in_cache): Remove, not needed as font.c handles
	caching.
	(nsfont_open): Remove setting of Vfonts_in_cache.
	(syms_of_nsfont): Remove initialization of Vfonts_in_cache.

2012-10-09  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (w32_last_error): Change the return value to DWORD, to
	match what GetLastError returns.  Explain why the function is
	needed.

	* frame.c (delete_frame): Rename local variable 'tooltip_frame' to
	'is_tooltip_frame', to avoid confusion with its global namesake.

2012-10-08  Daniel Colascione  <dancol@dancol.org>

	* xdisp.c (start_hourglass): Call w32_note_current_window when
	HAVE_NTGUI, not just WINDOWSNT, resolving a problem in the cygw32
	build that caused Emacs to display the hourglass cursor forever.

	* w32fns.c (Fx_display_color_cells): Instead of using NCOLORS,
	which is broken under remote desktop, calculate the number of
	colors available for a display based on the display's number of
	planes and number of bits per pixel per plane.  (bug#10397).

2012-10-08  Jan Djärv  <jan.h.d@swipnet.se>

	* nsfont.m (Vfonts_in_cache): New variable.
	(nsfont_open): Use unsignedLongLongValue for cache in case wide ints
	are used.  Add cached fonts to Vfonts_in_cache.
	(syms_of_nsfont): Initialize and staticpro Vfonts_in_cache.

2012-10-08  Juanma Barranquero  <lekktu@gmail.com>

	* makefile.w32-in (LOCAL_FLAGS): Don't define HAVE_NTGUI, it's now
	in nt/config.nt.
	(FONT_H): Define after FRAME_H.
	($(BLD)/emacs.$(O), $(BLD)/process.$(O), $(BLD)/w32heap.$(O)):
	Update dependencies.

	* w32term.c: Remove leftover declaration of keyboard_codepage.

2012-10-08  Eli Zaretskii  <eliz@gnu.org>

	* makefile.w32-in (FONT_H): Add $(FRAME_H).
	(W32TERM_H): Add $(ATIMER_H) and $(FRAME_H).
	($(BLD)/emacs.$(O), $(BLD)/w32console.$(O)): Update dependencies.
	(GLOBAL_SOURCES): Add cygw32.c.
	($(BLD)/unexw32.$(O)):
	($(BLD)/w32.$(O)):
	($(BLD)/w32console.$(O)):
	($(BLD)/w32fns.$(O)):
	($(BLD)/w32heap.$(O)):
	($(BLD)/w32menu.$(O)):
	($(BLD)/w32proc.$(O)): Add w32common.h.

	* w32fns.c (w32_color_map_lookup, x_to_w32_color): Argument is now
	'const char *'.
	(x_to_w32_color): Don't modify the argument, modify a copy instead.

2012-10-08  Daniel Colascione  <dancol@dancol.org>

	* w32term.h (WM_EMACS_BRINGTOTOP, WM_EMACS_INPUT_READY)
	(WM_EMACS_END): Change WM_EMACS_BRINGTOTOP from 22 to 21 to close
	accidental message numbering hole.  Change other messages to
	match.

	* w32select.h (HAVE_W32SELECT): Remove.

	* w32select.c, w32proc.c, w32menu.c, w32console.c, w32.c: Include
	w32common.h instead of w32heap.h.

	* w32heap.h (ROUND_UP, ROUND_DOWN, get_page_size)
	(get_allocation_unit, get_processor_type, get_w32_major_version)
	(get_w32_minor_version, sysinfo_cache, osinfo_cache)
	(w32_major_version, w32_minor_version, w32_build_number, OS_9X)
	(OS_NT, os_subtype, cache_system_info): Move declarations to
	w32common.

	* w32heap.c: Include w32common.h.
	(sysinfo_cache, syspage_mask, osinfo_cache, w32_major_version)
	(w32_minor_version, w32_build_number, w32_subtype):
	Remove duplicate definitions.

	* w32fns.c: Include w32common.h; include w32heap.h only in
	WINDOWSNT.

	(Fx_file_dialog): Clarify comment on GetOpenFileName structure.
	Use `report_file_error' instead of `error' in order to better
	inform users of what went wrong.  Increase NTGUI_UNICODE file
	dialog box file name length to 32k, the maximum allowed by the NT
	kernel.

	* w32common.h: New file.
	(ROUND_UP, ROUND_DOWN, get_page_size)
	(get_allocation_unit, get_processor_type, get_w32_major_version)
	(get_w32_minor_version, sysinfo_cache, osinfo_cache)
	(w32_major_version, w32_minor_version, w32_build_number, OS_9X)
	(OS_NT, os_subtype, cache_system_info): Move here.

	* unexw32.c, unexcw.c: Include w32common.h.

	* emacs.c (main): Use (defined (WINDOWSNT) || defined
	HAVE_NTGUI) instead of removed HAVE_W32SELECT to decide whether
	to call syms_of_w32select.

	* cygw32.h: Remove obsolete EXFUN declarations.

	* cygw32.c (Qutf_16_le): Rename to Qutf_16le.

	* Makefile.in (SOME_MACHINE_OBJECTS): Reverse accidental removal
	of w32inevt.o from SOME_MACHINE_OBJECTS.

2012-10-08  Daniel Colascione  <dancol@dancol.org>

	* image.c: Permanent fix for JPEG compilation issue --- limit
	jpeglib `boolean' redefinition to Cygwin builds.

2012-10-08  Eli Zaretskii  <eliz@gnu.org>

	* image.c (CHECK_LIB_AVAILABLE): Remove, no longer used.

	* emacs.c (DAEMON_MUST_EXEC) [HAVE_NTGUI]: Define this only on
	Cygwin.

2012-10-08  Daniel Colascione  <dancol@dancol.org>

	* xfaces.c, xdisp.c, window.c, w32xfns.c, w32term.h, w32term.c,
	w32select.h w32select.c, w32proc.c, w32menu.c, w32inevt.c,
	w32help.c, w32font.c, w32font.c, w32fns.c, w32console.c, w32.h,
	w32.c, unexw32.c, termhooks.h, process.c, menu.c, keyboard.h,
	keyboard.c, image.c, frame.h, frame.c, fontset.c, font.h, font.c,
	emacs.c, dispextern.h, cygw32.h, cygw32.c, conf_post.h,
	Makefile.in: use HAVE_NTGUI for W32 GUI and WINDOWSNT for the
	operating system.  defined(HAVE_NTGUI) && !defined(WINDOWSNT) is
	now a supported configuration.

	* Makefile.in: consolidate image variables into LIBIMAGE; add
	W32_OBJ and W32_LIBS.  Compile new files.

	* conf_post.h:
	(_DebPrint) declare tracing facility for W32 debugging.  We need
	to unify tracing later.

	(NTGUI_UNICODE) Define when compiling for Cygwin to allow the
	unconditional use of W32 Unicode functions.  Cygwin runs only on
	100% Unicode operating systems.

	* cygw32.c: New file.  Define Cygwin-specific facilities.
	(Fcygwin_convert_path_to_windows)
	(Fcygwin_convert_path_from_windows): New user functions for
	accessing Cygwin path-munging routines.

	* cygw32.h: New file.
	(WCSDATA, to_unicode, from_unicode): Define facilities for storing
	UTF-16LE strings temporarily inside non-Lisp-visible string
	objects.

	(w32_strerror): Just what it says on the tin.

	* emacs.c: Make the NS fork-then-exec code for daemon-launching
	also run for Cygwin; both systems have the same problem with using
	GUI facilities in a forked child.  Also call syms_of_cygw32,
	syms_of_w32select in correct places.

	(DAEMON_MUST_EXEC): new macro defined to signal that a platform
	needs fork-then-exec for daemon launching.

	* font.h: Include frame.h.

	* image.c: Use the image library cache machinery only when we're
	compiling for native WINDOWSNT; Cygwin can use shared libraries
	like any other Unixlike system.

	* keyboard.c: Clarify a comment regarding the input loop.

	* menu.c: When NTGUI_UNICODE is defined, use Unicode menu
	functions directly instead of trying to detect at runtime that our
	host operating system supports them.  We make this change for two
	reasons: Cygwin lacks support for the multibyte character
	conversion functions used by the legacy menu code, and Cygwin
	never needs to rely on non-Unicode APIs.

	* unexw32.c (hinst): Declare extern.

	* w32.c: Change header order;
	(w32_strerror): Move to w32fns.c because we need it for
	non-WINDOWSNT builds.

	* w32.h: Add #error macro to make sure we don't include w32.h for
	Cygwin builds.  Remove w32select declarations.

	* w32console.c (w32_sys_ring_bell, Fset_message_beep): Move to
	w32fns.c.  w32console.c is WINDOWSNT-only.

	* w32fns.c: Include cygw32.h or w32.h depending on CYGWIN; more
	NTGUI_UNICODE tweaks.  (See above.) Change _snprintf to the more
	POSIXy alternative.
	(faked_key, sysinfo_cache, osinfo_cahce, syspage_mask)
	(w32_major_version, w32_minor_version, w32_build_number)
	(os_subtype, sound_type): Define here
	(w32_defined_color): Make color parameter const for consistency
	with other _defined_color functions.
	(w32_createwindow): Unconditionally call w32_init_class instead of
	doing so only when hprevinst is non-NULL.  Plumbing hprevinst
	through the code is complex and unnecessary because class
	registration is practically free.
	(w32_name_of_message): New EMACSDEBUG-only function.
	(Fset_message_beep): Move here
	(Fx_open_connection): Require that the display name for Windows be
	"w32" for consistency, emacsclient disambiguation, and maybe, one
	day, multi-window-system support.
	(file_dialog_callback): NTGUI_UNICODE changes; encode and decode
	Cygwin files for W32 GUI facilities, since these clearly don't
	expect Cygwin names.
	(_DebPrint): Define.
	(w32_strerror, w32_console_toggle_lock_key, w32_kbd_mods_to_emacs)
	(w32_kbd_patch_key, w32_sys_ring_bell): Move here.
	(Ssystem_move_file_to_trash): Define only for native WINDOWSNT.
	(w32_last_error): Remove.

	* w32font.c: Define _strlwr to strlwr for non-WINDOWSNT builds.

	* w32heap.c (syspage_mask): Declare here.
	(cache_system_info): Remove.

	* w32inevt.c (faked_key): Define globally, not statically.
	(w32_kbd_mods_to_emacs, w32_kbd_patch_key, faked_key)
	(w32_console_toggle_lock_key): Move to w32fns.c.

	* w32menu.c: Include setjmp.h.  NTGUI_UNICODE changes throughout.

	* w32proc.c (_DebPrint): Move to w32fns.c.
	* w32select.c: Include string.h, stdio.h for Cygwin.
	* w32select.h: New File.

	* w32term.c: Include io.h for non-CYGWIN builds; needed for
	get_osfhandle.
	(w32_message_fd): New variable.  Under Cygwin, holds the file
	descriptor the system used to tell us about pending thread
	messages.

	(w32_init_term): Remove incorrect calls to fcntl and init_sigio
	that prevented compilation under non-WINDOWSNT systems.

	(w32_initialize): Open /dev/windows and assign it to
	w32_message_fd.  Provide w32 feature.

	* w32term.h: Include frame.h, atimer.h.  Declare various frame functions.
	(WM_EMACS_INPUT_READY): add.
	(prepend_msg, w32_message_fd): Declare globally.

	* w32xfns.c:
	(keyboard_handle): Use only when WINDOWSNT.
	(notify_msg_ready): New function.  Posts a message to the main
	thread's message queue under CYGWIN, which wakes up the main
	thread from select(2) by making the /dev/windows file descriptor
	ready.  Under WINDOWSNT, it sets an event the same way the old
	code did.

	(post, prepend_msg): Actually call notify_msg_ready instead of
	setting the input event directly.

2012-10-07  Eli Zaretskii  <eliz@gnu.org>

	* ralloc.c (relinquish): If a heap is ready to be relinquished,
	but it still has blocs in it, don't return it to the system,
	instead of aborting.  (Bug#12402)

2012-10-07  Jan Djärv  <jan.h.d@swipnet.se>

	* nsterm.m (ns_dumpglyphs_image): Only draw slice of image (Bug#12506).

	* nsterm.m (ns_update_auto_hide_menu_bar): Remove defintion of
	MAC_OS_X_VERSION_10_6.
	(syms_of_nsterm): Remove comment about Panther and above for
	ns-antialias-text.
	* nsterm.h (MAC_OS_X_VERSION_10_3, onTiger): Remove.
	(EmacsApp): Remove check for >= MAC_OS_X_VERSION_10_4.
	(struct nsfont_info): Remove check for >= MAC_OS_X_VERSION_10_3.

	* nsselect.m (ns_string_from_pasteboard): Remove check for >=
	MAC_OS_X_VERSION_10_4.

	* nsmenu.m (fillWithWidgetValue:): Remove code for <
	MAC_OS_X_VERSION_10_2.

	* nsimage.m (setPixmapData, getPixelAtX, setAlphaAtX): Remove onTiger.

	* nsfns.m (Fns_list_services): Remove comment and check for OSX < 10.4.
	(ns_do_applescript): Remove check for >= MAC_OS_X_VERSION_10_4.

	* nsterm.m (ns_in_resize): Remove (Bug#12479).
	(ns_resize_handle_rect, mouseDown, mouseUp, mouseDragged): Remove.
	(ns_clear_frame, sendEvent, windowDidResize, drawRect:):
	Remove ns_in_resize check.
	(ns_clear_frame_area): Remove resize handle code.

	* nsfns.m (ns_in_resize): Remove.
	(x_set_icon_name, ns_set_name, ns_set_name_as_filename):
	Remove ns_in_resize check.

2012-10-07  Paul Eggert  <eggert@cs.ucla.edu>

	Improve sys_siglist detection.
	* sysdep.c (sys_siglist, init_signals): Use _sys_siglist if it's
	defined as a macro, as is done in Solaris.
	(sys_siglist_entries): New macro.
	(save_strsignal): Use it.
	* syssignal.h (safe_strsignal): Now ATTRIBUTE_CONST, to pacify
	GCC 4.7.2 on Fedora 17 with the fixed sys_siglist detection.

2012-10-06  Jan Djärv  <jan.h.d@swipnet.se>

	* nsfns.m (Fx_create_frame): Call x_default_parameter with
	fullscreen/Fullscreen.

	* nsterm.h (EmacsView): Rename tbar_height to tibar_height.
	tobar_height is new.

	* nsterm.m (x_make_frame_visible): Check for fullscreen.
	(ns_fullscreen_hook): Activate old style fullscreen with a timer.
	(ns_term_init): Set activateIgnoringOtherApps if old style fullscreen.
	(windowDidResize:): Check for correct window if old style fullscreen.
	Capitalize word in comment.  Remove incorrect comment.
	(initFrameFromEmacs:): tbar_height renamed tibar_height.
	(windowDidEnterFullScreen:): Toggle toolbar for fullscreen to fix
	error in drawing background.
	(toggleFullScreen:): Remove comment.  Rearrange calls.
	Set toolbar values to zero, save old height in tobar_height.
	Restore tool bar height when leaving fullscreen.
	(canBecomeMainWindow): New function.

2012-10-06  Paul Eggert  <eggert@cs.ucla.edu>

	* keyboard.c (read_char): Remove unnecessary 'volatile's and label.

2012-10-05  Eli Zaretskii  <eliz@gnu.org>

	* w32proc.c (stop_timer_thread): Fix declaration of 'err'.

	* w32.c (utime): Open the file with FILE_FLAG_BACKUP_SEMANTICS, so
	that time stamps of directories could also be changed.
	Don't request the too broad GENERIC_WRITE, only the more restrictive
	FILE_WRITE_ATTRIBUTES access rights.

	* fileio.c (Fset_file_times): Special-case ignoring errors for
	directories only on MSDOS, not on MS-Windows.

2012-10-05  Ikumi Keita  <ikumi@ikumi.que.jp>  (tiny change)

	* minibuf.c (Fcompleting_read): Doc fix.  (Bug#12555)

2012-10-04  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (utime): Test for INVALID_HANDLE_VALUE, not for NULL, to
	see whether CreateFile failed.

2012-10-04  Paul Eggert  <eggert@cs.ucla.edu>

	* profiler.c (handle_profiler_signal): Inhibit pending signals too,
	to avoid similar races.
	* keyboard.c (pending_signals): Now bool, not int.

	Port timers to OpenBSD, plus check for timer failures.
	OpenBSD problem reported by Han Boetes.
	* profiler.c (setup_cpu_timer): Check for failure of timer_settime
	and/or setitimer.
	(Fprofiler_cpu_stop): Don't assume HAVE_SETITIMER.
	* syssignal.h (HAVE_ITIMERSPEC): New macro.  This is for platforms
	like OpenBSD, which has timer_settime but does not declare it.
	OpenBSD does not define SIGEV_SIGNAL, so use that when deciding
	whether to use itimerspec-related primitives.  All uses of
	HAVE_TIMER_SETTIME replaced with HAVE_ITIMERSPEC.

2012-10-02  Paul Eggert  <eggert@cs.ucla.edu>

	* profiler.c (handle_profiler_signal): Fix a malloc race
	that caused Emacs to hang on Fedora 17 when profiling Lisp.

2012-10-02  Jan Djärv  <jan.h.d@swipnet.se>

	* nsterm.m (windowDidEnterFullScreen): Remove fprintf.

2012-10-02  Eli Zaretskii  <eliz@gnu.org>

	* w32proc.c (sys_wait): Declare 'signame' 'const char *', to be
	consistent with the change in return value of 'safe_strsignal'.

2012-10-02  Paul Eggert  <eggert@cs.ucla.edu>

	Prefer plain 'static' to 'static inline' (Bug#12541).
	* bidi.c (bidi_get_type, bidi_check_type, bidi_get_category)
	(bidi_set_sor_type, bidi_push_embedding_level)
	(bidi_pop_embedding_level, bidi_remember_char, bidi_copy_it)
	(bidi_cache_reset, bidi_cache_shrink, bidi_cache_fetch_state)
	(bidi_cache_search, bidi_cache_ensure_space)
	(bidi_cache_iterator_state, bidi_cache_find)
	(bidi_peek_at_next_level, bidi_set_paragraph_end)
	(bidi_count_bytes, bidi_char_at_pos, bidi_fetch_char)
	(bidi_explicit_dir_char, bidi_resolve_neutral_1):
	Now 'static', not 'static inline'.

	Count overruns when profiling; change units to ns.
	* profiler.c (handle_profiler_signal): Count sampling intervals, not ms.
	Give extra weight to samples after overruns, to attempt to count
	the time more accurately.
	(setup_cpu_timer): Change sampling interval units from ms to ns, since
	the underlying primitives nominally do ns.
	(Fprofiler_cpu_start): Document the change.  Mention that
	the sampling intervals are only approximate.

2012-10-02  Stefan Monnier  <monnier@iro.umontreal.ca>

	* frame.c (Fmake_terminal_frame): Prefer safer CONSP over !NILP.

	* coding.h (ENCODE_FILE, DECODE_FILE, DECODE_SYSTEM): Remove special
	case for the special 0 coding-system.

	* buffer.c (Fset_buffer_multibyte): Signal an error instead of widening.
	(Fmake_overlay): Remove redundant tests.
	(fix_start_end_in_overlays): Remove redundant recentering.

2012-10-02  Juanma Barranquero  <lekktu@gmail.com>

	* makefile.w32-in ($(BLD)/alloc.$(O), $(BLD)/gmalloc.$(O)):
	Update dependencies.

2012-10-01  Paul Eggert  <eggert@cs.ucla.edu>

	Fix a malloc race condition involving strsignal.
	A signal can arrive in the middle of a malloc, and Emacs's signal
	handler can invoke strsignal, which can invoke malloc, which is
	not portable.  This race condition bug makes Emacs hang on GNU/Linux.
	Fix it by altering the signal handler so that it does not invoke
	strsignal.
	* emacs.c (shut_down_emacs): Use safe_strsignal, not strsignal.
	* process.c (status_message): Use const pointer, in case strsignal
	is #defined to safe_strsignal.
	* sysdep.c (sys_siglist, init_signals): Always define and
	initialize a substitute sys_siglist if the system does not define
	one, even if HAVE_STRSIGNAL.
	(safe_strsignal): Rename from strsignal.  Always define,
	using sys_siglist.  Return a const pointer.
	* syssignal.h (safe_strsignal): New decl.
	(strsignal) [!HAVE_STRSIGNAL]: Define in terms of safe_strsignal.

2012-10-01  Eli Zaretskii  <eliz@gnu.org>

	* w32proc.c (timer_loop): Fix code that waits for timer
	expiration, to avoid high CPU usage.

2012-10-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fns.c (check_hash_table, get_key_arg, maybe_resize_hash_table)
	(sweep_weak_table): Remove redundant prototypes.

2012-10-01  Fabrice Popineau  <fabrice.popineau@gmail.com>

	* emacs.c: Move the inclusion of TERM_HEADER after including
	windows.h on WINDOWSNT.  This avoids compilation problems with
	MSVC.

2012-10-01  Eli Zaretskii  <eliz@gnu.org>

	* unexw32.c (OFFSET_TO_RVA, RVA_TO_OFFSET)
	(RVA_TO_SECTION_OFFSET): Encode all macro arguments in parentheses.
	(RVA_TO_PTR): Cast the result of RVA_TO_OFFSET to 'unsigned char *',
	as the previous version used 'void *'.

	* ralloc.c (ROUNDUP): Fix last change.
	(MEM_ROUNDUP): Don't cast MEM_ALIGN, it is already of type
	'size_t'.

	* w32proc.c <disable_itimers>: New static flag.
	(init_timers): Initialize it to zero, after creating the critical
	sections used by the timer threads.
	(term_timers): Set to 1 before deleting the critical sections.
	(getitimer, setitimer): If disable_itimers is non-zero, return an
	error indication without doing anything.  Reported by Fabrice
	Popineau <fabrice.popineau@supelec.fr> as part of bug#12544.
	(alarm) [HAVE_SETITIMER]: Be more conformant to the expected
	return results.
	[!HAVE_SETITIMER]: Behave as the previous version that didn't
	support timers.

	* emacs.c (shut_down_emacs) [WINDOWSNT]: Move the call to
	term_ntproc after all the other bookkeeping, to get timers working
	as long as possible.

2012-10-01  Paul Eggert  <eggert@cs.ucla.edu>

	* xdisp.c (syms_of_xdisp): Default message-log-max to 1000, not 100.
	Suggested by Juri Linkov in
	<http://lists.gnu.org/archive/html/emacs-devel/2012-09/msg00821.html>.

	Prefer plain 'static' to 'static inline' (Bug#12541).
	With static functions, modern compilers inline pretty well by
	themselves; advice from programmers often hurts as much as it helps.
	On my host (x86-64, Fedora 17, GCC 4.7.2, default 'configure'),
	this change shrinks the text size of the Emacs executable by 1.1%
	without affecting CPU significantly in my benchmark.
	* alloc.c (mem_find, live_string_p, live_cons_p, live_symbol_p)
	(live_float_p, live_misc_p, live_vector_p, live_buffer_p)
	(mark_maybe_object, mark_maybe_pointer, bounded_number):
	* buffer.c (bset_abbrev_mode, bset_abbrev_table)
	(bset_auto_fill_function, bset_auto_save_file_format)
	(bset_auto_save_file_name, bset_backed_up, bset_begv_marker)
	(bset_bidi_display_reordering, bset_buffer_file_coding_system)
	(bset_cache_long_line_scans, bset_case_fold_search)
	(bset_ctl_arrow, bset_cursor_in_non_selected_windows)
	(bset_cursor_type, bset_display_table, bset_extra_line_spacing)
	(bset_file_format, bset_file_truename, bset_fringe_cursor_alist)
	(bset_fringe_indicator_alist, bset_fringes_outside_margins)
	(bset_header_line_format, bset_indicate_buffer_boundaries)
	(bset_indicate_empty_lines, bset_invisibility_spec)
	(bset_left_fringe_width, bset_major_mode, bset_mark)
	(bset_minor_modes, bset_mode_line_format, bset_mode_name)
	(bset_name, bset_overwrite_mode, bset_pt_marker)
	(bset_right_fringe_width, bset_save_length)
	(bset_scroll_bar_width, bset_scroll_down_aggressively)
	(bset_scroll_up_aggressively, bset_selective_display)
	(bset_selective_display_ellipses, bset_vertical_scroll_bar_type)
	(bset_word_wrap, bset_zv_marker, set_buffer_overlays_before)
	(set_buffer_overlays_after):
	* category.c (bset_category_table):
	* charset.c (read_hex):
	* coding.c (produce_composition, produce_charset)
	(handle_composition_annotation, handle_charset_annotation)
	(char_encodable_p):
	* dispnew.c (swap_glyph_pointers, copy_row_except_pointers)
	(assign_row, set_frame_matrix_frame, make_current)
	(add_row_entry):
	* eval.c (set_specpdl_symbol, set_specpdl_old_value):
	* fns.c (maybe_resize_hash_table):
	* frame.c (fset_buffer_predicate, fset_minibuffer_window):
	* gmalloc.c (register_heapinfo):
	* image.c (lookup_image_type):
	* intervals.c (set_interval_object, set_interval_left)
	(set_interval_right, copy_interval_parent, rotate_right)
	(rotate_left, balance_possible_root_interval):
	* keyboard.c (kset_echo_string, kset_kbd_queue)
	(kset_keyboard_translate_table, kset_last_prefix_arg)
	(kset_last_repeatable_command, kset_local_function_key_map)
	(kset_overriding_terminal_local_map, kset_real_last_command)
	(kset_system_key_syms, clear_event, set_prop):
	* lread.c (digit_to_number):
	* marker.c (attach_marker, live_buffer, set_marker_internal):
	* nsterm.m (ns_compute_glyph_string_overhangs):
	* process.c (pset_buffer, pset_command)
	(pset_decode_coding_system, pset_decoding_buf)
	(pset_encode_coding_system, pset_encoding_buf, pset_filter)
	(pset_log, pset_mark, pset_name, pset_plist, pset_sentinel)
	(pset_status, pset_tty_name, pset_type, pset_write_queue):
	* syntax.c (bset_syntax_table, dec_bytepos):
	* terminal.c (tset_param_alist):
	* textprop.c (interval_has_some_properties)
	(interval_has_some_properties_list):
	* window.c (wset_combination_limit, wset_dedicated)
	(wset_display_table, wset_hchild, wset_left_fringe_width)
	(wset_left_margin_cols, wset_new_normal, wset_new_total)
	(wset_normal_cols, wset_normal_lines, wset_parent, wset_pointm)
	(wset_right_fringe_width, wset_right_margin_cols)
	(wset_scroll_bar_width, wset_start, wset_temslot, wset_vchild)
	(wset_vertical_scroll_bar_type, wset_window_parameters):
	* xdisp.c (wset_base_line_number, wset_base_line_pos)
	(wset_column_number_displayed, wset_region_showing)
	(window_box_edges, run_window_scroll_functions)
	(append_glyph_string_lists, prepend_glyph_string_lists)
	(append_glyph_string, set_glyph_string_background_width)
	(append_glyph, append_composite_glyph)
	(take_vertical_position_into_account):
	* xfaces.c (x_create_gc, x_free_gc, merge_face_vectors)
	(face_attr_equal_p, lface_equal_p, hash_string_case_insensitive)
	(lface_hash, lface_same_font_attributes_p, lookup_face):
	* xml.c (libxml2_loaded_p):
	* xterm.c (x_set_mode_line_face_gc, x_set_glyph_string_gc)
	(x_set_glyph_string_clipping, x_clear_glyph_string_rect):
	Now 'static', not 'static inline'.

	* bidi.c: Tune.
	(bidi_copy_it): Do the whole copy with a single memcpy.
	(bidi_char_at_pos): Merge the two STRING_CHAR calls into one.

	Revert the FOLLOW-SYMLINKS change for file-attributes.
	Doing it right would require several changes to Tramp, and there's
	not enough time to get that tested before the freeze today.
	* dired.c (directory_files_internal, Ffile_attributes):
	Undo last change.

	* frame.c (x_report_frame_params): Port better to wider ints.
	Do not assume that EMACS_UINT is the same width as uprintmax_t,
	or that pointers can be printed in 15 decimal digits.
	Avoid GCC warnings if EMACS_UINT is wider than a pointer.

2012-09-30  Fabrice Popineau  <fabrice.popineau@supelec.fr>

	Support x64 build on MS-Windows.
	* w32term.h (SCROLL_BAR_PACK, SCROLL_BAR_UNPACK): Define for x64.
	(SET_SCROLL_BAR_W32_WINDOW): Cast ID to intptr_t, for
	compatibility with x64.
	(x_get_focus_frame): Add prototype.

	* w32term.c (w32_draw_underwave): Don't use GCC extensions for
	defining an XRectangle structure.

	* w32proc.c (RVA_TO_PTR, w32_executable_type): Fix pointer
	arithmetic for compatibility with x64.

	* w32menu.c (add_menu_item): Use UINT_PTR instead of UINT, for
	compatibility with x64.

	* w32heap.h: Adjust prototypes and declarations.

	* w32heap.c (RVA_TO_PTR, allocate_heap, sbrk, init_heap)
	(round_heap): Use DWORD_PTR, ptrdiff_t and size_t instead of
	DWORD, long, and unsigned long, for compatibility with x64.
	(allocate_heap) [_WIN64]: Reserve 32GB of memory.
	(sbrk): Argument is now of type ptrdiff_t.

	* w32fns.c (HMONITOR): Condition declaration on _WIN32_WINNT being
	less than 0x0500.
	(w32_msg_pump): Use WPARAM type for 'result'.

	* w32.c (init_environment, get_emacs_configuration): Support AMD64
	architecture.
	(init_ntproc): Cast arguments of _open_osfhandle to intptr_t, for
	compatibility with x64.

	* vm-limit.c (lim_data): Now size_t.
	(check_memory_limits): Adjust prototypes of real_morecore and
	__morecore to receive argument of type ptrdiff_t.  Use size_t for
	five_percent and data_size.

	* unexw32.c: Use DWORD_PTR instead of DWORD for file-scope
	variables, for compatibility with x64.
	(rva_to_section, offset_to_section, relocate_offset)
	(OFFSET_TO_RVA, RVA_TO_OFFSET, RVA_TO_SECTION_OFFSET)
	(PTR_TO_RVA, RVA_TO_PTR, OFFSET_TO_PTR, get_section_info)
	(copy_executable_and_dump_data): Use DWORD_PTR instead of DWORD
	for compatibility with x64.

	* sysdep.c (STDERR_FILENO): Define if not already defined.

	* ralloc.c (real_morecore): Argument type is now ptrdiff_t.
	(__morecore): Argument type is now ptrdiff_t.
	(ROUNDUP, MEM_ROUNDUP): Use size_t instead of 'unsigned long'.
	(relinquish): Use ptrdiff_t type for 'excess'.
	(r_alloc_sbrk): Argument type is now ptrdiff_t.

	* makefile.w32-in (HEAPSIZE): Get value from EMACS_HEAPSIZE.
	(bootstrap-temacs-CMD, bootstrap-temacs-SH): Use $(EMACS_PURESIZE)
	instead of a literal number.

	* gmalloc.c [WINDOWSNT]: Include w32heap.h.
	(min): Define only if not already defined.

	* frame.c (x_report_frame_params): Use EMACS_UINT for the return
	value of FRAME_X_WINDOW, to fit a 64-bit pointer on 64-bit Windows
	hosts.

	* image.c (x_bitmap_pixmap): Return ptrdiff_t, not int, since
	'bitmaps' is a pointer.

	* dispextern.h (x_bitmap_pixmap): Adjust prototype.

	* alloc.c (gdb_make_enums_visible): Now conditional on __GNUC__.

2012-09-30  Paul Eggert  <eggert@cs.ucla.edu>

	file-attributes has a new optional arg FOLLOW-SYMLINKS.
	* dired.c (directory_files_internal, Ffile_attributes):
	New arg follow_symlinks.  All uses changed.

2012-09-30  Stefan Monnier  <monnier@iro.umontreal.ca>

	* .gdbinit (xbacktrace): Adjust to recent "struct backtrace" change.

2012-09-30  Eli Zaretskii  <eliz@gnu.org>

	Support atimers and CPU profiler via profile.c on MS-Windows.
	* w32proc.c (sig_mask, crit_sig): New static variables.
	(sys_signal): Support SIGALRM and SIGPROF.
	(sigemptyset, sigaddset, sigfillset, sigprocmask)
	(pthread_sigmask, setpgrp): Move here from w32.c.  sigaddset,
	sigfillset, and sigprocmask are no longer no-ops.
	(sigismember): New function.
	(struct itimer_data): New definition.
	(ticks_now, real_itimer, prof_itimer, clocks_min, crit_real)
	(crit_prof): New static variables.
	(MAX_SINGLE_SLEEP): New definition.
	(timer_loop, stop_timer_thread, term_timers, init_timers)
	(start_timer_thread, getitimer, setitimer): New functions.
	(alarm): No longer a no-op, calls setitimer.

	* w32.c (term_ntproc): Call term_timers.
	(init_ntproc): Make sure all signals are unblocked at startup, to
	erase any traces of dumping.  Call init_timers.

	* w32fns.c (hourglass_timer, HOURGLASS_ID): Remove.
	Windows-specific code to display the hourglass mouse pointer is no
	longer used.
	(w32_wnd_proc): Remove code that handled the WM_TIMER message due
	to hourglass timer expiration.
	(start_hourglass, cancel_hourglass, DEFAULT_HOURGLASS_DELAY):
	Remove, no longer used.
	(w32_note_current_window, show_hourglass, hide_hourglass):
	New functions, in support of hourglass cursor display similar to other
	window systems.
	(syms_of_w32fns): Don't initialize hourglass_timer.

	* xdisp.c (start_hourglass, cancel_hourglass): Now used on
	WINDOWSNT as well.
	(start_hourglass) [WINDOWSNT]: Call w32_note_current_window.

	* w32.h (init_timers, term_timers): Add prototypes.

2012-09-30  Kenichi Handa  <handa@gnu.org>

	* coding.c (decode_coding_ccl, encode_coding_ccl): Pay attention
	to the buffer relocation which may be caused by ccl_driver.

2012-09-30  Jan Djärv  <jan.h.d@swipnet.se>

	* xfns.c (Fx_file_dialog): Update comment.

	* w32fns.c (Fx_file_dialog): Update comment.

	* nsfns.m (Fns_read_file_name): Add argument DIR_ONLY_P.
	Initialize panel name field if OSX >= 10.6.

	* fileio.c (Fnext_read_file_uses_dialog_p): Add HAVE_NS.

	* nsfns.m (ns_frame_parm_handlers): Add x_set_fullscreen.

	* nsterm.m (NEW_STYLE_FS): New define.
	(ns_fullscreen_hook, windowWillEnterFullScreen)
	(windowDidEnterFullScreen, windowWillExitFullScreen)
	(windowDidExitFullScreen, toggleFullScreen, handleFS)
	(setFSValue): New functions.
	(EmacsFSWindow): New implementation.
	(canBecomeKeyWindow): New function for EmacsFSWindow.
	(ns_create_terminal): Set fullscreen_hook to ns_fullscreen_hook.
	(dealloc): Release nonfs_window if in fullscreen.
	(updateFrameSize:): Call windowDidMove to update top/left.
	(windowWillResize:toSize:): Check if frame is still maximized.
	(initFrameFromEmacs:): Initialize fs_state, fs_before_fs,
	next_maximized, maximized_width, maximized_height and nonfs_window.
	Call setCollectionBehavior if NEW_STYLE_FS.  Initialize bwidth and
	tbar_height.
	(windowWillUseStandardFrame:defaultFrame:): Update frame parameter
	fullscreen.  Set maximized_width/height.  Act on next_maximized.

	* nsterm.h (MAC_OS_X_VERSION_10_7, MAC_OS_X_VERSION_10_8): New.
	(EmacsView): Add variables for fullscreen.
	(handleFS, setFSValue, toggleFullScreen): New in EmacsView.
	(EmacsFSWindow): New interface for fullscreen.

2012-09-30  Juanma Barranquero  <lekktu@gmail.com>

	* makefile.w32-in ($(BLD)/profiler.$(O)): Update dependencies.

2012-09-30  Chong Yidong  <cyd@gnu.org>

	* fns.c (Frandom): Doc fix.

2012-09-30  Martin Rudalics  <rudalics@gmx.at>

	* window.c (Vwindow_combination_limit): New default value.
	(Qwindow_size): New symbol replacing Qtemp_buffer_resize.

2012-09-30  Paul Eggert  <eggert@cs.ucla.edu>

	* syssignal.h (PROFILER_CPU_SUPPORT): Don't define if PROFILING.
	Suggested by Eli Zaretskii in
	<http://lists.gnu.org/archive/html/emacs-devel/2012-09/msg00811.html>.

2012-09-30  Eli Zaretskii  <eliz@gnu.org>

	* profiler.c (Fprofiler_cpu_stop): Use timer_settime only if
	HAVE_TIMER_SETTIME is defined.

2012-09-30  Paul Eggert  <eggert@cs.ucla.edu>

	Profiler improvements: more-accurate timers, overflow checks.
	* profiler.c: Don't include stdio.h, limits.h, sys/time.h,
	signal.h, setjmp.h.  Include systime.h instead.
	(saturated_add): New function.
	(record_backtrace, current_sample_interval): Use EMACS_INT, not size_t.
	(record_backtrace, handle_profiler_signal): Saturate on fixnum overflow.
	(profiler_timer, profiler_timer_ok) [HAVE_TIMER_SETTIME]:
	New static vars.
	(enum profiler_cpu_running): New enum.
	(profiler_cpu_running): Now of that enum type, not bool.
	All uses changed to store the new value.
	(handle_profiler_signal): Rename from sigprof_handler_1,
	for consistency with other handlers.  Do not check whether
	cpu_log is a hash-table if garbage collecting, since it
	doesn't matter in that case.
	(deliver_profiler_signal): Rename from sigprof_handler,
	for consistency with other handlers.
	(setup_cpu_timer): New function, with much of what used to be in
	Fprofiler_cpu_start.  Check for out-of-range argument.
	Prefer timer_settime if available, and prefer
	thread cputime clocks, then process cputime clocks, then
	monotonic clocks, to the old realtime clock.  Use make_timeval
	to round more-correctly when falling back to setitimer.
	(Fprofiler_cpu_start): Use it.
	(Fprofiler_cpu_stop): Prefer timer_settime if available.
	Don't assume that passing NULL as the 2nd argument of setitimer
	is the same as passing a pointer to all-zero storage.
	Ignore SIGPROF afterwards.
	(malloc_probe): Saturate at MOST_POSITIVE_FIXNUM.
	* sysdep.c (emacs_sigaction_init): Also mask out SIGPROF in
	non-fatal signal handlers.  Ignore SIGPROF on startup.
	* syssignal.h (PROFILER_CPU_SUPPORT): Define this macro here, not
	in profiler.c, since sysdep.c now uses it.

	* sysdep.c (handle_fatal_signal): Bump backtrace size to 40.
	Suggested by Eli Zaretskii in
	<http://lists.gnu.org/archive/html/emacs-devel/2012-09/msg00796.html>.

2012-09-29  Juanma Barranquero  <lekktu@gmail.com>

	* makefile.w32-in ($(BLD)/profiler.$(O)): Update dependencies.

2012-09-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp.h (struct backtrace): Remove indirection for `function' field.
	* xdisp.c (redisplay_internal):
	* profiler.c (record_backtrace, sigprof_handler_1):
	* alloc.c (Fgarbage_collect):
	* eval.c (interactive_p, Fsignal, eval_sub, Ffuncall, Fbacktrace)
	(Fbacktrace_frame): Adjust accordingly.

2012-09-28  Glenn Morris  <rgm@gnu.org>

	* eval.c (Frun_hook_with_args, Frun_hook_with_args_until_success)
	(Frun_hook_with_args_until_failure): Doc fixes.

2012-09-28  Eli Zaretskii  <eliz@gnu.org>

	* xdisp.c (syms_of_xdisp) <Qredisplay_internal>: Rename from
	Qautomatic_redisplay and change the symbol name.  All users changed.

2012-09-28  Tomohiro Matsuyama  <tomo@cx4a.org>

	* profiler.c (sigprof_handler): Fix race condition.

2012-09-28  Glenn Morris  <rgm@gnu.org>

	* lread.c (lisp_file_lexically_bound_p): Handle #! lines.  (Bug#12528)

2012-09-27  Paul Eggert  <eggert@cs.ucla.edu>

	Check more robustly for timer_settime.
	* Makefile.in (LIB_TIMER_TIME): New macro.
	(LIBES): Add it.
	* atimer.c (alarm_timer, alarm_timer_ok, set_alarm, init_atimer):
	Use HAVE_TIMER_SETTIME, not SIGEV_SIGNAL, to decide whether to
	call timer_settime.

2012-09-26  Tomohiro Matsuyama  <tomo@cx4a.org>

	* profiler.c (Fprofiler_cpu_start): Remove unnecessary flag SA_SIGINFO.

2012-09-26  Juanma Barranquero  <lekktu@gmail.com>

	* makefile.w32-in ($(BLD)/profiler.$(O)): Update dependencies.

2012-09-26  Paul Eggert  <eggert@cs.ucla.edu>

	* character.h (MAYBE_UNIFY_CHAR): Remove.
	* charset.c, charset.h (maybe_unify_char): Now static.
	* charset.c (decode_char): Use maybe_unify_char, not MAYBE_UNIFY_CHAR.
	Since this stuff is now private to charset.c, there's no need for
	a public macro and no need to inline by hand.

2012-09-26  Tomohiro Matsuyama  <tomo@cx4a.org>
	    Stefan Monnier  <monnier@iro.umontreal.ca>
	    Juanma Barranquero  <lekktu@gmail.com>

	* profiler.c: New file.
	* Makefile.in (base_obj): Add profiler.o.
	* makefile.w32-in (OBJ2, GLOBAL_SOURCES): Add profiler.c.
	($(BLD)/profiler.$(O)): New target.
	* emacs.c (main): Call syms_of_profiler.
	* alloc.c (Qautomatic_gc): New constant.
	(MALLOC_PROBE): New macro.
	(xmalloc, xzalloc, xrealloc, lisp_malloc, lisp_align_malloc): Use it.
	(total_bytes_of_live_objects): New function.
	(Fgarbage_collect): Use it.  Record itself in backtrace_list.
	Call malloc_probe for the memory profiler.
	(syms_of_alloc): Define Qautomatic_gc.
	* eval.c (eval_sub, Ffuncall): Reorder assignments to avoid
	race condition.
	(struct backtrace): Move definition...
	* lisp.h (struct backtrace): ..here.
	(Qautomatic_gc, profiler_memory_running): Declare vars.
	(malloc_probe, syms_of_profiler): Declare functions.
	* xdisp.c (Qautomatic_redisplay): New constant.
	(redisplay_internal): Record itself in backtrace_list.
	(syms_of_xdisp): Define Qautomatic_redisplay.

2012-09-25  Eli Zaretskii  <eliz@gnu.org>
2012-09-25  Juanma Barranquero  <lekktu@gmail.com>

	* makefile.w32-in ($(BLD)/callproc.$(O)): Update dependencies.

2012-09-25  Paul Eggert  <eggert@cs.ucla.edu>

	Prefer POSIX timers if available.
	They avoid a race if the timer is too close to the current time.
	* atimer.c (alarm_timer, alarm_timer_ok) [SIGEV_SIGNAL]: New static vars.
	(set_alarm) [SIGEV_SIGNAL]: Use POSIX timers if available.
	(init_atimer) [SIGEV_SIGNAL]: Initialize them.

2012-09-25  Eli Zaretskii  <eliz@gnu.org>

	* coding.c (CHAR_STRING_ADVANCE_NO_UNIFY): Make it an alias of
	CHAR_STRING_ADVANCE.
	(STRING_CHAR_ADVANCE_NO_UNIFY): Make it an alias of
	STRING_CHAR_ADVANCE.

2012-09-25  Juanma Barranquero  <lekktu@gmail.com>

	Move Vlibrary_cache to emacs.c and reset before dumping.

	* lisp.h (reset_image_types): Declare.
	[WINDOWSNT] (Vlibrary_cache): Declare.

	* image.c (reset_image_types): New function.

	* emacs.c [WINDOWSNT] (Vlibrary_cache): Move from w32.c.
	(syms_of_emacs) [WINDOWSNT] <Vlibrary_cache>: Initialize and staticpro.
	(Fdump_emacs): Reset Vlibrary_cache and image_types.

	* w32.c (Vlibrary_cache): Do not define; moved to emacs.c
	(globals_of_w32) <Vlibrary_cache>: Do not initialize.

	* w32.h (Vlibrary_cache): Do not declare.

2012-09-25  Eli Zaretskii  <eliz@gnu.org>

	* w32proc.c (sys_signal): Handle all signals defined by the
	MS-Windows runtime, not just SIGCHLD.  Actually install the signal
	handlers for signals supported by Windows.  Don't override
	term_ntproc as the handler for SIGABRT.
	(sigaction): Rewrite to call sys_signal instead of duplicating its
	code.
	(sys_kill): Improve commentary.

	* w32.c (term_ntproc): Accept (and ignore) one argument, for
	consistency with a signature of a signal handler.  All callers
	changed.
	(init_ntproc): Accept an argument DUMPING.  If dumping, don't
	install term_ntproc as a signal handler for SIGABRT, as that
	should be done by the dumped Emacs.

	* w32.h (init_ntproc, term_ntproc): Adjust prototypes.

	* w32select.c (term_w32select): Protect against repeated
	invocation by setting clipboard_owner to NULL after calling
	DestroyWindow.

	* emacs.c (shut_down_emacs, main): Adapt the calls to init_ntproc
	and term_ntproc to their modified signatures.

	* character.c (char_string, string_char): Remove calls to
	MAYBE_UNIFY_CHAR.  See the discussion starting at
	http://lists.gnu.org/archive/html/emacs-devel/2012-09/msg00433.html
	for the details.

2012-09-25  Chong Yidong  <cyd@gnu.org>

	* xdisp.c (mode_line_inverse_video): Delete obsolete variable.

2012-09-24  Stefan Monnier  <monnier@iro.umontreal.ca>

	* bytecode.c (exec_byte_code): Signal an error instead of aborting,
	when encountering an unknown bytecode.

2012-09-24  Paul Eggert  <eggert@cs.ucla.edu>

	image.c, indent.c: Use bool for booleans.
	* dispextern.h (struct image_type): Members valid_p, load, init
	now return bool, not int.  All uses changed.
	* image.c: Omit unnecessary static decls.
	(x_create_bitmap_mask, x_build_heuristic_mask):
	Return void, not int, since callers don't care about the return value.
	(x_create_bitmap_mask, define_image_type, valid_image_p)
	(struct image_keyword, parse_image_spec, image_spec_value)
	(check_image_size, image_background)
	(image_background_transparent, x_clear_image_1)
	(postprocess_image, lookup_image, x_check_image_size)
	(x_create_x_image_and_pixmap, xbm_image_p)
	(Create_Pixmap_From_Bitmap_Data, xbm_read_bitmap_data)
	(xbm_load_image, xbm_file_p, xbm_load, xpm_lookup_color)
	(init_xpm_functions, xpm_valid_color_symbols_p, xpm_image_p)
	(xpm_load, xpm_load_image, lookup_rgb_color, lookup_pixel_color)
	(x_to_xcolors, x_build_heuristic_mask, pbm_image_p, pbm_load)
	(png_image_p, init_png_functions, png_load_body, png_load)
	(jpeg_image_p, init_jpeg_functions, jpeg_load_body, jpeg_load)
	(tiff_image_p, init_tiff_functions, tiff_load, gif_image_p)
	(init_gif_functions, gif_load, imagemagick_image_p)
	(imagemagick_load_image, imagemagick_load, svg_image_p)
	(init_svg_functions, svg_load, svg_load_image, gs_image_p)
	(gs_load):
	* nsimage.m (ns_load_image):
	* nsterm.m (ns_defined_color):
	* xfaces.c (tty_lookup_color, tty_defined_color, defined_color):
	* xfns.c (x_defined_color):
	* xterm.c (x_alloc_lighter_color_for_widget)
	(x_alloc_nearest_color_1, x_alloc_nearest_color)
	(x_alloc_lighter_color):
	* indent.c (disptab_matches_widthtab, current_column)
	(scan_for_column, string_display_width, indented_beyond_p)
	(compute_motion, vmotion, Fvertical_motion):
	Use bool for booleans.

2012-09-24  Chong Yidong  <cyd@gnu.org>

	* chartab.c (Fset_char_table_default): Obsolete function removed.

2012-09-23  Paul Eggert  <eggert@cs.ucla.edu>

	Move pid_t related decls out of lisp.h.
	* lisp.h, syswait.h (record_child_status_change, wait_for_termination)
	(interruptible_wait_for_termination):
	Move these decls from lisp.h to syswait.h, since they use pid_t.
	Needed on FreeBSD; see Herbert J. Skuhra in
	<http://lists.gnu.org/archive/html/emacs-devel/2012-09/msg00571.html>.
	* callproc.c: Include syswait.h.

	gnutls.c, gtkutil.c: Use bool for boolean.
	* gnutls.c (gnutls_global_initialized, init_gnutls_functions)
	(emacs_gnutls_handle_error):
	* gtkutil.c (xg_check_special_colors, xg_prepare_tooltip)
	(xg_hide_tooltip, xg_create_frame_widgets)
	(create_dialog, xg_uses_old_file_dialog)
	(xg_get_file_with_chooser, xg_get_file_with_selection)
	(xg_get_file_name, xg_have_tear_offs, create_menus, xg_create_widget)
	(xg_item_label_same_p, xg_update_menubar)
	(xg_modify_menubar_widgets, xg_event_is_for_menubar)
	(xg_ignore_gtk_scrollbar, xg_set_toolkit_scroll_bar_thumb)
	(xg_event_is_for_scrollbar, xg_pack_tool_bar, xg_make_tool_item)
	(is_box_type, xg_tool_item_stale_p, xg_update_tool_bar_sizes)
	(update_frame_tool_bar, free_frame_tool_bar):
	* gtkutil.c, w32term.c, xterm.c (x_wm_set_size_hint):
	* nsmenu.m (ns_update_menubar):
	* nsmenu.m, w32menu.c, xmenu.c (set_frame_menubar):
	* xfns.c (Fx_show_tip) [USE_GTK]:
	Use bool for boolean.
	* gtkutil.c (xg_update_frame_menubar):
	* xmenu.c (update_frame_menubar):
	Return void, not int, since caller ignores return value.
	* gtkutil.c (xg_change_toolbar_position):
	Return void, not 1.

2012-09-23  Juanma Barranquero  <lekktu@gmail.com>

	* makefile.w32-in (BLOCKINPUT_H): Remove.
	(SYSSIGNAL_H): New macro.
	($(BLD)/alloc.$(O), $(BLD)/atimer.$(O), $(BLD)/buffer.$(O))
	($(BLD)/callproc.$(O), $(BLD)/data.$(O), $(BLD)/dired.$(O))
	($(BLD)/dispnew.$(O), $(BLD)/editfns.$(O), $(BLD)/emacs.$(O))
	($(BLD)/eval.$(O), $(BLD)/fileio.$(O), $(BLD)/floatfns.$(O))
	($(BLD)/fns.$(O), $(BLD)/fontset.$(O), $(BLD)/frame.$(O))
	($(BLD)/fringe.$(O), $(BLD)/image.$(O), $(BLD)/insdel.$(O))
	($(BLD)/keyboard.$(O), $(BLD)/keymap.$(O), $(BLD)/lread.$(O))
	($(BLD)/menu.$(O), $(BLD)/w32inevt.$(O), $(BLD)/w32proc.$(O))
	($(BLD)/print.$(O), $(BLD)/process.$(O), $(BLD)/ralloc.$(O))
	($(BLD)/search.$(O), $(BLD)/sound.$(O), $(BLD)/sysdep.$(O))
	($(BLD)/term.$(O), $(BLD)/window.$(O), $(BLD)/xdisp.$(O))
	($(BLD)/xfaces.$(O), $(BLD)/w32fns.$(O), $(BLD)/w32menu.$(O))
	($(BLD)/w32term.$(O), $(BLD)/w32select.$(O), $(BLD)/w32reg.$(O))
	($(BLD)/w32xfns.$(O)): Update dependencies.

2012-09-23  Eli Zaretskii  <eliz@gnu.org>

	* .gdbinit: Set breakpoint on terminate_due_to_signal, not on
	fatal_error_backtrace.

	* w32proc.c (sys_kill): Undo last change: don't do anything when
	invoked to deliver SIGABRT to our own process.  This is now
	handled by emacs_raise.

2012-09-23  Juanma Barranquero  <lekktu@gmail.com>

	* w32term.c (w32_read_socket): Remove leftover reference to
	interrupt_input_pending.

2012-09-23  Paul Eggert  <eggert@cs.ucla.edu>

	Do not use SA_NODEFER.
	Problem reported by Dani Moncayo in
	<http://lists.gnu.org/archive/html/emacs-devel/2012-09/msg00557.html>.
	* alloc.c (die):
	* sysdep.c (emacs_abort): Do not reset signal handler.
	* emacs.c (terminate_due_to_signal): Reset signal handler here.
	* sysdep.c (init_signals): Do not use SA_NODEFER.  It wasn't
	wanted even on POSIXish hosts, and it doesn't work on Windows.

2012-09-23  Jan Djärv  <jan.h.d@swipnet.se>

	* xterm.c (x_term_init): Call fixup_locale before and after calling
	gtk_init (Bug#12392).

2012-09-23  Chong Yidong  <cyd@gnu.org>

	* w32.c (w32_delayed_load): Remove LIBRARIES argument; always use
	Vdynamic_library_alist.

	* gnutls.c (init_gnutls_functions): Caller changed; remove arg.
	(Fgnutls_available_p): Caller changed.

	* xml.c (init_libxml2_functions, Flibxml_parse_html_region)
	(Flibxml_parse_xml_region): Likewise.

	* dispextern.h (struct image_type): Remove arg from init function.

	* image.c (Finit_image_library, lookup_image_type)
	(define_image_type): Remove now-unneeded second arg.
	(init_xpm_functions, init_png_functions, init_jpeg_functions)
	(init_tiff_functions, init_gif_functions, init_svg_functions):
	Arglist and w32_delayed_load calling convention changed.
	(gs_type): Remove init_gs_functions; there is no such function.
	(valid_image_p, make_image): Fix caller to lookup_image_type.

2012-09-23  Paul Eggert  <eggert@cs.ucla.edu>

	Simplify and avoid signal-handling races (Bug#12471).
	* alloc.c (die):
	* sysdep.c (emacs_abort) [HAVE_NTGUI]:
	Avoid recursive loop if there's a fatal error in the function itself.
	* atimer.c (pending_atimers):
	* blockinput.h: Don't include "atimer.h"; no longer needed.
	(interrupt_input_pending): Remove.  All uses removed.
	pending_signals now counts both atimers and ordinary interrupts.
	This is less racy than having three separate pending-signal flags.
	(block_input, unblock_input, totally_unblock_input, unblock_input_to)
	(input_blocked_p):
	Rename from their upper-case counterparts BLOCK_INPUT,
	UNBLOCK_INPUT, TOTALLY_UNBLOCK_INPUT, UNBLOCK_INPUT_TO,
	INPUT_BLOCKED_P, and turn into functions.  All uses changed.
	This makes it easier to access volatile variables more accurately.
	(BLOCK_INPUT_RESIGNAL): Remove.  All uses replaced by unblock_input ().
	(input_blocked_p): Prefer this to 'interrupt_input_blocked', as
	that's more reliable if the code is buggy and sets
	interrupt_input_blocked to a negative value.  All uses changed.
	* atimer.c (deliver_alarm_signal):
	Remove.  No need to deliver this to the parent; any thread can
	handle this signal now.  All uses replaced by underlying handler.
	* atimer.c (turn_on_atimers):
	* dispnew.c (handle_window_change_signal):
	* emacs.c (handle_danger_signal):
	* keyboard.c (kbd_buffer_get_event):
	Don't reestablish signal handler; not needed with sigaction.
	* blockinput.h (UNBLOCK_INPUT_TO, TOTALLY_UNBLOCK_INPUT)
	(UNBLOCK_INPUT_TO):
	Rework to avoid unnecessary accesses to volatile variables.
	(UNBLOCK_INPUT_TO): Now a function.
	(totally_unblock_input, unblock_input): New decls.
	* data.c (handle_arith_signal, deliver_arith_signal): Move to sysdep.c
	(init_data): Remove.  Necessary stuff now done in init_signal.
	* emacs.c, xdisp.c: Include "atimer.h", since we invoke atimer functions.
	* emacs.c (handle_fatal_signal, deliver_fatal_signal): Move to sysdep.c.
	(fatal_error_code): Remove; no longer needed.
	(terminate_due_to_signal): Rename from fatal_error_backtrace, since
	it doesn't always backtrace.  All uses changed.  No need to reset
	signal to default, since sigaction and/or die does that for us now.
	Use emacs_raise (FOO), not kill (getpid (), FOO).
	(main): Check more-accurately whether we're dumping.
	Move fatal-error setup to sysdep.c
	* floatfns.c: Do not include "syssignal.h"; no longer needed.
	* gtkutil.c (xg_get_file_name, xg_get_font):
	Remove no-longer-needed signal-mask manipulation.
	* keyboard.c, process.c (POLL_FOR_INPUT):
	Don't depend on USE_ASYNC_EVENTS, a symbol that is never defined.
	* keyboard.c (read_avail_input): Remove.
	All uses replaced by gobble_input.
	(Ftop_level): Use TOTALLY_UNBLOCK_INPUT rather than open code.
	(kbd_buffer_store_event_hold, gobble_input):
	(record_asynch_buffer_change) [USABLE_SIGIO]:
	(store_user_signal_events):
	No need to mess with signal mask.
	(gobble_input): If blocking input and there are terminals, simply
	set pending_signals to 1 and return.  All hooks changed to not
	worry about whether input is blocked.
	(process_pending_signals): Clear pending_signals before processing
	them, in case a signal comes in while we're processing.
	By convention callers now test pending_signals before calling us.
	(UNBLOCK_INPUT_TO, unblock_input, totally_unblock_input):
	New functions, to support changes to blockinput.h.
	(handle_input_available_signal): Now extern.
	(reinvoke_input_signal): Remove.  All uses replaced by
	handle_async_input.
	(quit_count): Now volatile, since a signal handler uses it.
	(handle_interrupt): Now takes bool IN_SIGNAL_HANDLER as arg.
	All callers changed.  Block SIGINT only if not already blocked.
	Clear sigmask reliably, even if Fsignal returns, which it can.
	Omit unnecessary accesses to volatile var.
	(quit_throw_to_read_char): No need to restore sigmask.
	* keyboard.c (gobble_input, handle_user_signal):
	* process.c (wait_reading_process_output):
	Call signal-handling code rather than killing ourselves.
	* lisp.h: Include <float.h>, for...
	(IEEE_FLOATING_POINT): New macro, moved here to avoid duplication.
	(pending_signals): Now volatile.
	(syms_of_data): Now const if IEEE floating point.
	(handle_input_available_signal) [USABLE_SIGIO]:
	(terminate_due_to_signal, record_child_status_change): New decls.
	* process.c (create_process): Avoid disaster if memory is exhausted
	while we're processing a vfork, by tightening the critical section
	around the vfork.
	(send_process_frame, process_sent_to, handle_pipe_signal)
	(deliver_pipe_signal): Remove.  No longer needed, as Emacs now
	ignores SIGPIPE.
	(send_process): No need for setjmp/longjmp any more, since the
	SIGPIPE stuff is now gone.  Instead, report an error if errno
	is EPIPE.
	(record_child_status_change): Now extern.  PID and W are now args.
	Return void, not bool.  All callers changed.
	* sysdep.c (wait_debugging) [(BSD_SYSTEM || HPUX) && !defined (__GNU__)]:
	Remove.  All uses removed.  This bug should be fixed now in a
	different way.
	(wait_for_termination_1): Use waitpid rather than sigsuspend,
	and record the child status change directly.  This avoids the
	need to futz with the signal mask.
	(process_fatal_action): Move here from emacs.c.
	(emacs_sigaction_flags): New function, containing
	much of what used to be in emacs_sigaction_init.
	(emacs_sigaction_init): Use it.  Block nonfatal system signals that are
	caught by emacs, to make races less likely.
	(deliver_process_signal): Rename from handle_on_main_thread.
	All uses changed.
	(BACKTRACE_LIMIT_MAX): Now at top level.
	(thread_backtrace_buffer, threadback_backtrace_pointers):
	New static vars.
	(deliver_thread_signal, deliver_fatal_thread_signal):
	New functions, for more-accurate delivery of thread-specific signals.
	(handle_fatal_signal, deliver_fatal_signal): Move here from emacs.c.
	(deliver_arith_signal): Handle in this thread, not
	in the main thread, since it's triggered by this thread.
	(maybe_fatal_sig): New function.
	(init_signals): New arg DUMPING so that we can be more accurate
	about whether we're dumping.  Caller changed.
	Treat thread-specific signals differently from process-general signals.
	Block all signals while handling fatal error; that's safer.
	xsignal from SIGFPE only on non-IEEE hosts, treating it as fatal
	on IEEE hosts.
	When batch, ignore SIGHUP, SIGINT, SIGTERM if they were already ignored.
	Ignore SIGPIPE unless batch.
	(emacs_backtrace): Output backtrace for the appropriate thread,
	which is not necessarily the main thread.
	* syssignal.h: Include <stdbool.h>.
	(emacs_raise): New macro.
	* xterm.c (x_connection_signal): Remove; no longer needed
	now that we use sigaction.
	(x_connection_closed): No need to mess with sigmask now.
	(x_initialize): No need to reset SIGPIPE handler here, since
	init_signals does this for us now.

2012-09-23  Jan Djärv  <jan.h.d@swipnet.se>

	* nsterm.m (ns_dumpglyphs_image): dr is a new rect to draw image into,
	background rect may be larger (Bug#12245).

2012-09-23  Chong Yidong  <cyd@gnu.org>

	* keyboard.c (timer_check): Avoid quitting during Fcopy_sequence.

2012-09-22  Paul Eggert  <eggert@cs.ucla.edu>

	* .gdbinit: Just stop at fatal_error_backtrace.
	See Stefan Monnier's request in
	<http://lists.gnu.org/archive/html/emacs-devel/2012-09/msg00549.html>.
	Remove no-longer-used query of system type.

2012-09-22  Chong Yidong  <cyd@gnu.org>

	* search.c (Freplace_match): Doc fix (Bug#12325).

	* minibuf.c (Finternal_complete_buffer): Doc fix (Bug#12391).

	* editfns.c (Fline_beginning_position): Doc fix (Bug#12416).
	(Fline_end_position): Doc fix.

	* cmds.c (Fforward_char, Fbackward_char): Doc fix (Bug#12414).

2012-09-22  Chong Yidong  <cyd@gnu.org>

	* dispextern.h (struct image_type): Add new slot, storing a type
	initialization function.

	* image.c (define_image_type): Call the image initializer function
	if it is defined.  Arguments and return value changed.
	(valid_image_p, make_image): Callers changed.
	(xbm_type, xpm_type, pbm_type, png_type, jpeg_type, tiff_type)
	(gif_type, imagemagick_type, svg_type, gs_type):
	Add initialization functions.
	(Finit_image_library): Call lookup_image_type.
	(CHECK_LIB_AVAILABLE): Macro deleted.
	(lookup_image_type): Call define_image_type here, rather than via
	Finit_image_library, and without using CHECK_LIB_AVAILABLE.
	(syms_of_image): Move define_image_type calls for xbm_type and
	pbm_type to lookup_image_type.

2012-09-22  Eli Zaretskii  <eliz@gnu.org>

	* keyboard.c (timer_check_2): Move calculation of 'timers' and
	'idle_timers' from here ...
	(timer_check): ... to here.  Use Fcopy_sequence to copy the timer
	lists, to avoid infloops when the timer does something stupid,
	like reinvoke itself with the same or smaller time-out.
	(Bug#12447)

2012-09-22  Martin Rudalics  <rudalics@gmx.at>

	* window.c (Fsplit_window_internal): Handle only Qt value of
	Vwindow_combination_limit separately.
	(Qtemp_buffer_resize): New symbol.
	(Vwindow_combination_limit): New default value.
	Rewrite doc-string.

2012-09-22  Eli Zaretskii  <eliz@gnu.org>

	* xdisp.c (next_overlay_string): Initialize it->end_charpos for
	the new overlay string.  (Bug#10159)

2012-09-22  Paul Eggert  <eggert@cs.ucla.edu>

	* emacs.c (shut_down_emacs): Don't assume stderr is buffered,
	or that fprintf is async-signal-safe.  POSIX doesn't require
	either assumption.

2012-09-22  Chong Yidong  <cyd@gnu.org>

	* buffer.c (Fset_buffer_modified_p): Handle indirect buffers
	(Bug#8207).

2012-09-22  Kenichi Handa  <handa@gnu.org>

	* composite.c (composition_reseat_it): Handle the case that a
	grapheme cluster is not covered by a single font (Bug#12352).

2012-09-21  Chong Yidong  <cyd@gnu.org>

	* image.c (define_image_type): Avoid adding duplicate types to
	image_types (Bug#12463).  Suggested by Jörg Walter.

2012-09-21  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* unexmacosx.c: Define LC_DATA_IN_CODE if not defined.
	(print_load_command_name): Add case LC_DATA_IN_CODE.
	(dump_it) [LC_DATA_IN_CODE]: Call copy_linkedit_data.

2012-09-21  Glenn Morris  <rgm@gnu.org>

	* eval.c (Frun_hook_with_args_until_success)
	(Frun_hook_with_args_until_failure): Doc fixes.  (Bug#12393)

2012-09-21  Andreas Schwab  <schwab@linux-m68k.org>

	* fileio.c (Ffile_selinux_context): Only call freecon when
	lgetfilecon succeeded.
	(Fset_file_selinux_context): Likewise.  (Bug#12444)

2012-09-21  Eli Zaretskii  <eliz@gnu.org>

	* xdisp.c (try_window_reusing_current_matrix): Under bidi
	reordering, locate the cursor by calling set_cursor_from_row; if
	that fails, clear the desired glyph matrix before returning a
	failure indication to the caller.  Fixes leaving garbled display
	when fast scrolling with a down-key.  (Bug#12403)
	(compute_stop_pos_backwards): Fix a typo that caused crashes while
	scrolling through multibyte text.

2012-09-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* alloc.c (mark_object) <PVEC_WINDOW>: Mark prev/next_buffers *after*
	calling mark_vectorlike since that's the one that marks the window.
	(mark_discard_killed_buffers): Mark the final cdr.
	* window.h (struct window): Move prev/next_buffers to the
	non-standard fields.
	* window.c (make_window): Initialize prev/next_buffers manually.

2012-09-20  Paul Eggert  <eggert@cs.ucla.edu>

	Omit unused arg EXPECTED from socket hooks.
	* keyboard.c (gobble_input, read_avail_input, tty_read_avail_input):
	* nsterm.m (ns_term_init):
	* termhooks.h (struct terminal.read_socket_hook):
	* w32inevt.c (w32_console_read_socket):
	* w32term.c (w32_read_socket):
	* xterm.c (XTread_socket):
	Omit unused arg EXPECTED.  All callers changed.
	(store_user_signal_events): Return void, not int, since callers no
	longer care about the return value.  All uses changed.

2012-09-20  Juanma Barranquero  <lekktu@gmail.com>

	* w32gui.h (XParseGeometry): Do not declare.

2012-09-19  Paul Eggert  <eggert@cs.ucla.edu>

	* w32inevt.c (w32_console_read_socket): Return -1 on failure, not 0.
	Ignore 'expected'.  See Eli Zaretskii in
	<http://bugs.gnu.org/12471#8> (last line).

	* frame.c (read_integer): Remove.  All uses replaced by strtol/strtoul.
	(XParseGeometry): Now static.  Substitute extremal values for
	values that are out of range.

2012-09-19  Jan Djärv  <jan.h.d@swipnet.se>

	* w32xfns.c (read_integer, XParseGeometry): Move to frame.c.

	* nsfns.m (XParseGeometry): Remove.
	(Fx_create_frame): Call x_set_offset to correctly interpret
	top_pos in geometry.

	* frame.c (read_integer, XParseGeometry): Move from w32xfns.c.
	(Fx_parse_geometry): If there is a space in string, call
	Qns_parse_geometry, otherwise do as on other terms (Bug#12368).

2012-09-17  Eli Zaretskii  <eliz@gnu.org>

	* search.c (scan_buffer): Use character positions in calls to
	region_cache_forward and region_cache_backward, not byte
	positions.  (Bug#12196)

	* w32term.c (w32_read_socket): Set pending_signals to 1, like
	xterm.c does.  Reported by Daniel Colascione <dancol@dancol.org>.

	* ralloc.c (r_alloc_init) [!SYSTEM_MALLOC]: Initialize
	__malloc_extra_blocks to 32 instead of 64, like alloc.c did in
	emacs_blocked_malloc, now deleted.

2012-09-17  Paul Eggert  <eggert@cs.ucla.edu>

	Remove no-longer-needed Solaris 2.4 vfork bug workaround.
	The workaround was for improving performance on Solaris 2.4, but
	is getting in the way now.  Emacs will still work if someone is
	still running Solaris 2.4 in a museum somewhere; Sun dropped
	support for Solaris 2.4 in 2003.
	* callproc.c (Fcall_process) [HAVE_WORKING_VFORK]:
	* process.c (create_process) [HAVE_WORKING_VFORK]:
	Omit now-unnecessary workaround for the Solaris 2.4 vfork bug,
	since Emacs no longer uses vfork on that platform.

2012-09-17  Glenn Morris  <rgm@gnu.org>

	* emacs.c: Use COPYRIGHT.

2012-09-16  Paul Eggert  <eggert@cs.ucla.edu>

	Remove configure's --without-sync-input option (Bug#12450).
	When auditing signal-handling in preparation for cleaning it up,
	I found that SYNC_INPUT has race conditions and would be a real
	pain to fix.  Since it's an undocumented and deprecated
	configure-time option, now seems like a good time to remove it.
	Also see <http://bugs.gnu.org/11080#16>.
	* alloc.c (_bytes_used, __malloc_extra_blocks, _malloc_internal)
	(_free_internal) [!DOUG_LEA_MALLOC]: Remove decls.
	(alloc_mutex) [!SYSTEM_MALLOC && !SYNC_INPUT && HAVE_PTHREAD]:
	(malloc_hysteresis):
	(check_depth) [XMALLOC_OVERRUN_CHECK]:
	(MALLOC_BLOCK_INPUT, MALLOC_UNBLOCK_INPUT):
	(__malloc_hook, __realloc_hook, __free_hook, BYTES_USED)
	(dont_register_blocks, bytes_used_when_reconsidered)
	(bytes_used_when_full, emacs_blocked_free, emacs_blocked_malloc)
	(emacs_blocked_realloc, reset_malloc_hooks, uninterrupt_malloc):
	[!SYSTEM_MALLOC && !SYNC_INPUT]:
	Remove.  All uses removed.
	(MALLOC_BLOCK_INPUT, MALLOC_UNBLOCK_INPUT): Use a different
	implementation, one that depends on whether the new macro
	XMALLOC_BLOCK_INPUT_CHECK is defined, not on whether SYNC_INPUT
	is defined.
	* atimer.c (run_timers, handle_alarm_signal):
	* keyboard.c (pending_signal, poll_for_input_1, poll_for_input)
	(handle_async_input, process_pending_signals)
	(handle_input_available_signal, init_keyboard):
	* nsterm.m (ns_read_socket):
	* process.c (wait_reading_process_output):
	* regex.c (immediate_quit, IMMEDIATE_QUIT_CHECK):
	* sysdep.c (emacs_sigaction_init) [SA_RESTART]:
	(emacs_write):
	* xterm.c (XTread_socket):
	Assume SYNC_INPUT.
	* conf_post.h (SA_RESTART) [IRIX6_5]: Do not #undef.
	* eval.c (handling_signal): Remove.  All uses removed.
	* lisp.h (ELSE_PENDING_SIGNALS): Remove.
	All uses replaced with the SYNC_INPUT version.
	(reset_malloc_hooks, uninterrupt_malloc, handling_signal):
	Remove decls.
	* sysdep.c, syssignal.h (main_thread) [FORWARD_SIGNAL_TO_MAIN_THREAD]:
	Now static.

	* font.c (Ffont_shape_gstring): Remove unused local.

2012-09-16  Glenn Morris  <rgm@gnu.org>

	* Makefile.in (clean): No longer run nextstep's clean.

	* Makefile.in (ns_appdir, ns_appbindir, ns_appsrc): Remove variables.
	(ns_frag): Remove.
	(ns-app): Move here from ns.mk, and simplify.
	(clean): Simplify nextstep entry.
	* ns.mk: Remove file.

2012-09-17  Kenichi Handa  <handa@gnu.org>

	* font.c (Ffont_shape_gstring): Fix previous change; GLYPHs may
	not covert the last few charactes.

2012-09-16  Kenichi Handa  <handa@gnu.org>

	* font.c (Ffont_shape_gstring): Don't adjust grapheme cluster
	here, but just check the validity of glyphs in the glyph-string.

2012-09-16  Martin Rudalics  <rudalics@gmx.at>

	* window.c (Fwindow_parameter, Fset_window_parameter):
	Accept any window as argument (Bug#12452).

2012-09-16  Jan Djärv  <jan.h.d@swipnet.se>

	* nsfns.m (Fx_open_connection): Move initialization of ns_*_types
	to ns_term_init to avoid memory leak.

	* nsterm.m (ns_update_begin): Initialize bp after lcokFocus, use
	explicit retain/release.
	(ns_term_init): Only allow one display.  Initialize outerpool and
	ns_*_types.

2012-09-15  Paul Eggert  <eggert@cs.ucla.edu>

	Port _setjmp fix to POSIXish hosts as well as Microsoft.
	* image.c (_setjmp) [!HAVE__SETJMP]: Restore definition, as
	it's needed on POSIXish hosts that lack _setjmp.  Attempt to solve
	the Microsoft problem in a different way, by altering ../nt/config.nt.

2012-09-15  Eli Zaretskii  <eliz@gnu.org>

	* w32xfns.c:
	* w32uniscribe.c:
	* w32term.c:
	* w32select.c:
	* w32reg.c:
	* w32proc.c:
	* w32menu.c:
	* w32inevt.c:
	* w32heap.c:
	* w32font.c:
	* w32fns.c:
	* w32console.c:
	* w32.c:
	* w16select.c: Remove inclusion of setjmp.h, as it is now included
	by lisp.h.  This completes removal of setjmp.h inclusion
	erroneously announced in the previous commit.  (Bug#12446)

	* lisp.h [!HAVE__SETJMP, !HAVE_SIGSETJMP]: Make the commentary
	more accurate.

	* image.c (_setjmp) [!HAVE__SETJMP]: Define only if 'setjmp' is
	not defined as a macro.  The latter happens on MS-Windows.
	(Bug#12446)

2012-09-15  Paul Eggert  <eggert@cs.ucla.edu>

	Port better to POSIX hosts lacking _setjmp (Bug#12446).
	* lisp.h: Include <setjmp.h> here, since we use its symbols here.
	Some instances of '#include <setjmp.h>' removed, if the
	only reason for the instance was because "lisp.h" was included.
	(sys_jmp_buf, sys_setjmp, sys_longjmp): New symbols.
	Unless otherwise specified, replace all uses of jmp_buf, _setjmp,
	and _longjmp with the new symbols.  Emacs already uses _setjmp if
	available, so this change affects only POSIXish hosts that have
	sigsetjmp but not _setjmp, such as some versions of Solaris and
	Unixware.  (Also, POSIX-2008 marks _setjmp as obsolescent.)
	* image.c (_setjmp, _longjmp) [HAVE_PNG && !HAVE__SETJMP]: New macros.
	(png_load_body) [HAVE_PNG]:
	(PNG_LONGJMP) [HAVE_PNG && PNG_LIBPNG_VER < 10500]:
	(PNG_JMPBUF) [HAVE_PNG && PNG_LIBPNG_VER >= 10500]:
	Use _setjmp and _longjmp rather than sys_setjmp and sys_longjmp,
	since PNG requires jmp_buf.  This is the only exception to the
	general rule that we now use sys_setjmp and sys_longjmp.
	This exception is OK since this code does not change the signal
	mask or longjmp out of a signal handler.

2012-09-14  Paul Eggert  <eggert@cs.ucla.edu>

	* alloc.c [!SYSTEM_MALLOC && !SYNC_INPUT && HAVE_PTHREAD]:
	Include "syssignal.h", for 'main_thread'.

2012-09-14  Dmitry Antipov  <dmantipov@yandex.ru>

	Avoid out-of-range marker position (Bug#12426).
	* insdel.c (replace_range, replace_range_2):
	Adjust markers before overlays, as suggested by comments.
	(insert_1_both, insert_from_buffer_1, adjust_after_replace):
	Remove redundant check before calling offset_intervals.

2012-09-14  Martin Rudalics  <rudalics@gmx.at>

	* xdisp.c (Fformat_mode_line): Unconditionally save/restore
	current buffer (Bug#12387).

2012-09-14  Juanma Barranquero  <lekktu@gmail.com>

	* makefile.w32-in ($(BLD)/alloc.$(O)): Update dependencies.

2012-09-13  Paul Eggert  <eggert@cs.ucla.edu>

	Use a more backwards-compatible timer format (Bug#12430).
	* keyboard.c (decode_timer): Get PSECS from the 8th (origin-0)
	vector element, not from the 4th, since PSECS is now at the end.
	(Fcurrent_idle_time): Doc fix.

2012-09-13  Dmitry Antipov  <dmantipov@yandex.ru>

	Function to mark objects and remove killed buffers at once.
	* alloc.c (discard_killed_buffers): Rename to ...
	(mark_discard_killed buffers) ... new name.  Add marking
	of remaining objects.  Fix comment.  Adjust users.
	(mark_object): Do not touch frame buffer lists here.
	* frame.c (delete_frame): Reset frame buffer lists here.

2012-09-13  Paul Eggert  <eggert@cs.ucla.edu>

	Better workaround for GNOME bug when --enable-gcc-warnings.
	* emacsgtkfixed.c (G_STATIC_ASSERT): Remove, undoing last change.
	Instead, disable -Wunused-local-typedefs.  See Dmitry Antipov in
	<http://lists.gnu.org/archive/html/emacs-devel/2012-09/msg00335.html>.

	Simplify SIGIO usage (Bug#12408).
	The code that dealt with SIGIO was crufty and confusing, e.g., it
	played tricks like "#undef SIGIO" but these tricks were not used
	consistently.  Simplify mostly by not #undeffing standard symbols,
	e.g., use "defined USABLE_SIGIO" (our symbol, which we can define
	or not as we please) rather than "defined SIGIO" (standard symbol
	that we probably shouldn't #undef).
	* conf_post.h [USG5_4]: Do not include <sys/wait.h> here.
	Modules that need it can include it.
	[USG5_4 && emacs]: Likewise, do not include the streams stuff here.
	* dispextern.h (ignore_sigio): New decl.
	* emacs.c (shut_down_emacs): Invoke unrequest_sigio
	unconditionally, since it's now a no-op if !USABLE_SIGIO.
	* emacs.c (shut_down_emacs):
	* keyboard.c (kbd_buffer_store_event_hold):
	Use ignore_sigio rather than invoking 'signal' directly.
	* keyboard.c (USABLE_FIONREAD && USG5_4): Include <sys/filio.h>,
	for FIONREAD.
	(FIONREAD, SIGIO): Do not #undef.
	(tty_read_avail_input): Use #error rather than a syntax error.
	* process.c [USG5_4]: Include <sys/stream.h> and <sys/stropts.h>,
	for I_PIPE, used by SETUP_SLAVE_PTY.
	(DATAGRAM_SOCKETS): Simplify defn, based on USABLE_FIONREAD.
	* sysdep.c (croak): Remove; no longer needed.  This bit of
	temporary code, with Fred N. Fish's comment that it's temporary,
	has been in Emacs since at least 1992!
	(init_sigio, reset_sigio, request_sigio, unrequest_sigio):
	Arrange for them to be no-ops in all cases when ! USABLE_SIGIO.
	* syssignal.h (croak): Remove decl.
	(SIGIO, SIGPOO, SIGAIO, SIGPTY): Do not #undef; that's too fragile.
	* systty.h [!NO_TERMIO]: Do not include <termio.h>; no longer needed
	now that we're termios-only.
	(FIONREAD, ASYNC) [BROKEN_FIONREAD]: Do not #undef.
	* term.c (dissociate_if_controlling_tty): Use #error rather than
	a run-time error.

	Work around GCC and GNOME bugs when --enable-gcc-warnings.
	* emacsgtkfixed.c (G_STATIC_ASSERT): Redefine to use 'verify',
	to work around GNOME bug 683906.
	* image.c (jpeg_load_body) [HAVE_JPEG && lint]: Pacify gcc -Wclobber.
	(struct my_jpeg_error_mgr) [HAVE_JPEG && lint]: New member fp.
	This works around GCC bug 54561.

2012-09-12  Paul Eggert  <eggert@cs.ucla.edu>

	More fixes for 'volatile' and setjmp/longjmp.
	* eval.c (Fdefvar, Fcondition_case): Remove unnecessary 'volatile's.
	* image.c (struct png_load_context) [HAVE_PNG]: New type.
	(png_load_body) [HAVE_PNG]:
	(jpeg_load_body) [HAVE_JPEG]:
	New function, with most of the old parent function's body.
	(png_load) [HAVE_PNG]:
	(jpeg_load) [HAVE_JPEG]:
	Invoke the new function, to avoid longjmp munging our locals.
	(struct my_jpeg_error_mgr) [HAVE_JPEG]: New members cinfo, failure_code.
	(my_error_exit) [HAVE_JPEG]: Don't trust 'setjmp' to return 2 when
	longjmp is passed 2, as the C standard doesn't guarantee this.
	Instead, store the failure code into mgr->failure_code.

2012-09-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keyboard.c (read_char, requeued_events_pending_p, Finput_pending_p)
	(Fdiscard_input, quit_throw_to_read_char, init_keyboard)
	(syms_of_keyboard): Remove support for unread-command-char.

2012-09-12  Eli Zaretskii  <eliz@gnu.org>

	* w32proc.c (sys_kill): If PID is our process ID and the signal is
	SIGABRT, call emacs_abort.  Avoids silently exiting upon assertion
	violation.  (Bug#12426)

2012-09-12  Paul Eggert  <eggert@cs.ucla.edu>

	* image.c (jpeg_memory_src): Don't assume string len fits in unsigned.

2012-09-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* eval.c: Add `inhibit-debugger'.
	(Qinhibit_debugger): New symbol.
	(call_debugger): Bind it instead of Qdebug_on_error.
	(maybe_call_debugger): Test Vinhibit_debugger.
	(syms_of_eval): Define inhibit-debugger.
	* xdisp.c (set_message): Don't bind Qinhibit_debug_on_message.
	(syms_of_xdisp): Remove inhibit-debug-on-message.

2012-09-11  Paul Eggert  <eggert@cs.ucla.edu>

	Avoid _setjmp/_longjmp problems with local nonvolatile variables.
	If a nonvolatile local variable is written before a _longjmp to
	the frame containing the variable, and is read after the _longjmp,
	the value read is indeterminate.  Some local variables of type
	'struct handler' and 'struct catchtag' are used in this way, so
	mark each of their slots as volatile if the slot can be set before
	_longjmp and read afterwards.
	* lisp.h (struct handler): var and chosen_clause are now volatile.
	(struct catchtag): val, next, and pdlcount are now volatile.

	* bidi.c (bidi_push_it, bidi_pop_it):
	* fns.c (copy_hash_table):
	* image.c (define_image_type):
	* keyboard.c (kbd_buffer_store_event_hold):
	* process.c (Fprocess_send_eof):
	* xfaces.c (x_create_gc) [HAVE_NS]:
	* xgselect.c (xg_select):
	Prefer assignment to memcpy when either will do.

	* alloc.c (discard_killed_buffers): Tune and simplify a bit.
	Use pointer-to-a-pointer to simplify and avoid a NILP check each
	time an item is removed.  No need to mark this function 'inline';
	the compiler knows better than we do.

2012-09-11  Jan Djärv  <jan.h.d@swipnet.se>

	* nsterm.m (ns_judge_scroll_bars): Pass NO to updateFrameSize.
	(updateFrameSize:): Add delay parameter to updateFrameSize, send it
	to change_frame_size (Bug#12388).
	(windowDidResize:): Pass YES to updateFrameSize.

	* nsterm.h: Add delay parameter to updateFrameSize.

2012-09-11  Dmitry Antipov  <dmantipov@yandex.ru>

	Discard killed buffers from deleted window and frame objects.
	This reduces an amount of references to killed buffers and
	helps GC to reclaim them faster.
	* alloc.c (discard_killed_buffers): New function.
	(mark_object): Use it for deleted windows and frames.
	(mark_object): If symbol's value is set up for a killed buffer
	or deleted frame, restore its global binding.
	* data.c (swap_in_global_binding): Add GC notice.
	(swap_in_symval_forwarding): Use convenient set_blv_where.
	* window.c (wset_next_buffers, wset_prev_buffers): Move ...
	* window.h: ... to here.

2012-09-11  Dmitry Antipov  <dmantipov@yandex.ru>

	Convenient macro to check whether the buffer is live.
	* buffer.h (BUFFER_LIVE_P): New macro.
	* alloc.c, buffer.c, editfns.c, insdel.c, lread.c, marker.c:
	* minibuf.c, print.c, process.c, window.c, xdisp.c: Use it.

2012-09-11  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* xdisp.c (right_overwritten, right_overwriting): Also handle gstring
	composition cases (Bug#12364).

	* xterm.c (x_draw_glyph_string): Avoid overwriting inverted left
	overhang of succeeding glyphs overlapping box cursor.

	* w32term.c (x_draw_glyph_string): Likewise.

2012-09-11  Paul Eggert  <eggert@cs.ucla.edu>

	Simplify, document, and port floating-point (Bug#12381).
	The porting part of this patch fixes bugs on non-IEEE platforms
	with frexp, ldexp, logb.
	* data.c, lisp.h (Qdomain_error, Qsingularity_error, Qunderflow_error):
	Now static.
	* floatfns.c: Simplify discussion of functions that Emacs doesn't
	support, by removing commented-out code and briefly listing the
	C89 functions excluded.  The commented-out stuff was confusing
	maintenance, e.g., we thought we needed cbrt but it was commented out.
	(logb): Remove decl; no longer needed.
	(isfinite): New macro, if not already supplied.
	(isnan): Don't replace any existing macro.
	(Ffrexp, Fldexp): Define even if !HAVE_COPYSIGN, as frexp and ldexp
	are present on all C89 platforms.
	(Ffrexp): Do not special-case zero, as frexp does the right thing
	for that case.
	(Flogb): Do not use logb, as it doesn't have the desired meaning
	on hosts that use non-base-2 floating point.  Instead, stick with
	frexp, which is C89 anyway.  Do not pass an infinity or a NaN to
	frexp, to avoid getting an unspecified result.

	* xdisp.c (Qinhibit_debug_on_message): Now static.

2012-09-10  Jan Djärv  <jan.h.d@swipnet.se>

	* nsterm.m (ns_update_begin): Set clip path to whole view by using
	NSBezierPath (Bug#12131).

2012-09-10  Chong Yidong  <cyd@gnu.org>

	* fns.c (Fdelq, Fdelete): Doc fix.

2012-09-10  Paul Eggert  <eggert@cs.ucla.edu>

	* lisp.h (XSETINT, XSETCONS, XSETVECTOR, XSETSTRING, XSETSYMBOL)
	(XSETFLOAT, XSETMISC): Parenthesize macro bodies.

2012-09-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp.h (make_lisp_ptr): New macro to replace XSET.
	(XSETCONS, XSETVECTOR, XSETSTRING, XSETSYMBOL, XSETFLOAT, XSETMISC):
	Use it.

2012-09-09  Eli Zaretskii  <eliz@gnu.org>

	* fringe.c (draw_fringe_bitmap_1): Don't reduce the width of the
	left fringe if the window has a left margin.  This avoids leaving
	traces of the cursor because its leftmost pixel is not drawn over.

	* dispnew.c (update_window_line): When the left margin area of a
	screen line is updated, set the redraw_fringe_bitmaps_p flag of
	that screen line.  (Bug#12277)

2012-09-09  Paul Eggert  <eggert@cs.ucla.edu>

	Assume C89 or later for math functions (Bug#12381).
	This simplifies the code, and makes it a bit smaller and faster,
	and (most important) makes it easier to clean up signal handling
	since we can stop worring about floating-point exceptions in
	library code.  That was a problem before C89, but the problem
	went away many years ago on all practical Emacs targets.
	* data.c, image.c, lread.c, print.c:
	Don't include <math.h>; no longer needed.
	* data.c, floatfns.c (IEEE_FLOATING_POINT): Don't worry that it
	might be autoconfigured, as that never happens.
	* data.c (fmod):
	* doprnt.c (DBL_MAX_10_EXP):
	* print.c (DBL_DIG):
	Remove.  C89 or later always defines these.
	* floatfns.c (HAVE_MATHERR, FLOAT_CHECK_ERRNO, FLOAT_CHECK_DOMAIN)
	(in_float, float_error_arg, float_error_arg2, float_error_fn_name)
	(arith_error, domain_error, domain_error2):
	Remove all this pre-C89 cruft.  Do not include <errno.h> as that's
	no longer needed -- we simply return what C returns.  All uses removed.
	(IN_FLOAT, IN_FLOAT2): Remove.  All uses replaced with
	the wrapped code.
	(FLOAT_TO_INT, FLOAT_TO_INT2, range_error, range_error2):
	Remove.  All uses expanded, as these macros are no longer used
	more than once and are now more trouble than they're worth.
	(Ftan): Use tan, not sin / cos.
	(Flogb): Assume C89 frexp.
	(fmod_float): Assume C89 fmod.
	(matherr) [HAVE_MATHERR]: Remove; no longer needed.
	(init_floatfns): Remove.  All uses removed.

2012-09-08  Jan Djärv  <jan.h.d@swipnet.se>

	* nsterm.m (ns_draw_fringe_bitmap, ns_dumpglyphs_image): Take back
	compositeToPoint for OSX < 10.6 (Bug#12390).

2012-09-08  Paul Eggert  <eggert@cs.ucla.edu>

	* floatfns.c (Ftan): Use tan (x), not (sin (x) / cos (x)).
	This produces more-accurate results.

2012-09-08  Jan Djärv  <jan.h.d@swipnet.se>

	* nsterm.m (updateFrameSize): Call setFrame: on the view when size
	changes (Bug#12088).

2012-09-08  Chong Yidong  <cyd@gnu.org>

	* syntax.c (Fstring_to_syntax): Doc fix.

2012-09-08  Jan Djärv  <jan.h.d@swipnet.se>

	* nsterm.m (ns_clip_to_row): Remove code that deals with drawing fringe
	in the internal border.
	(x_set_window_size): Remove static variables and their usage.
	(ns_redraw_scroll_bars): Fix NSTRACE arg.
	(ns_after_update_window_line, ns_draw_fringe_bitmap):
	Remove fringe/internal border adjustment (Bug#11052).
	(ns_draw_fringe_bitmap): Make code more like other terms (xterm.c).
	(ns_draw_window_cursor): Remove fringe/internal border adjustment.
	(ns_fix_rect_ibw): Remove.
	(ns_get_glyph_string_clip_rect): Remove call to ns_fix_rect_ibw.
	(ns_dumpglyphs_box_or_relief): Ditto.
	(ns_maybe_dumpglyphs_background): Remove fringe/internal border
	adjustment.
	(ns_dumpglyphs_image): Ditto.
	(ns_dumpglyphs_stretch): Fix coding style.  Remove fringe/internal
	border adjustment.
	(ns_set_vertical_scroll_bar): Remove variables barOnVeryLeft/Right and
	their usage.  Add fringe_extended_p and its use as in other terms.
	(ns_judge_scroll_bars): Code style fix.  Call updateFrameSize if
	scroll bar was removed.
	(updateFrameSize): New function.
	(windowDidResize): Move code to updateFrameSize and call it.

	* nsterm.h (EmacsView): Add updateFrameSize.

2012-09-07  Chong Yidong  <cyd@gnu.org>

	* textprop.c (Fget_text_property): Minor doc fix (Bug#12323).

	* data.c (Flocal_variable_if_set_p): Doc fix (Bug#10713).

2012-09-07  Paul Eggert  <eggert@cs.ucla.edu>

	More signal-handler cleanup (Bug#12327).
	* emacs.c (main): Convert three 'signal' calls to 'sigaction' calls.
	Problem introduced when merging patches.  Noted by Eli Zaretskii in
	<http://bugs.gnu.org/12327#67>.
	* floatfns.c: Comment fix.
	* lisp.h (force_auto_save_soon): Declare regardless of SIGDANGER.
	SIGDANGER might not be in scope so "#ifdef SIGDANGER" is not right,
	and anyway the declaration is harmless even if SIGDANGER is not defined.
	* syssignal.h (SIGIO): Also #undef if (! defined FIONREAD ||
	defined BROKEN_FIONREAD).  systty.h formerly did this, but other
	source files not surprisingly expected syssignal.h to define, or
	not define, SIGIO, and it's cleaner to do it that way, for consistency.
	Include <sys/ioctl.h>, for FIONREAD.
	* systty.h (SIGIO): Do not #undef here; it's now syssignal.h's job.
	This eliminates a problem whereby other files mysteriously had
	to include "syssignal.h" before including "systty.h" if they
	wanted to use "#ifdef SIGIO".

2012-09-07  Eli Zaretskii  <eliz@gnu.org>

	* w32proc.c (sigaction): New function, emulates Posix 'sigaction'.

	* w32.c (sigemptyset): Empty the set.
	(sigsetmask, sigmask, sigblock, sigunblock): Remove unused functions.

	* alloc.c [ENABLE_CHECKING]: Include signal.h, since we need SIGABRT.

2012-09-07  Dmitry Antipov  <dmantipov@yandex.ru>

	* alloc.c (mark_buffer): Revert unsafe marking optimization.
	(mark_object): Likewise for frame objects.

2012-09-07  Paul Eggert  <eggert@cs.ucla.edu>

	* syssignal.h (handle_on_main_thread): Always declare,
	even if FORWARD_SIGNAL_TO_MAIN_THREAD is not defined.
	This ports to platforms without HAVE_PTHREAD.

2012-09-06  Paul Eggert  <eggert@cs.ucla.edu>

	Signal-handler cleanup (Bug#12327).
	Emacs's signal handlers were written in the old 4.2BSD style with
	sigblock and sigmask and so forth, and this led to some
	inefficiencies and confusion.  Rewrite these to use
	pthread_sigmask etc. without copying signal sets around.  Also,
	get rid of the confusing macros 'SIGNAL_THREAD_CHECK' and
	'signal', and instead use functions that do not attempt to take
	over the system name space.  This patch causes Emacs's text
	segment to shrink by 0.7% on my platform, Fedora 17 x86-64.
	* alloc.c, emacsgtkfixed.c, nsfns.m, widget.c, xmenu.c:
	Do not include <signal.h> or "syssignal.h", as these
	modules do not use signals.
	* atimer.c, callproc.c, data.c, dispnew.c, emacs.c, floatfns.c:
	* gtkutil.c, keyboard.c, process.c, sound.c, sysdep.c, term.c, xterm.c:
	Do not include <signal.h>, as "syssignal.h" does that for us now.
	* atimer.c (sigmask_atimers): New function.
	(block_atimers, unblock_atimers): New functions,
	replacing the old macros BLOCK_ATIMERS and UNBLOCK_ATIMERS.
	All uses replaced.
	* conf_post.h [SIGNAL_H_AHB]: Do not include <signal.h>;
	no longer needed here.
	* emacs.c (main): Inspect existing signal handler with sigaction,
	so that there's no need to block and unblock SIGHUP.
	* sysdep.c (struct save_signal): New member 'action', replacing
	old member 'handler'.
	(save_signal_handlers, restore_signal_handlers):
	Use sigaction instead of 'signal' to save and restore.
	(get_set_sighandler, set_sighandler) [!WINDOWSNT]:
	New function.  All users of 'signal' modified to use set_sighandler
	if they're writeonly, and to use sys_signal if they're read+write.
	(emacs_sigaction_init, forwarded_signal): New functions.
	(sys_signal): Remove.  All uses replaced by calls to sigaction
	and emacs_sigaction_init, or by direct calls to 'signal'.
	(sys_sigmask) [!__GNUC__]: Remove; no longer needed.
	(sys_sigblock, sys_sigunblock, sys_sigsetmask): Remove;
	all uses replaced by pthread_sigmask etc. calls.
	* syssignal.h: Include <signal.h>.
	(emacs_sigaction_init, forwarded_signal): New decls.
	(SIGMASKTYPE): Remove.  All uses replaced by its definiens, sigset_t.
	(SIGEMPTYMASK): Remove; all uses replaced by its definiens, empty_mask.
	(sigmask, sys_sigmask): Remove; no longer needed.
	(sigpause): Remove.  All uses replaced by its definiens, sigsuspend.
	(sigblock, sigunblock, sigfree):
	(sigsetmask) [!defined sigsetmask]:
	Remove.  All uses replaced by pthread_sigmask.
	(signal): Remove.  Its remaining uses (with SIG_DFL and SIG_IGN)
	no longer need to be replaced, and its typical old uses
	are now done via emacs_sigaction_init and sigaction.
	(sys_sigblock, sys_sigunblock, sys_sigsetmask): Remove decls.
	(sys_sigdel): Remove; unused.
	(NSIG): Remove a FIXME; the code's fine.  Remove an unnecessary ifdef.

2012-09-06  Eli Zaretskii  <eliz@gnu.org>

	* process.c (CAN_HANDLE_MULTIPLE_CHILDREN): Fix a typo that broke
	SIGCHLD handling on systems that don't have WNOHANG.  (Bug#12327)

2012-09-06  Dmitry Antipov  <dmantipov@yandex.ru>

	Explicitly mark buffer_defaults and buffer_local_symbols.
	* alloc.c (Fgarbage_collect): Mark buffer_defaults and
	mark_local_symbols here.
	(mark_object): If GC_CHECK_MARKED_OBJECTS, simplify checking
	since special buffers aren't marked here any more.
	(allocate_buffer): Chain new buffer with all_buffers here...
	* buffer.c (Fget_buffer_create, Fmake_indirect_buffer): ...and
	not here.
	(Vbuffer_defaults, Vbuffer_local_symbols): Remove.
	(syms_of_buffer): Remove staticpro of the above.
	(init_buffer_once): Set names for buffer_defaults and
	buffer_local_symbols.

2012-09-06  Paul Eggert  <eggert@cs.ucla.edu>

	Use bool for booleans in font-related modules.
	* font.c (font_intern_prop, font_style_to_value)
	(font_style_symbolic, font_parse_xlfd, font_parse_fcname)
	(generate_otf_features, font_check_otf_features, font_check_otf)
	(font_match_p, font_list_entities, font_at):
	* fontset.c (fontset_id_valid_p, reorder_font_vector
	(fontset_find_font, Fset_fontset_font)
	(face_suitable_for_char_p) [0]:
	* ftfont.c (fc_initialized, ftfont_get_open_type_spec)
	(ftfont_open, ftfont_text_extents, ftfont_check_otf):
	(m17n_flt_initialized, ftfont_shape_by_flt):
	* ftxfont.c (ftxfont_draw_bitmap, ftxfont_draw):
	* nsfont.m (nsfont_draw):
	* w32font.c (w32font_draw):
	* w32term.c (x_draw_glyphless_glyph_string_foreground):
	Use bool for booleans.
	* font.h: Adjust to above API changes.
	(struct font, struct font_driver, struct font_driver_list):
	Use bool for booleans.
	(struct font): Remove useless member encoding_type.
	All users removed.
	* fontset.c, xftfont.c: Omit unnecessary static decls.

2012-09-06  Dmitry Antipov  <dmantipov@yandex.ru>

	* alloc.c (mark_object): Revert window marking code
	since it's unsafe for the Fset_window_configuration.

2012-09-05  Paul Eggert  <eggert@cs.ucla.edu>

	Fix race conditions with signal handlers and errno (Bug#12327).
	Be more systematic about preserving errno whenever a signal
	handler returns, even if it's not in the main thread.  Do this by
	renaming signal handlers to distinguish between signal delivery
	and signal handling.  All uses changed.
	* atimer.c (deliver_alarm_signal): Rename from alarm_signal_handler.
	* data.c (deliver_arith_signal): Rename from arith_error.
	* dispnew.c (deliver_window_change_signal): Rename from
	window_change_signal.
	* emacs.c (deliver_error_signal): Rename from fatal_error_signal.
	(deliver_danger_signal) [SIGDANGER]: Rename from memory_warning_signal.
	* keyboard.c (deliver_input_available_signal): Rename from
	input_available_signal.
	(deliver_user_signal): Rename from handle_user_signal.
	(deliver_interrupt_signal): Rename from interrupt_signal.
	* process.c (deliver_pipe_signal): Rename from send_process_trap.
	(deliver_child_signal): Rename from sigchld_handler.
	* atimer.c (handle_alarm_signal):
	* data.c (handle_arith_signal):
	* dispnew.c (handle_window_change_signal):
	* emacs.c (handle_fatal_signal, handle_danger_signal):
	* keyboard.c (handle_input_available_signal):
	* keyboard.c (handle_user_signal, handle_interrupt_signal):
	* process.c (handle_pipe_signal, handle_child_signal):
	New functions, with the actual signal-handling code taken from the
	original respective signal handlers, sans the sporadic attempts to
	preserve errno, since that's now done by handle_on_main_thread.
	* atimer.c (alarm_signal_handler): Remove unnecessary decl.
	* emacs.c, floatfns.c, lisp.h: Remove unused FLOAT_CATCH_SIGKILL cruft.
	* emacs.c (main_thread) [FORWARD_SIGNAL_TO_MAIN_THREAD]:
	Move to sysdep.c.
	(main) [FORWARD_SIGNAL_TO_MAIN_THREAD]:
	Move initialization of main_thread to sysdep.c's init_signals.
	* process.c (waitpid) [!WNOHANG]: #define to wait; that's good enough for
	our usage, and simplifies the mainline code.
	(record_child_status_change): New static function, as a helper
	for handle_child_signal, and with most of the old child handler's
	contents.
	(CAN_HANDLE_MULTIPLE_CHILDREN): New constant.
	(handle_child_signal): Use the above.
	* sysdep.c (main_thread) [FORWARD_SIGNAL_TO_MAIN_THREAD]:
	Moved here from emacs.c.
	(init_signals) [FORWARD_SIGNAL_TO_MAIN_THREAD]: Initialize it;
	code moved here from emacs.c's main function.
	* sysdep.c, syssignal.h (handle_on_main_thread): New function,
	replacing the old SIGNAL_THREAD_CHECK.  All uses changed.
	This lets callers save and restore errno properly.

2012-09-05  Dmitry Antipov  <dmantipov@yandex.ru>

	Remove redundant or unused things here and there.
	* lisp.h (CYCLE_CHECK, CHAR_TABLE_TRANSLATE): Remove.
	* conf_post.h (RE_TRANSLATE): Use char_table_translate.
	* editfns.c (Fcompare_buffer_substrings): Likewise.
	* frame.h (struct terminal, struct font_driver_list):
	Remove redundant declarations.
	* window.h (Qleft, Qright): Likewise.

2012-09-05  Dmitry Antipov  <dmantipov@yandex.ru>

	Do not mark objects from deleted buffers, windows and frames.
	* alloc.c (mark_buffer): Mark just the buffer if it is dead.
	(mark_object): Likewise for windows and frames.

2012-09-05  Dmitry Antipov  <dmantipov@yandex.ru>

	* alloc.c (valid_lisp_object_p): Treat killed buffers,
	buffer_defaults and buffer_local_symbols as valid objects.
	Return special value to denote them.

2012-09-05  Paul Eggert  <eggert@cs.ucla.edu>

	* fileio.c, filelock.c, floatfns.c, fns.c: Use bool for boolean.
	* fileio.c (auto_saving, auto_save_error_occurred, make_temp_name)
	(Fexpand_file_name, barf_or_query_if_file_exists, Fcopy_file)
	(file_name_absolute_p, Fsubstitute_in_file_name):
	(check_executable, check_writable, Ffile_accessible_directory_p)
	(Fset_file_selinux_context, Fdefault_file_modes)
	(Finsert_file_contents, choose_write_coding_system)
	(Fwrite_region, build_annotations, a_write, e_write)
	(Fdo_auto_save):
	* filelock.c (boot_time_initialized, get_boot_time)
	(get_boot_time_1, lock_file_1, within_one_second):
	* floatfns.c (in_float):
	* fns.c (concat, internal_equal, Frequire, base64_encode_1)
	(base64_decode_1, cmpfn_eql, cmpfn_user_defined)
	(sweep_weak_table, sweep_weak_hash_tables, secure_hash):
	* lisp.h (struct Lisp_Hash_Table.cmpfn):
	* window.c (compare_window_configurations):
	Use bool for booleans.
	* fileio.c (auto_saving_dir_umask, auto_saving_mode_bits)
	(Fdefault_file_modes): Now mode_t, not int, for modes.
	(Fdo_auto_save): Set a boolean to 1 rather than using ++.
	(internal_delete_file): Now returns void, not a (boolean) int,
	since nobody was looking at the return value.
	* lisp.h, window.h: Adjust to above API changes.

	* xdisp.c (set_message): Simplify and reindent last change.

2012-09-05  Juanma Barranquero  <lekktu@gmail.com>

	* makefile.w32-in ($(BLD)/sysdep.$(O)): Update dependencies.

2012-09-04  Lars Ingebrigtsen  <larsi@gnus.org>

	* eval.c (call_debugger): Make the function non-static so that we
	can call it from set_message.

	* xdisp.c (set_message): Implement the new variable `debug-on-message'.
	(syms_of_xdisp): Defvar it and `inhibit-debug-on-message'.

2012-09-04  Paul Eggert  <eggert@cs.ucla.edu>

	Give more-useful info on a fatal error (Bug#12328).
	* alloc.c [ENABLE_CHECKING]: Do not include <execinfo.h>.
	(die) [ENABLE_CHECKING]: Call fatal_error_backtrace instead
	of doing the work ourselves.
	* emacs.c (fatal_error_signal): Let fatal_error_backtrace
	do most of the work.
	(fatal_error_backtrace): New function, taken from the guts
	of the old fatal_error_signal, but with a new option to output
	a backtrace.
	(shut_down_emacs) [!DOS_NT]: Use strsignal to give more-useful
	info about the signal than just its number.
	* lisp.h (fatal_error_backtrace, emacs_backtrace): New decls.
	* sysdep.c: Include <execinfo.h>
	(emacs_backtrace): New function, taken partly from the previous
	code of the 'die' function.
	(emacs_abort): Call fatal_error_backtrace rather than abort.

2012-09-04  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lread.c (readevalloop): Call internal-macroexpand-for-load to perform
	eager (load-time) macro-expansion.
	* lisp.mk (lisp): Add macroexp.

2012-09-04  Paul Eggert  <eggert@cs.ucla.edu>

	Simplify redefinition of 'abort' (Bug#12316).
	Do not try to redefine the 'abort' function.  Instead, redo
	the code so that it calls 'emacs_abort' rather than 'abort'.
	This removes the need for the NO_ABORT configure-time macro
	and makes it easier to change the abort code to do a backtrace.
	* .gdbinit: Just stop at emacs_abort, not at w32_abort or abort.
	* emacs.c (abort) [!DOS_NT && !NO_ABORT]:
	Remove; sysdep.c's emacs_abort now takes its place.
	* lisp.h (emacs_abort): New decl.  All calls from Emacs code to
	'abort' changed to use 'emacs_abort'.
	* msdos.c (dos_abort) [defined abort]: Remove; not used.
	(abort) [!defined abort]: Rename to ...
	(emacs_abort): ... new name.
	* sysdep.c (emacs_abort) [!HAVE_NTGUI]: New function, taking
	the place of the old 'abort' in emacs.c.
	* w32.c, w32fns.c (abort): Do not #undef.
	* w32.c (emacs_abort): Rename from w32_abort.

2012-09-04  Eli Zaretskii  <eliz@gnu.org>

	* w32uniscribe.c (uniscribe_shape): Reverse the sign of
	offsets[j].dv, since the y axis of the screen coordinates points
	down, while the y axis of the font definition coordinates points
	up.  This fixes display of Arabic diacritics such as KASRA and
	KASRATAN.  (Bug#11860)

2012-09-04  Paul Eggert  <eggert@cs.ucla.edu>

	Be more systematic about _setjmp vs setjmp.
	* alloc.c (test_setjmp, mark_stack):
	* image.c (PNG_LONGJMP) [PNG_LIBPNG_VER < 10500]:
	(PNG_JMPBUF) [! (PNG_LIBPNG_VER < 10500)]:
	(png_load, my_error_exit, jpeg_load):
	* process.c (send_process_trap, send_process):
	Uniformly prefer _setjmp and _longjmp to setjmp and longjmp.
	The underscored versions are up to 30x faster on some hosts.
	Formerly, the code used setjmp+longjmp sometimes and
	_setjmp+_longjmp at other times, with no particular reason to
	prefer setjmp+longjmp.

2012-09-03  Paul Eggert  <eggert@cs.ucla.edu>

	Fix minor problem found by static checking.
	* buffer.c (Fdelete_all_overlays): Return nil.

2012-09-03  Martin Rudalics  <rudalics@gmx.at>

	* buffer.c (Fdelete_all_overlays): New function.

2012-09-03  Chong Yidong  <cyd@gnu.org>

	* gtkutil.c: Add extern decl for Qxft.

2012-09-02  Paul Eggert  <eggert@cs.ucla.edu>

	* emacs.c, eval.c: Use bool for boolean.
	* emacs.c (initialized, inhibit_window_system, running_asynch_code):
	(malloc_using_checking) [DOUG_LEA_MALLOC]:
	(display_arg) [HAVE_X_WINDOWS || HAVE_NS]:
	(noninteractive, no_site_lisp, fatal_error_in_progress, argmatch)
	(main, decode_env_path, Fdaemon_initialized):
	* eval.c (call_debugger, Finteractive_p, interactive_p):
	(unwind_to_catch, Fsignal, wants_debugger, skip_debugger)
	(maybe_call_debugger, Fbacktrace):
	* process.c (read_process_output, exec_sentinel):
	Use bool for booleans.
	* emacs.c (shut_down_emacs): Omit unused boolean argument NO_X.
	All callers changed.
	* eval.c (interactive_p): Omit always-true boolean argument
	EXCLUDE_SUBRS_P.  All callers changed.
	* dispextern.h, lisp.h: Reflect above API changes.
	* firstfile.c (dummy): Use the address of 'main', whose signature
	won't change, instead of the address of 'initialize', whose
	signature just changed from int to bool.
	* lisp.h (fatal_error_in_progress): New decl of boolean, moved here ...
	* msdos.c (fatal_error_in_progress): ... from here.
	* xdisp.c (redisplaying_p): Now a boolean.  Set it to 1 instead
	of incrementing it.
	(redisplay_internal, unwind_redisplay): Simply clear
	REDISPLAYING_P when unwinding, instead of saving its previous,
	always-false value and then restoring it.

	Clean up some extern decls.
	Mostly, this hoists extern decls out of .c files and into .h files.
	That way, we're more likely to catch errors if the interfaces change.
	* alloc.c [USE_GTK]: Include "gtkutil.h" so that we need not
	declare xg_mark_data.
	* dispextern.h (x_frame_parm_handlers):
	* font.h (Qxft):
	* lisp.h (Qlexical_binding, Qinternal_interpreter_environment)
	(Qextra_light, Qlight, Qsemi_light, Qsemi_bold, Qbold, Qextra_bold)
	(Qultra_bold, Qoblique, Qitalic):
	Move extern decl here from .c file.
	* alloc.c (xg_mark_data) [USE_GTK]:
	* doc.c (Qclosure):
	* eval.c (Qlexical_binding):
	* fns.c (time) [!HAVE_UNISTD_H]:
	* gtkutil.c (Qxft, Qnormal, Qextra_light, Qlight, Qsemi_light)
	(Qsemi_bold, Qbold, Qextra_bold, Qultra_bold, Qoblique, Qitalic):
	* image.c (Vlibrary_cache, QCloaded_from) [HAVE_NTGUI]:
	* lread.c (Qinternal_interpreter_environment):
	* minibuf.c (Qbuffer):
	* process.c (QCfamily, QCfilter):
	* widget.c (free_frame_faces):
	* xfaces.c (free_frame_menubar) [USE_X_TOOLKIT]:
	* xfont.c (x_clear_errors):
	* xterm.c (x_frame_parm_handlers):
	Remove now-redundant extern decls.
	* keyboard.c, keyboard.h (ignore_mouse_drag_p) [USE_GTK || HAVE_NS]:
	* xfaces.c (Qultra_light, Qreverse_oblique, Qreverse_italic):
	Now static.
	* xfaces.c: Remove unnecessary static decls.
	* xterm.c (updating_frame): Remove decl of nonexistent object.

	* Makefile.in (gl-stamp): Don't scan $(SOME_MACHINE_OBJECTS)
	when building globals.h, as the objects that are not built on
	this host are not needed to compile C files on this host.

2012-09-02  Jan Djärv  <jan.h.d@swipnet.se>

	* gtkutil.h: Remove prototype for x_wm_set_size_hint.

	* frame.h: Add missing prototype for x_wm_set_size_hint.

2012-09-02  Paul Eggert  <eggert@cs.ucla.edu>

	* doc.c, editfns.c, insdel.c, intervals.c: Use bool for boolean.
	* doc.c (read_bytecode_char, get_doc_string, reread_doc_file)
	(Fdocumentation, Fdocumentation_property, Fsnarf_documentation)
	(Fsubstitute_command_keys):
	* editfns.c (region_limit, find_field, Fconstrain_to_field)
	(save_excursion_save, save_excursion_restore)
	(disassemble_lisp_time, decode_time_components, emacs_nmemftime)
	(format_time_string, general_insert_function)
	(make_buffer_string, make_buffer_string_both)
	(Fsubst_char_in_region, Ftranslate_region_internal, Fformat):
	* insdel.c (check_markers, gap_left, adjust_markers_for_insert)
	(copy_text, insert_1, insert_1_both, insert_from_string)
	(insert_from_string_before_markers, insert_from_string_1)
	(insert_from_buffer, insert_from_buffer_1, replace_range)
	(replace_range_2, del_range_1, del_range_byte, del_range_both)
	(del_range_2, modify_region):
	* intervals.c (intervals_equal, balance_possible_root_interval)
	(adjust_intervals_for_insertion, merge_properties_sticky)
	(graft_intervals_into_buffer, lookup_char_property)
	(adjust_for_invis_intang, set_point_both)
	(get_property_and_range, compare_string_intervals)
	(set_intervals_multibyte_1, set_intervals_multibyte):
	* keyboard.c (decode_timer):
	Use bool for boolean.
	* intervals.h, lisp.h, systime.h: Reflect above API changes.
	* editfns.c (struct info): Use 1-bit unsigned bitfields for booleans.

2012-09-02  Chong Yidong  <cyd@gnu.org>

	* keymap.c (push_key_description): Print M-TAB as C-M-i
	(Bug#11758).

2012-09-02  Juanma Barranquero  <lekktu@gmail.com>

	* makefile.w32-in (CCL_H, W32FONT_H): New macros.
	(ATIMER_H, FONT_H, $(BLD)/alloc.$(O), $(BLD)/callproc.$(O))
	($(BLD)/editfns.$(O), $(BLD)/ccl.$(O), $(BLD)/chartab.$(O))
	($(BLD)/coding.$(O), $(BLD)/sysdep.$(O), $(BLD)/fontset.$(O))
	($(BLD)/sysdep.$(O), $(BLD)/w32fns.$(O), $(BLD)/keyboard.$(O))
	($(BLD)/w32term.$(O), $(BLD)/w32menu.$(O), $(BLD)/process.$(O))
	($(BLD)/w32font.$(O), $(BLD)/w32uniscribe.$(O)): Update dependencies.

2012-09-01  Eli Zaretskii  <eliz@gnu.org>

	* w32uniscribe.c (uniscribe_shape): Handle correctly the case of
	more than one grapheme cluster passed to the shaper: compute the
	offset adjustment values separately for each cluster.  (Bug#11860)

	* image.c: Restore mistakenly removed inclusion of w32.h.  Without
	it, GCC doesn't see prototypes of w32_delayed_load, and complains
